/* Password.c generated by valac 0.45.3, the Vala compiler
 * generated from Password.vala, do not modify */

/*This file is part of FeedReader.*/
/**/
/*FeedReader is free software: you can redistribute it and/or modify*/
/*it under the terms of the GNU General Public License as published by*/
/*the Free Software Foundation, either version 3 of the License, or*/
/*(at your option) any later version.*/
/**/
/*FeedReader is distributed in the hope that it will be useful,*/
/*but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*GNU General Public License for more details.*/
/**/
/*You should have received a copy of the GNU General Public License*/
/*along with FeedReader.  If not, see <http://www.gnu.org/licenses/>.*/

#include <glib-object.h>
#include <libsecret/secret.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>

#define FEED_READER_TYPE_PASSWORD (feed_reader_password_get_type ())
#define FEED_READER_PASSWORD(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FEED_READER_TYPE_PASSWORD, FeedReaderPassword))
#define FEED_READER_PASSWORD_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FEED_READER_TYPE_PASSWORD, FeedReaderPasswordClass))
#define FEED_READER_IS_PASSWORD(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FEED_READER_TYPE_PASSWORD))
#define FEED_READER_IS_PASSWORD_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FEED_READER_TYPE_PASSWORD))
#define FEED_READER_PASSWORD_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FEED_READER_TYPE_PASSWORD, FeedReaderPasswordClass))

typedef struct _FeedReaderPassword FeedReaderPassword;
typedef struct _FeedReaderPasswordClass FeedReaderPasswordClass;
typedef struct _FeedReaderPasswordPrivate FeedReaderPasswordPrivate;
typedef GHashTable* (*FeedReaderPasswordGetAttributesFunc) (gpointer user_data);
enum  {
	FEED_READER_PASSWORD_0_PROPERTY,
	FEED_READER_PASSWORD_NUM_PROPERTIES
};
static GParamSpec* feed_reader_password_properties[FEED_READER_PASSWORD_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _secret_schema_unref0(var) ((var == NULL) ? NULL : (var = (secret_schema_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _secret_value_unref0(var) ((var == NULL) ? NULL : (var = (secret_value_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _FeedReaderPassword {
	GObject parent_instance;
	FeedReaderPasswordPrivate * priv;
};

struct _FeedReaderPasswordClass {
	GObjectClass parent_class;
};

struct _FeedReaderPasswordPrivate {
	SecretCollection* m_secrets;
	SecretSchema* m_schema;
	FeedReaderPasswordGetAttributesFunc m_get_attributes;
	gpointer m_get_attributes_target;
	GDestroyNotify m_get_attributes_target_destroy_notify;
	gchar* m_label;
};

static gint FeedReaderPassword_private_offset;
static gpointer feed_reader_password_parent_class = NULL;

GType feed_reader_password_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FeedReaderPassword, g_object_unref)
FeedReaderPassword* feed_reader_password_new (SecretCollection* secrets,
                                              SecretSchema* schema,
                                              const gchar* label,
                                              FeedReaderPasswordGetAttributesFunc get_attributes,
                                              gpointer get_attributes_target,
                                              GDestroyNotify get_attributes_target_destroy_notify);
FeedReaderPassword* feed_reader_password_construct (GType object_type,
                                                    SecretCollection* secrets,
                                                    SecretSchema* schema,
                                                    const gchar* label,
                                                    FeedReaderPasswordGetAttributesFunc get_attributes,
                                                    gpointer get_attributes_target,
                                                    GDestroyNotify get_attributes_target_destroy_notify);
static void feed_reader_password_unlock_keyring (FeedReaderPassword* self,
                                          GCancellable* cancellable,
                                          GError** error);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
gchar* feed_reader_password_get_password (FeedReaderPassword* self,
                                          GCancellable* cancellable);
void feed_reader_logger_error (const gchar* message);
void feed_reader_password_set_password (FeedReaderPassword* self,
                                        const gchar* password,
                                        GCancellable* cancellable);
gboolean feed_reader_password_delete_password (FeedReaderPassword* self,
                                               GCancellable* cancellable);
static void feed_reader_password_finalize (GObject * obj);

static inline gpointer
feed_reader_password_get_instance_private (FeedReaderPassword* self)
{
	return G_STRUCT_MEMBER_P (self, FeedReaderPassword_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 27 "../src/Password.vala"
	return self ? g_object_ref (self) : NULL;
#line 112 "Password.c"
}

static gpointer
_secret_schema_ref0 (gpointer self)
{
#line 28 "../src/Password.vala"
	return self ? secret_schema_ref (self) : NULL;
#line 120 "Password.c"
}

FeedReaderPassword*
feed_reader_password_construct (GType object_type,
                                SecretCollection* secrets,
                                SecretSchema* schema,
                                const gchar* label,
                                FeedReaderPasswordGetAttributesFunc get_attributes,
                                gpointer get_attributes_target,
                                GDestroyNotify get_attributes_target_destroy_notify)
{
	FeedReaderPassword * self = NULL;
	SecretCollection* _tmp0_;
	SecretSchema* _tmp1_;
	gchar* _tmp2_;
	FeedReaderPasswordGetAttributesFunc _tmp3_;
	gpointer _tmp3__target;
	GDestroyNotify _tmp3__target_destroy_notify;
#line 25 "../src/Password.vala"
	g_return_val_if_fail (secrets != NULL, NULL);
#line 25 "../src/Password.vala"
	g_return_val_if_fail (schema != NULL, NULL);
#line 25 "../src/Password.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 25 "../src/Password.vala"
	self = (FeedReaderPassword*) g_object_new (object_type, NULL);
#line 27 "../src/Password.vala"
	_tmp0_ = _g_object_ref0 (secrets);
#line 27 "../src/Password.vala"
	_g_object_unref0 (self->priv->m_secrets);
#line 27 "../src/Password.vala"
	self->priv->m_secrets = _tmp0_;
#line 28 "../src/Password.vala"
	_tmp1_ = _secret_schema_ref0 (schema);
#line 28 "../src/Password.vala"
	_secret_schema_unref0 (self->priv->m_schema);
#line 28 "../src/Password.vala"
	self->priv->m_schema = _tmp1_;
#line 29 "../src/Password.vala"
	_tmp2_ = g_strdup (label);
#line 29 "../src/Password.vala"
	_g_free0 (self->priv->m_label);
#line 29 "../src/Password.vala"
	self->priv->m_label = _tmp2_;
#line 30 "../src/Password.vala"
	_tmp3_ = get_attributes;
#line 30 "../src/Password.vala"
	_tmp3__target = get_attributes_target;
#line 30 "../src/Password.vala"
	_tmp3__target_destroy_notify = get_attributes_target_destroy_notify;
#line 30 "../src/Password.vala"
	get_attributes = NULL;
#line 30 "../src/Password.vala"
	get_attributes_target = NULL;
#line 30 "../src/Password.vala"
	get_attributes_target_destroy_notify = NULL;
#line 30 "../src/Password.vala"
	(self->priv->m_get_attributes_target_destroy_notify == NULL) ? NULL : (self->priv->m_get_attributes_target_destroy_notify (self->priv->m_get_attributes_target), NULL);
#line 30 "../src/Password.vala"
	self->priv->m_get_attributes = NULL;
#line 30 "../src/Password.vala"
	self->priv->m_get_attributes_target = NULL;
#line 30 "../src/Password.vala"
	self->priv->m_get_attributes_target_destroy_notify = NULL;
#line 30 "../src/Password.vala"
	self->priv->m_get_attributes = _tmp3_;
#line 30 "../src/Password.vala"
	self->priv->m_get_attributes_target = _tmp3__target;
#line 30 "../src/Password.vala"
	self->priv->m_get_attributes_target_destroy_notify = _tmp3__target_destroy_notify;
#line 25 "../src/Password.vala"
	(get_attributes_target_destroy_notify == NULL) ? NULL : (get_attributes_target_destroy_notify (get_attributes_target), NULL);
#line 25 "../src/Password.vala"
	get_attributes = NULL;
#line 25 "../src/Password.vala"
	get_attributes_target = NULL;
#line 25 "../src/Password.vala"
	get_attributes_target_destroy_notify = NULL;
#line 25 "../src/Password.vala"
	return self;
#line 201 "Password.c"
}

FeedReaderPassword*
feed_reader_password_new (SecretCollection* secrets,
                          SecretSchema* schema,
                          const gchar* label,
                          FeedReaderPasswordGetAttributesFunc get_attributes,
                          gpointer get_attributes_target,
                          GDestroyNotify get_attributes_target_destroy_notify)
{
#line 25 "../src/Password.vala"
	return feed_reader_password_construct (FEED_READER_TYPE_PASSWORD, secrets, schema, label, get_attributes, get_attributes_target, get_attributes_target_destroy_notify);
#line 214 "Password.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 43 "../src/Password.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 222 "Password.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 43 "../src/Password.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 230 "Password.c"
}

static void
feed_reader_password_unlock_keyring (FeedReaderPassword* self,
                                     GCancellable* cancellable,
                                     GError** error)
{
	SecretCollection* _tmp0_;
	GList* collections_to_unlock = NULL;
	SecretCollection* _tmp1_;
	SecretCollection* _tmp2_;
	SecretService* service = NULL;
	SecretCollection* _tmp3_;
	SecretService* _tmp4_;
	SecretService* _tmp5_;
	SecretService* _tmp6_;
	GList* _tmp7_;
	GError* _inner_error0_ = NULL;
#line 33 "../src/Password.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Password.vala"
	_tmp0_ = self->priv->m_secrets;
#line 35 "../src/Password.vala"
	if (!secret_collection_get_locked (_tmp0_)) {
#line 37 "../src/Password.vala"
		return;
#line 257 "Password.c"
	}
#line 40 "../src/Password.vala"
	collections_to_unlock = NULL;
#line 41 "../src/Password.vala"
	_tmp1_ = self->priv->m_secrets;
#line 41 "../src/Password.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 41 "../src/Password.vala"
	collections_to_unlock = g_list_append (collections_to_unlock, _tmp2_);
#line 42 "../src/Password.vala"
	_tmp3_ = self->priv->m_secrets;
#line 42 "../src/Password.vala"
	_tmp4_ = secret_collection_get_service (_tmp3_);
#line 42 "../src/Password.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 42 "../src/Password.vala"
	service = _tmp5_;
#line 43 "../src/Password.vala"
	_tmp6_ = service;
#line 43 "../src/Password.vala"
	_tmp7_ = collections_to_unlock;
#line 43 "../src/Password.vala"
	secret_service_unlock_sync (_tmp6_, _tmp7_, cancellable, NULL, &_inner_error0_);
#line 43 "../src/Password.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 43 "../src/Password.vala"
		g_propagate_error (error, _inner_error0_);
#line 43 "../src/Password.vala"
		_g_object_unref0 (service);
#line 43 "../src/Password.vala"
		(collections_to_unlock == NULL) ? NULL : (collections_to_unlock = (_g_list_free__g_object_unref0_ (collections_to_unlock), NULL));
#line 43 "../src/Password.vala"
		return;
#line 291 "Password.c"
	}
#line 33 "../src/Password.vala"
	_g_object_unref0 (service);
#line 33 "../src/Password.vala"
	(collections_to_unlock == NULL) ? NULL : (collections_to_unlock = (_g_list_free__g_object_unref0_ (collections_to_unlock), NULL));
#line 297 "Password.c"
}

gchar*
feed_reader_password_get_password (FeedReaderPassword* self,
                                   GCancellable* cancellable)
{
	gchar* result = NULL;
	GHashTable* attributes = NULL;
	FeedReaderPasswordGetAttributesFunc _tmp0_;
	gpointer _tmp0__target;
	GHashTable* _tmp1_;
	gchar* _tmp30_;
	GError* _inner_error0_ = NULL;
#line 46 "../src/Password.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 48 "../src/Password.vala"
	_tmp0_ = self->priv->m_get_attributes;
#line 48 "../src/Password.vala"
	_tmp0__target = self->priv->m_get_attributes_target;
#line 48 "../src/Password.vala"
	_tmp1_ = _tmp0_ (_tmp0__target);
#line 48 "../src/Password.vala"
	attributes = _tmp1_;
#line 321 "Password.c"
	{
		gboolean _tmp2_ = FALSE;
		GList* secrets = NULL;
		SecretCollection* _tmp4_;
		SecretSchema* _tmp5_;
		GHashTable* _tmp6_;
		GList* _tmp7_;
		gboolean _tmp8_ = FALSE;
		GList* _tmp10_;
#line 51 "../src/Password.vala"
		feed_reader_password_unlock_keyring (self, cancellable, &_inner_error0_);
#line 51 "../src/Password.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 335 "Password.c"
			goto __catch10_g_error;
		}
#line 53 "../src/Password.vala"
		if (cancellable != NULL) {
#line 53 "../src/Password.vala"
			_tmp2_ = g_cancellable_is_cancelled (cancellable);
#line 342 "Password.c"
		} else {
#line 53 "../src/Password.vala"
			_tmp2_ = FALSE;
#line 346 "Password.c"
		}
#line 53 "../src/Password.vala"
		if (_tmp2_) {
#line 350 "Password.c"
			gchar* _tmp3_;
#line 55 "../src/Password.vala"
			_tmp3_ = g_strdup ("");
#line 55 "../src/Password.vala"
			result = _tmp3_;
#line 55 "../src/Password.vala"
			_g_hash_table_unref0 (attributes);
#line 55 "../src/Password.vala"
			return result;
#line 360 "Password.c"
		}
#line 58 "../src/Password.vala"
		_tmp4_ = self->priv->m_secrets;
#line 58 "../src/Password.vala"
		_tmp5_ = self->priv->m_schema;
#line 58 "../src/Password.vala"
		_tmp6_ = attributes;
#line 58 "../src/Password.vala"
		_tmp7_ = secret_collection_search_sync (_tmp4_, _tmp5_, _tmp6_, SECRET_SEARCH_NONE, cancellable, &_inner_error0_);
#line 58 "../src/Password.vala"
		secrets = _tmp7_;
#line 58 "../src/Password.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 374 "Password.c"
			goto __catch10_g_error;
		}
#line 60 "../src/Password.vala"
		if (cancellable != NULL) {
#line 60 "../src/Password.vala"
			_tmp8_ = g_cancellable_is_cancelled (cancellable);
#line 381 "Password.c"
		} else {
#line 60 "../src/Password.vala"
			_tmp8_ = FALSE;
#line 385 "Password.c"
		}
#line 60 "../src/Password.vala"
		if (_tmp8_) {
#line 389 "Password.c"
			gchar* _tmp9_;
#line 62 "../src/Password.vala"
			_tmp9_ = g_strdup ("");
#line 62 "../src/Password.vala"
			result = _tmp9_;
#line 62 "../src/Password.vala"
			(secrets == NULL) ? NULL : (secrets = (_g_list_free__g_object_unref0_ (secrets), NULL));
#line 62 "../src/Password.vala"
			_g_hash_table_unref0 (attributes);
#line 62 "../src/Password.vala"
			return result;
#line 401 "Password.c"
		}
#line 65 "../src/Password.vala"
		_tmp10_ = secrets;
#line 65 "../src/Password.vala"
		if (g_list_length (_tmp10_) != ((guint) 0)) {
#line 407 "Password.c"
			SecretItem* item = NULL;
			GList* _tmp11_;
			gconstpointer _tmp12_;
			SecretItem* _tmp13_;
			SecretItem* _tmp14_;
			gboolean _tmp15_ = FALSE;
			SecretValue* secret = NULL;
			SecretItem* _tmp17_;
			SecretValue* _tmp18_;
			SecretValue* _tmp19_;
			gchar* password = NULL;
			SecretValue* _tmp21_;
			const gchar* _tmp22_;
			gchar* _tmp23_;
			const gchar* _tmp24_;
#line 67 "../src/Password.vala"
			_tmp11_ = secrets;
#line 67 "../src/Password.vala"
			_tmp12_ = _tmp11_->data;
#line 67 "../src/Password.vala"
			_tmp13_ = _g_object_ref0 ((SecretItem*) _tmp12_);
#line 67 "../src/Password.vala"
			item = _tmp13_;
#line 68 "../src/Password.vala"
			_tmp14_ = item;
#line 68 "../src/Password.vala"
			secret_item_load_secret_sync (_tmp14_, cancellable, &_inner_error0_);
#line 68 "../src/Password.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 68 "../src/Password.vala"
				_g_object_unref0 (item);
#line 68 "../src/Password.vala"
				(secrets == NULL) ? NULL : (secrets = (_g_list_free__g_object_unref0_ (secrets), NULL));
#line 441 "Password.c"
				goto __catch10_g_error;
			}
#line 69 "../src/Password.vala"
			if (cancellable != NULL) {
#line 69 "../src/Password.vala"
				_tmp15_ = g_cancellable_is_cancelled (cancellable);
#line 448 "Password.c"
			} else {
#line 69 "../src/Password.vala"
				_tmp15_ = FALSE;
#line 452 "Password.c"
			}
#line 69 "../src/Password.vala"
			if (_tmp15_) {
#line 456 "Password.c"
				gchar* _tmp16_;
#line 71 "../src/Password.vala"
				_tmp16_ = g_strdup ("");
#line 71 "../src/Password.vala"
				result = _tmp16_;
#line 71 "../src/Password.vala"
				_g_object_unref0 (item);
#line 71 "../src/Password.vala"
				(secrets == NULL) ? NULL : (secrets = (_g_list_free__g_object_unref0_ (secrets), NULL));
#line 71 "../src/Password.vala"
				_g_hash_table_unref0 (attributes);
#line 71 "../src/Password.vala"
				return result;
#line 470 "Password.c"
			}
#line 74 "../src/Password.vala"
			_tmp17_ = item;
#line 74 "../src/Password.vala"
			_tmp18_ = secret_item_get_secret (_tmp17_);
#line 74 "../src/Password.vala"
			secret = _tmp18_;
#line 75 "../src/Password.vala"
			_tmp19_ = secret;
#line 75 "../src/Password.vala"
			if (_tmp19_ == NULL) {
#line 482 "Password.c"
				gchar* _tmp20_;
#line 77 "../src/Password.vala"
				feed_reader_logger_error ("Password.get_password: Got NULL secret");
#line 78 "../src/Password.vala"
				_tmp20_ = g_strdup ("");
#line 78 "../src/Password.vala"
				result = _tmp20_;
#line 78 "../src/Password.vala"
				_secret_value_unref0 (secret);
#line 78 "../src/Password.vala"
				_g_object_unref0 (item);
#line 78 "../src/Password.vala"
				(secrets == NULL) ? NULL : (secrets = (_g_list_free__g_object_unref0_ (secrets), NULL));
#line 78 "../src/Password.vala"
				_g_hash_table_unref0 (attributes);
#line 78 "../src/Password.vala"
				return result;
#line 500 "Password.c"
			}
#line 80 "../src/Password.vala"
			_tmp21_ = secret;
#line 80 "../src/Password.vala"
			_tmp22_ = secret_value_get_text (_tmp21_);
#line 80 "../src/Password.vala"
			_tmp23_ = g_strdup (_tmp22_);
#line 80 "../src/Password.vala"
			password = _tmp23_;
#line 81 "../src/Password.vala"
			_tmp24_ = password;
#line 81 "../src/Password.vala"
			if (_tmp24_ == NULL) {
#line 514 "Password.c"
				gchar* _tmp25_;
#line 83 "../src/Password.vala"
				feed_reader_logger_error ("Password.get_password: Got NULL password in non-NULL secret (secret is" \
"n't a text?)");
#line 84 "../src/Password.vala"
				_tmp25_ = g_strdup ("");
#line 84 "../src/Password.vala"
				result = _tmp25_;
#line 84 "../src/Password.vala"
				_g_free0 (password);
#line 84 "../src/Password.vala"
				_secret_value_unref0 (secret);
#line 84 "../src/Password.vala"
				_g_object_unref0 (item);
#line 84 "../src/Password.vala"
				(secrets == NULL) ? NULL : (secrets = (_g_list_free__g_object_unref0_ (secrets), NULL));
#line 84 "../src/Password.vala"
				_g_hash_table_unref0 (attributes);
#line 84 "../src/Password.vala"
				return result;
#line 534 "Password.c"
			}
#line 86 "../src/Password.vala"
			result = password;
#line 86 "../src/Password.vala"
			_secret_value_unref0 (secret);
#line 86 "../src/Password.vala"
			_g_object_unref0 (item);
#line 86 "../src/Password.vala"
			(secrets == NULL) ? NULL : (secrets = (_g_list_free__g_object_unref0_ (secrets), NULL));
#line 86 "../src/Password.vala"
			_g_hash_table_unref0 (attributes);
#line 86 "../src/Password.vala"
			return result;
#line 548 "Password.c"
		}
#line 49 "../src/Password.vala"
		(secrets == NULL) ? NULL : (secrets = (_g_list_free__g_object_unref0_ (secrets), NULL));
#line 552 "Password.c"
	}
	goto __finally10;
	__catch10_g_error:
	{
		GError* e = NULL;
		GError* _tmp26_;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
#line 49 "../src/Password.vala"
		e = _inner_error0_;
#line 49 "../src/Password.vala"
		_inner_error0_ = NULL;
#line 91 "../src/Password.vala"
		_tmp26_ = e;
#line 91 "../src/Password.vala"
		_tmp27_ = _tmp26_->message;
#line 91 "../src/Password.vala"
		_tmp28_ = g_strconcat ("Password.get_password: ", _tmp27_, NULL);
#line 91 "../src/Password.vala"
		_tmp29_ = _tmp28_;
#line 91 "../src/Password.vala"
		feed_reader_logger_error (_tmp29_);
#line 91 "../src/Password.vala"
		_g_free0 (_tmp29_);
#line 49 "../src/Password.vala"
		_g_error_free0 (e);
#line 580 "Password.c"
	}
	__finally10:
#line 49 "../src/Password.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 49 "../src/Password.vala"
		_g_hash_table_unref0 (attributes);
#line 49 "../src/Password.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 49 "../src/Password.vala"
		g_clear_error (&_inner_error0_);
#line 49 "../src/Password.vala"
		return NULL;
#line 593 "Password.c"
	}
#line 93 "../src/Password.vala"
	_tmp30_ = g_strdup ("");
#line 93 "../src/Password.vala"
	result = _tmp30_;
#line 93 "../src/Password.vala"
	_g_hash_table_unref0 (attributes);
#line 93 "../src/Password.vala"
	return result;
#line 603 "Password.c"
}

void
feed_reader_password_set_password (FeedReaderPassword* self,
                                   const gchar* password,
                                   GCancellable* cancellable)
{
	GHashTable* attributes = NULL;
	FeedReaderPasswordGetAttributesFunc _tmp0_;
	gpointer _tmp0__target;
	GHashTable* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 96 "../src/Password.vala"
	g_return_if_fail (self != NULL);
#line 96 "../src/Password.vala"
	g_return_if_fail (password != NULL);
#line 98 "../src/Password.vala"
	_tmp0_ = self->priv->m_get_attributes;
#line 98 "../src/Password.vala"
	_tmp0__target = self->priv->m_get_attributes_target;
#line 98 "../src/Password.vala"
	_tmp1_ = _tmp0_ (_tmp0__target);
#line 98 "../src/Password.vala"
	attributes = _tmp1_;
#line 628 "Password.c"
	{
		gboolean _tmp2_ = FALSE;
		SecretValue* value = NULL;
		gint _tmp3_;
		gint _tmp4_;
		SecretValue* _tmp5_;
		SecretCollection* _tmp6_;
		SecretSchema* _tmp7_;
		GHashTable* _tmp8_;
		const gchar* _tmp9_;
		SecretValue* _tmp10_;
		SecretItem* _tmp11_;
		SecretItem* _tmp12_;
#line 101 "../src/Password.vala"
		feed_reader_password_unlock_keyring (self, cancellable, &_inner_error0_);
#line 101 "../src/Password.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 646 "Password.c"
			goto __catch11_g_error;
		}
#line 103 "../src/Password.vala"
		if (cancellable != NULL) {
#line 103 "../src/Password.vala"
			_tmp2_ = g_cancellable_is_cancelled (cancellable);
#line 653 "Password.c"
		} else {
#line 103 "../src/Password.vala"
			_tmp2_ = FALSE;
#line 657 "Password.c"
		}
#line 103 "../src/Password.vala"
		if (_tmp2_) {
#line 105 "../src/Password.vala"
			_g_hash_table_unref0 (attributes);
#line 105 "../src/Password.vala"
			return;
#line 665 "Password.c"
		}
#line 108 "../src/Password.vala"
		_tmp3_ = strlen (password);
#line 108 "../src/Password.vala"
		_tmp4_ = _tmp3_;
#line 108 "../src/Password.vala"
		_tmp5_ = secret_value_new (password, (gssize) _tmp4_, "text/plain");
#line 108 "../src/Password.vala"
		value = _tmp5_;
#line 109 "../src/Password.vala"
		_tmp6_ = self->priv->m_secrets;
#line 109 "../src/Password.vala"
		_tmp7_ = self->priv->m_schema;
#line 109 "../src/Password.vala"
		_tmp8_ = attributes;
#line 109 "../src/Password.vala"
		_tmp9_ = self->priv->m_label;
#line 109 "../src/Password.vala"
		_tmp10_ = value;
#line 109 "../src/Password.vala"
		_tmp11_ = secret_item_create_sync (_tmp6_, _tmp7_, _tmp8_, _tmp9_, _tmp10_, SECRET_ITEM_CREATE_REPLACE, cancellable, &_inner_error0_);
#line 109 "../src/Password.vala"
		_tmp12_ = _tmp11_;
#line 109 "../src/Password.vala"
		_g_object_unref0 (_tmp12_);
#line 109 "../src/Password.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 109 "../src/Password.vala"
			_secret_value_unref0 (value);
#line 695 "Password.c"
			goto __catch11_g_error;
		}
#line 99 "../src/Password.vala"
		_secret_value_unref0 (value);
#line 700 "Password.c"
	}
	goto __finally11;
	__catch11_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 99 "../src/Password.vala"
		e = _inner_error0_;
#line 99 "../src/Password.vala"
		_inner_error0_ = NULL;
#line 113 "../src/Password.vala"
		_tmp13_ = e;
#line 113 "../src/Password.vala"
		_tmp14_ = _tmp13_->message;
#line 113 "../src/Password.vala"
		_tmp15_ = g_strconcat ("Password.setPassword: ", _tmp14_, NULL);
#line 113 "../src/Password.vala"
		_tmp16_ = _tmp15_;
#line 113 "../src/Password.vala"
		feed_reader_logger_error (_tmp16_);
#line 113 "../src/Password.vala"
		_g_free0 (_tmp16_);
#line 99 "../src/Password.vala"
		_g_error_free0 (e);
#line 728 "Password.c"
	}
	__finally11:
#line 99 "../src/Password.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 99 "../src/Password.vala"
		_g_hash_table_unref0 (attributes);
#line 99 "../src/Password.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 99 "../src/Password.vala"
		g_clear_error (&_inner_error0_);
#line 99 "../src/Password.vala"
		return;
#line 741 "Password.c"
	}
#line 96 "../src/Password.vala"
	_g_hash_table_unref0 (attributes);
#line 745 "Password.c"
}

gboolean
feed_reader_password_delete_password (FeedReaderPassword* self,
                                      GCancellable* cancellable)
{
	gboolean result = FALSE;
	GHashTable* attributes = NULL;
	FeedReaderPasswordGetAttributesFunc _tmp0_;
	gpointer _tmp0__target;
	GHashTable* _tmp1_;
	gboolean _tmp17_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 117 "../src/Password.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 119 "../src/Password.vala"
	_tmp0_ = self->priv->m_get_attributes;
#line 119 "../src/Password.vala"
	_tmp0__target = self->priv->m_get_attributes_target;
#line 119 "../src/Password.vala"
	_tmp1_ = _tmp0_ (_tmp0__target);
#line 119 "../src/Password.vala"
	attributes = _tmp1_;
#line 769 "Password.c"
	{
		gboolean _tmp2_ = FALSE;
		GList* secrets = NULL;
		SecretCollection* _tmp3_;
		SecretSchema* _tmp4_;
		GHashTable* _tmp5_;
		GList* _tmp6_;
		gboolean _tmp7_ = FALSE;
		GList* _tmp8_;
#line 122 "../src/Password.vala"
		feed_reader_password_unlock_keyring (self, cancellable, &_inner_error0_);
#line 122 "../src/Password.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 783 "Password.c"
			goto __catch12_g_error;
		}
#line 124 "../src/Password.vala"
		if (cancellable != NULL) {
#line 124 "../src/Password.vala"
			_tmp2_ = g_cancellable_is_cancelled (cancellable);
#line 790 "Password.c"
		} else {
#line 124 "../src/Password.vala"
			_tmp2_ = FALSE;
#line 794 "Password.c"
		}
#line 124 "../src/Password.vala"
		if (_tmp2_) {
#line 126 "../src/Password.vala"
			result = FALSE;
#line 126 "../src/Password.vala"
			_g_hash_table_unref0 (attributes);
#line 126 "../src/Password.vala"
			return result;
#line 804 "Password.c"
		}
#line 129 "../src/Password.vala"
		_tmp3_ = self->priv->m_secrets;
#line 129 "../src/Password.vala"
		_tmp4_ = self->priv->m_schema;
#line 129 "../src/Password.vala"
		_tmp5_ = attributes;
#line 129 "../src/Password.vala"
		_tmp6_ = secret_collection_search_sync (_tmp3_, _tmp4_, _tmp5_, SECRET_SEARCH_NONE, cancellable, &_inner_error0_);
#line 129 "../src/Password.vala"
		secrets = _tmp6_;
#line 129 "../src/Password.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 818 "Password.c"
			goto __catch12_g_error;
		}
#line 131 "../src/Password.vala"
		if (cancellable != NULL) {
#line 131 "../src/Password.vala"
			_tmp7_ = g_cancellable_is_cancelled (cancellable);
#line 825 "Password.c"
		} else {
#line 131 "../src/Password.vala"
			_tmp7_ = FALSE;
#line 829 "Password.c"
		}
#line 131 "../src/Password.vala"
		if (_tmp7_) {
#line 133 "../src/Password.vala"
			result = FALSE;
#line 133 "../src/Password.vala"
			(secrets == NULL) ? NULL : (secrets = (_g_list_free__g_object_unref0_ (secrets), NULL));
#line 133 "../src/Password.vala"
			_g_hash_table_unref0 (attributes);
#line 133 "../src/Password.vala"
			return result;
#line 841 "Password.c"
		}
#line 136 "../src/Password.vala"
		_tmp8_ = secrets;
#line 136 "../src/Password.vala"
		if (g_list_length (_tmp8_) != ((guint) 0)) {
#line 847 "Password.c"
			SecretItem* item = NULL;
			GList* _tmp9_;
			gconstpointer _tmp10_;
			SecretItem* _tmp11_;
			SecretItem* _tmp12_;
#line 138 "../src/Password.vala"
			_tmp9_ = secrets;
#line 138 "../src/Password.vala"
			_tmp10_ = _tmp9_->data;
#line 138 "../src/Password.vala"
			_tmp11_ = _g_object_ref0 ((SecretItem*) _tmp10_);
#line 138 "../src/Password.vala"
			item = _tmp11_;
#line 139 "../src/Password.vala"
			_tmp12_ = item;
#line 139 "../src/Password.vala"
			secret_item_delete_sync (_tmp12_, cancellable, &_inner_error0_);
#line 139 "../src/Password.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 139 "../src/Password.vala"
				_g_object_unref0 (item);
#line 139 "../src/Password.vala"
				(secrets == NULL) ? NULL : (secrets = (_g_list_free__g_object_unref0_ (secrets), NULL));
#line 871 "Password.c"
				goto __catch12_g_error;
			}
#line 140 "../src/Password.vala"
			result = TRUE;
#line 140 "../src/Password.vala"
			_g_object_unref0 (item);
#line 140 "../src/Password.vala"
			(secrets == NULL) ? NULL : (secrets = (_g_list_free__g_object_unref0_ (secrets), NULL));
#line 140 "../src/Password.vala"
			_g_hash_table_unref0 (attributes);
#line 140 "../src/Password.vala"
			return result;
#line 884 "Password.c"
		}
#line 142 "../src/Password.vala"
		result = FALSE;
#line 142 "../src/Password.vala"
		(secrets == NULL) ? NULL : (secrets = (_g_list_free__g_object_unref0_ (secrets), NULL));
#line 142 "../src/Password.vala"
		_g_hash_table_unref0 (attributes);
#line 142 "../src/Password.vala"
		return result;
#line 894 "Password.c"
	}
	goto __finally12;
	__catch12_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 120 "../src/Password.vala"
		e = _inner_error0_;
#line 120 "../src/Password.vala"
		_inner_error0_ = NULL;
#line 146 "../src/Password.vala"
		_tmp13_ = e;
#line 146 "../src/Password.vala"
		_tmp14_ = _tmp13_->message;
#line 146 "../src/Password.vala"
		_tmp15_ = g_strconcat ("Password.delete_password: ", _tmp14_, NULL);
#line 146 "../src/Password.vala"
		_tmp16_ = _tmp15_;
#line 146 "../src/Password.vala"
		feed_reader_logger_error (_tmp16_);
#line 146 "../src/Password.vala"
		_g_free0 (_tmp16_);
#line 147 "../src/Password.vala"
		result = FALSE;
#line 147 "../src/Password.vala"
		_g_error_free0 (e);
#line 147 "../src/Password.vala"
		_g_hash_table_unref0 (attributes);
#line 147 "../src/Password.vala"
		return result;
#line 928 "Password.c"
	}
	__finally12:
#line 120 "../src/Password.vala"
	_g_hash_table_unref0 (attributes);
#line 120 "../src/Password.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 120 "../src/Password.vala"
	g_clear_error (&_inner_error0_);
#line 120 "../src/Password.vala"
	return _tmp17_;
#line 939 "Password.c"
}

static void
feed_reader_password_class_init (FeedReaderPasswordClass * klass,
                                 gpointer klass_data)
{
#line 16 "../src/Password.vala"
	feed_reader_password_parent_class = g_type_class_peek_parent (klass);
#line 16 "../src/Password.vala"
	g_type_class_adjust_private_offset (klass, &FeedReaderPassword_private_offset);
#line 16 "../src/Password.vala"
	G_OBJECT_CLASS (klass)->finalize = feed_reader_password_finalize;
#line 952 "Password.c"
}

static void
feed_reader_password_instance_init (FeedReaderPassword * self,
                                    gpointer klass)
{
#line 16 "../src/Password.vala"
	self->priv = feed_reader_password_get_instance_private (self);
#line 961 "Password.c"
}

static void
feed_reader_password_finalize (GObject * obj)
{
	FeedReaderPassword * self;
#line 16 "../src/Password.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FEED_READER_TYPE_PASSWORD, FeedReaderPassword);
#line 20 "../src/Password.vala"
	_g_object_unref0 (self->priv->m_secrets);
#line 21 "../src/Password.vala"
	_secret_schema_unref0 (self->priv->m_schema);
#line 22 "../src/Password.vala"
	(self->priv->m_get_attributes_target_destroy_notify == NULL) ? NULL : (self->priv->m_get_attributes_target_destroy_notify (self->priv->m_get_attributes_target), NULL);
#line 22 "../src/Password.vala"
	self->priv->m_get_attributes = NULL;
#line 22 "../src/Password.vala"
	self->priv->m_get_attributes_target = NULL;
#line 22 "../src/Password.vala"
	self->priv->m_get_attributes_target_destroy_notify = NULL;
#line 23 "../src/Password.vala"
	_g_free0 (self->priv->m_label);
#line 16 "../src/Password.vala"
	G_OBJECT_CLASS (feed_reader_password_parent_class)->finalize (obj);
#line 986 "Password.c"
}

GType
feed_reader_password_get_type (void)
{
	static volatile gsize feed_reader_password_type_id__volatile = 0;
	if (g_once_init_enter (&feed_reader_password_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FeedReaderPasswordClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) feed_reader_password_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FeedReaderPassword), 0, (GInstanceInitFunc) feed_reader_password_instance_init, NULL };
		GType feed_reader_password_type_id;
		feed_reader_password_type_id = g_type_register_static (G_TYPE_OBJECT, "FeedReaderPassword", &g_define_type_info, 0);
		FeedReaderPassword_private_offset = g_type_add_instance_private (feed_reader_password_type_id, sizeof (FeedReaderPasswordPrivate));
		g_once_init_leave (&feed_reader_password_type_id__volatile, feed_reader_password_type_id);
	}
	return feed_reader_password_type_id__volatile;
}

