/* Rfc822.c generated by valac 0.45.3, the Vala compiler
 * generated from Rfc822.vala, do not modify */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <stdio.h>
#include <float.h>
#include <math.h>

#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

GDateTime* feed_reader_rfc822_parseDate (const gchar* str);

/**
* Parse a date string in RFC 822 format
* Note that we don't use Time.strptime because it uses the current locale
* to parse month names, but RFC 822 specifically requires months to be
* written in English.
* See: https://www.w3.org/Protocols/rfc822/#z28
* And: https://groups.yahoo.com/neo/groups/rss-public/conversations/topics/536
* */
GDateTime*
feed_reader_rfc822_parseDate (const gchar* str)
{
	GDateTime* result = NULL;
	GRegex* re = NULL;
	GMatchInfo* info = NULL;
	GRegex* _tmp6_;
	GMatchInfo* _tmp7_ = NULL;
	gboolean _tmp8_;
	gchar* dayStr = NULL;
	GMatchInfo* _tmp9_;
	gchar* _tmp10_;
	gint day = 0;
	const gchar* _tmp11_;
	gchar* monthStr = NULL;
	GMatchInfo* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gint month = 0;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	GQuark _tmp20_ = 0U;
#line 54 "../src/Rfc822.vala"
	static GQuark _tmp19_label0 = 0;
#line 54 "../src/Rfc822.vala"
	static GQuark _tmp19_label1 = 0;
#line 54 "../src/Rfc822.vala"
	static GQuark _tmp19_label2 = 0;
#line 54 "../src/Rfc822.vala"
	static GQuark _tmp19_label3 = 0;
#line 54 "../src/Rfc822.vala"
	static GQuark _tmp19_label4 = 0;
#line 54 "../src/Rfc822.vala"
	static GQuark _tmp19_label5 = 0;
#line 54 "../src/Rfc822.vala"
	static GQuark _tmp19_label6 = 0;
#line 54 "../src/Rfc822.vala"
	static GQuark _tmp19_label7 = 0;
#line 54 "../src/Rfc822.vala"
	static GQuark _tmp19_label8 = 0;
#line 54 "../src/Rfc822.vala"
	static GQuark _tmp19_label9 = 0;
#line 54 "../src/Rfc822.vala"
	static GQuark _tmp19_label10 = 0;
#line 54 "../src/Rfc822.vala"
	static GQuark _tmp19_label11 = 0;
#line 80 "Rfc822.c"
	gchar* yearStr = NULL;
	GMatchInfo* _tmp21_;
	gchar* _tmp22_;
	gint year = 0;
	const gchar* _tmp23_;
	gboolean _tmp24_ = FALSE;
	gchar* hourStr = NULL;
	GMatchInfo* _tmp26_;
	gchar* _tmp27_;
	gint hour = 0;
	const gchar* _tmp28_;
	gchar* minuteStr = NULL;
	GMatchInfo* _tmp29_;
	gchar* _tmp30_;
	gint minute = 0;
	const gchar* _tmp31_;
	gchar* secondStr = NULL;
	GMatchInfo* _tmp32_;
	gchar* _tmp33_;
	gint _tmp34_ = 0;
	gboolean _tmp35_ = FALSE;
	const gchar* _tmp36_;
	gint second = 0;
	gchar* zoneStr = NULL;
	GMatchInfo* _tmp39_;
	gchar* _tmp40_;
	GTimeZone* zone = NULL;
	const gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	GQuark _tmp45_ = 0U;
#line 118 "../src/Rfc822.vala"
	static GQuark _tmp44_label0 = 0;
#line 118 "../src/Rfc822.vala"
	static GQuark _tmp44_label1 = 0;
#line 118 "../src/Rfc822.vala"
	static GQuark _tmp44_label2 = 0;
#line 118 "../src/Rfc822.vala"
	static GQuark _tmp44_label3 = 0;
#line 118 "../src/Rfc822.vala"
	static GQuark _tmp44_label4 = 0;
#line 118 "../src/Rfc822.vala"
	static GQuark _tmp44_label5 = 0;
#line 118 "../src/Rfc822.vala"
	static GQuark _tmp44_label6 = 0;
#line 118 "../src/Rfc822.vala"
	static GQuark _tmp44_label7 = 0;
#line 118 "../src/Rfc822.vala"
	static GQuark _tmp44_label8 = 0;
#line 118 "../src/Rfc822.vala"
	static GQuark _tmp44_label9 = 0;
#line 118 "../src/Rfc822.vala"
	static GQuark _tmp44_label10 = 0;
#line 134 "Rfc822.c"
	GTimeZone* _tmp54_;
	GDateTime* _tmp55_;
	GError* _inner_error0_ = NULL;
#line 13 "../src/Rfc822.vala"
	if (str == NULL) {
#line 15 "../src/Rfc822.vala"
		result = NULL;
#line 15 "../src/Rfc822.vala"
		return result;
#line 144 "Rfc822.c"
	}
	{
		GRegex* _tmp0_ = NULL;
		GRegex* _tmp1_;
		GRegex* _tmp2_;
#line 20 "../src/Rfc822.vala"
		_tmp1_ = g_regex_new ("\n" \
"\t\t\t\t# We don't care about the day of the week\n" \
"\t\t\t\t\\s*(?:(?:Mon|Tue|Wed|Thu|Fri|Sat|Sun),\\s*)?\n" \
"\t\t\t\t(?<day>\\d{1,2})\\s+\n" \
"\t\t\t\t(?<month>Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\\s+\n" \
"\t\t\t\t# The standard specifies 2-digit years but 4 digit years are\n" \
"\t\t\t\t# recommended now.\n" \
"\t\t\t\t# This pattern will also accept 3-digit years, so we'll have t" \
"o\n" \
"\t\t\t\t# check for that separately\n" \
"\t\t\t\t(?<year>\\d{2,4})\\s+\n" \
"\t\t\t\t(?<hour>\\d{2})\n" \
"\t\t\t\t:(?<minute>\\d{2})\n" \
"\t\t\t\t(?::(?<second>\\d{2}))?\\s+\n" \
"\t\t\t\t(?<zone>UT|GMT|EST|EDT|MST|MDT|PST|PDT|[A-Z]|(?:[+-]\\d{4}))\n" \
"\t\t\t\t", G_REGEX_CASELESS | G_REGEX_EXTENDED, G_REGEX_MATCH_ANCHORED, &_inner_error0_);
#line 20 "../src/Rfc822.vala"
		_tmp0_ = _tmp1_;
#line 20 "../src/Rfc822.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20 "../src/Rfc822.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 158 "Rfc822.c"
				goto __catch34_g_regex_error;
			}
#line 20 "../src/Rfc822.vala"
			_g_regex_unref0 (re);
#line 20 "../src/Rfc822.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 20 "../src/Rfc822.vala"
			g_clear_error (&_inner_error0_);
#line 20 "../src/Rfc822.vala"
			return NULL;
#line 169 "Rfc822.c"
		}
#line 20 "../src/Rfc822.vala"
		_tmp2_ = _tmp0_;
#line 20 "../src/Rfc822.vala"
		_tmp0_ = NULL;
#line 20 "../src/Rfc822.vala"
		_g_regex_unref0 (re);
#line 20 "../src/Rfc822.vala"
		re = _tmp2_;
#line 19 "../src/Rfc822.vala"
		_g_regex_unref0 (_tmp0_);
#line 181 "Rfc822.c"
	}
	goto __finally34;
	__catch34_g_regex_error:
	{
		GError* e = NULL;
		FILE* _tmp3_;
		GError* _tmp4_;
		const gchar* _tmp5_;
#line 19 "../src/Rfc822.vala"
		e = _inner_error0_;
#line 19 "../src/Rfc822.vala"
		_inner_error0_ = NULL;
#line 38 "../src/Rfc822.vala"
		_tmp3_ = stderr;
#line 38 "../src/Rfc822.vala"
		_tmp4_ = e;
#line 38 "../src/Rfc822.vala"
		_tmp5_ = _tmp4_->message;
#line 38 "../src/Rfc822.vala"
		fprintf (_tmp3_, "RFC822 regex failed to parse: %s\n", _tmp5_);
#line 39 "../src/Rfc822.vala"
		_vala_assert (FALSE, "false");
#line 40 "../src/Rfc822.vala"
		result = NULL;
#line 40 "../src/Rfc822.vala"
		_g_error_free0 (e);
#line 40 "../src/Rfc822.vala"
		_g_regex_unref0 (re);
#line 40 "../src/Rfc822.vala"
		return result;
#line 212 "Rfc822.c"
	}
	__finally34:
#line 19 "../src/Rfc822.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 19 "../src/Rfc822.vala"
		_g_regex_unref0 (re);
#line 19 "../src/Rfc822.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 19 "../src/Rfc822.vala"
		g_clear_error (&_inner_error0_);
#line 19 "../src/Rfc822.vala"
		return NULL;
#line 225 "Rfc822.c"
	}
#line 44 "../src/Rfc822.vala"
	_tmp6_ = re;
#line 44 "../src/Rfc822.vala"
	_tmp8_ = g_regex_match (_tmp6_, str, 0, &_tmp7_);
#line 44 "../src/Rfc822.vala"
	_g_match_info_unref0 (info);
#line 44 "../src/Rfc822.vala"
	info = _tmp7_;
#line 44 "../src/Rfc822.vala"
	if (!_tmp8_) {
#line 46 "../src/Rfc822.vala"
		result = NULL;
#line 46 "../src/Rfc822.vala"
		_g_match_info_unref0 (info);
#line 46 "../src/Rfc822.vala"
		_g_regex_unref0 (re);
#line 46 "../src/Rfc822.vala"
		return result;
#line 245 "Rfc822.c"
	}
#line 49 "../src/Rfc822.vala"
	_tmp9_ = info;
#line 49 "../src/Rfc822.vala"
	_tmp10_ = g_match_info_fetch_named (_tmp9_, "day");
#line 49 "../src/Rfc822.vala"
	dayStr = _tmp10_;
#line 50 "../src/Rfc822.vala"
	_tmp11_ = dayStr;
#line 50 "../src/Rfc822.vala"
	day = atoi (_tmp11_);
#line 52 "../src/Rfc822.vala"
	_tmp12_ = info;
#line 52 "../src/Rfc822.vala"
	_tmp13_ = g_match_info_fetch_named (_tmp12_, "month");
#line 52 "../src/Rfc822.vala"
	_tmp14_ = _tmp13_;
#line 52 "../src/Rfc822.vala"
	_tmp15_ = g_ascii_strdown (_tmp14_, (gssize) -1);
#line 52 "../src/Rfc822.vala"
	_tmp16_ = _tmp15_;
#line 52 "../src/Rfc822.vala"
	_g_free0 (_tmp14_);
#line 52 "../src/Rfc822.vala"
	monthStr = _tmp16_;
#line 54 "../src/Rfc822.vala"
	_tmp17_ = monthStr;
#line 54 "../src/Rfc822.vala"
	_tmp18_ = _tmp17_;
#line 54 "../src/Rfc822.vala"
	_tmp20_ = (NULL == _tmp18_) ? 0 : g_quark_from_string (_tmp18_);
#line 54 "../src/Rfc822.vala"
	if (_tmp20_ == ((0 != _tmp19_label0) ? _tmp19_label0 : (_tmp19_label0 = g_quark_from_static_string ("jan")))) {
#line 54 "../src/Rfc822.vala"
		switch (0) {
#line 281 "Rfc822.c"
			default:
			{
#line 56 "../src/Rfc822.vala"
				month = 1;
#line 57 "../src/Rfc822.vala"
				break;
#line 288 "Rfc822.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label1) ? _tmp19_label1 : (_tmp19_label1 = g_quark_from_static_string ("feb")))) {
#line 54 "../src/Rfc822.vala"
		switch (0) {
#line 294 "Rfc822.c"
			default:
			{
#line 59 "../src/Rfc822.vala"
				month = 2;
#line 60 "../src/Rfc822.vala"
				break;
#line 301 "Rfc822.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label2) ? _tmp19_label2 : (_tmp19_label2 = g_quark_from_static_string ("mar")))) {
#line 54 "../src/Rfc822.vala"
		switch (0) {
#line 307 "Rfc822.c"
			default:
			{
#line 62 "../src/Rfc822.vala"
				month = 3;
#line 63 "../src/Rfc822.vala"
				break;
#line 314 "Rfc822.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label3) ? _tmp19_label3 : (_tmp19_label3 = g_quark_from_static_string ("apr")))) {
#line 54 "../src/Rfc822.vala"
		switch (0) {
#line 320 "Rfc822.c"
			default:
			{
#line 65 "../src/Rfc822.vala"
				month = 4;
#line 66 "../src/Rfc822.vala"
				break;
#line 327 "Rfc822.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label4) ? _tmp19_label4 : (_tmp19_label4 = g_quark_from_static_string ("may")))) {
#line 54 "../src/Rfc822.vala"
		switch (0) {
#line 333 "Rfc822.c"
			default:
			{
#line 68 "../src/Rfc822.vala"
				month = 5;
#line 69 "../src/Rfc822.vala"
				break;
#line 340 "Rfc822.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label5) ? _tmp19_label5 : (_tmp19_label5 = g_quark_from_static_string ("jun")))) {
#line 54 "../src/Rfc822.vala"
		switch (0) {
#line 346 "Rfc822.c"
			default:
			{
#line 71 "../src/Rfc822.vala"
				month = 6;
#line 72 "../src/Rfc822.vala"
				break;
#line 353 "Rfc822.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label6) ? _tmp19_label6 : (_tmp19_label6 = g_quark_from_static_string ("jul")))) {
#line 54 "../src/Rfc822.vala"
		switch (0) {
#line 359 "Rfc822.c"
			default:
			{
#line 74 "../src/Rfc822.vala"
				month = 7;
#line 75 "../src/Rfc822.vala"
				break;
#line 366 "Rfc822.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label7) ? _tmp19_label7 : (_tmp19_label7 = g_quark_from_static_string ("aug")))) {
#line 54 "../src/Rfc822.vala"
		switch (0) {
#line 372 "Rfc822.c"
			default:
			{
#line 77 "../src/Rfc822.vala"
				month = 8;
#line 78 "../src/Rfc822.vala"
				break;
#line 379 "Rfc822.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label8) ? _tmp19_label8 : (_tmp19_label8 = g_quark_from_static_string ("sep")))) {
#line 54 "../src/Rfc822.vala"
		switch (0) {
#line 385 "Rfc822.c"
			default:
			{
#line 80 "../src/Rfc822.vala"
				month = 9;
#line 81 "../src/Rfc822.vala"
				break;
#line 392 "Rfc822.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label9) ? _tmp19_label9 : (_tmp19_label9 = g_quark_from_static_string ("oct")))) {
#line 54 "../src/Rfc822.vala"
		switch (0) {
#line 398 "Rfc822.c"
			default:
			{
#line 83 "../src/Rfc822.vala"
				month = 10;
#line 84 "../src/Rfc822.vala"
				break;
#line 405 "Rfc822.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label10) ? _tmp19_label10 : (_tmp19_label10 = g_quark_from_static_string ("nov")))) {
#line 54 "../src/Rfc822.vala"
		switch (0) {
#line 411 "Rfc822.c"
			default:
			{
#line 86 "../src/Rfc822.vala"
				month = 11;
#line 87 "../src/Rfc822.vala"
				break;
#line 418 "Rfc822.c"
			}
		}
	} else if (_tmp20_ == ((0 != _tmp19_label11) ? _tmp19_label11 : (_tmp19_label11 = g_quark_from_static_string ("dec")))) {
#line 54 "../src/Rfc822.vala"
		switch (0) {
#line 424 "Rfc822.c"
			default:
			{
#line 89 "../src/Rfc822.vala"
				month = 12;
#line 90 "../src/Rfc822.vala"
				break;
#line 431 "Rfc822.c"
			}
		}
	} else {
#line 54 "../src/Rfc822.vala"
		switch (0) {
#line 437 "Rfc822.c"
			default:
			{
#line 93 "../src/Rfc822.vala"
				_vala_assert (FALSE, "false");
#line 94 "../src/Rfc822.vala"
				result = NULL;
#line 94 "../src/Rfc822.vala"
				_g_free0 (monthStr);
#line 94 "../src/Rfc822.vala"
				_g_free0 (dayStr);
#line 94 "../src/Rfc822.vala"
				_g_match_info_unref0 (info);
#line 94 "../src/Rfc822.vala"
				_g_regex_unref0 (re);
#line 94 "../src/Rfc822.vala"
				return result;
#line 454 "Rfc822.c"
			}
		}
	}
#line 97 "../src/Rfc822.vala"
	_tmp21_ = info;
#line 97 "../src/Rfc822.vala"
	_tmp22_ = g_match_info_fetch_named (_tmp21_, "year");
#line 97 "../src/Rfc822.vala"
	yearStr = _tmp22_;
#line 98 "../src/Rfc822.vala"
	_tmp23_ = yearStr;
#line 98 "../src/Rfc822.vala"
	year = atoi (_tmp23_);
#line 100 "../src/Rfc822.vala"
	if (year >= 0) {
#line 100 "../src/Rfc822.vala"
		_tmp24_ = year <= 49;
#line 472 "Rfc822.c"
	} else {
#line 100 "../src/Rfc822.vala"
		_tmp24_ = FALSE;
#line 476 "Rfc822.c"
	}
#line 100 "../src/Rfc822.vala"
	if (_tmp24_) {
#line 102 "../src/Rfc822.vala"
		year += 2000;
#line 482 "Rfc822.c"
	} else {
		gboolean _tmp25_ = FALSE;
#line 105 "../src/Rfc822.vala"
		if (year >= 50) {
#line 105 "../src/Rfc822.vala"
			_tmp25_ = year < 100;
#line 489 "Rfc822.c"
		} else {
#line 105 "../src/Rfc822.vala"
			_tmp25_ = FALSE;
#line 493 "Rfc822.c"
		}
#line 105 "../src/Rfc822.vala"
		if (_tmp25_) {
#line 107 "../src/Rfc822.vala"
			year += 1900;
#line 499 "Rfc822.c"
		}
	}
#line 109 "../src/Rfc822.vala"
	_tmp26_ = info;
#line 109 "../src/Rfc822.vala"
	_tmp27_ = g_match_info_fetch_named (_tmp26_, "hour");
#line 109 "../src/Rfc822.vala"
	hourStr = _tmp27_;
#line 110 "../src/Rfc822.vala"
	_tmp28_ = hourStr;
#line 110 "../src/Rfc822.vala"
	hour = atoi (_tmp28_);
#line 111 "../src/Rfc822.vala"
	_tmp29_ = info;
#line 111 "../src/Rfc822.vala"
	_tmp30_ = g_match_info_fetch_named (_tmp29_, "minute");
#line 111 "../src/Rfc822.vala"
	minuteStr = _tmp30_;
#line 112 "../src/Rfc822.vala"
	_tmp31_ = minuteStr;
#line 112 "../src/Rfc822.vala"
	minute = atoi (_tmp31_);
#line 113 "../src/Rfc822.vala"
	_tmp32_ = info;
#line 113 "../src/Rfc822.vala"
	_tmp33_ = g_match_info_fetch_named (_tmp32_, "second");
#line 113 "../src/Rfc822.vala"
	secondStr = _tmp33_;
#line 114 "../src/Rfc822.vala"
	_tmp36_ = secondStr;
#line 114 "../src/Rfc822.vala"
	if (_tmp36_ == NULL) {
#line 114 "../src/Rfc822.vala"
		_tmp35_ = TRUE;
#line 534 "Rfc822.c"
	} else {
		const gchar* _tmp37_;
#line 114 "../src/Rfc822.vala"
		_tmp37_ = secondStr;
#line 114 "../src/Rfc822.vala"
		_tmp35_ = g_strcmp0 (_tmp37_, "") == 0;
#line 541 "Rfc822.c"
	}
#line 114 "../src/Rfc822.vala"
	if (_tmp35_) {
#line 114 "../src/Rfc822.vala"
		_tmp34_ = 0;
#line 547 "Rfc822.c"
	} else {
		const gchar* _tmp38_;
#line 114 "../src/Rfc822.vala"
		_tmp38_ = secondStr;
#line 114 "../src/Rfc822.vala"
		_tmp34_ = atoi (_tmp38_);
#line 554 "Rfc822.c"
	}
#line 114 "../src/Rfc822.vala"
	second = _tmp34_;
#line 116 "../src/Rfc822.vala"
	_tmp39_ = info;
#line 116 "../src/Rfc822.vala"
	_tmp40_ = g_match_info_fetch_named (_tmp39_, "zone");
#line 116 "../src/Rfc822.vala"
	zoneStr = _tmp40_;
#line 118 "../src/Rfc822.vala"
	_tmp41_ = zoneStr;
#line 118 "../src/Rfc822.vala"
	_tmp42_ = g_ascii_strup (_tmp41_, (gssize) -1);
#line 118 "../src/Rfc822.vala"
	_tmp43_ = _tmp42_;
#line 118 "../src/Rfc822.vala"
	_tmp45_ = (NULL == _tmp43_) ? 0 : g_quark_from_string (_tmp43_);
#line 118 "../src/Rfc822.vala"
	g_free (_tmp43_);
#line 118 "../src/Rfc822.vala"
	if (_tmp45_ == ((0 != _tmp44_label0) ? _tmp44_label0 : (_tmp44_label0 = g_quark_from_static_string ("EDT")))) {
#line 118 "../src/Rfc822.vala"
		switch (0) {
#line 578 "Rfc822.c"
			default:
			{
				GTimeZone* _tmp46_;
#line 122 "../src/Rfc822.vala"
				_tmp46_ = g_time_zone_new ("-04");
#line 122 "../src/Rfc822.vala"
				_g_time_zone_unref0 (zone);
#line 122 "../src/Rfc822.vala"
				zone = _tmp46_;
#line 123 "../src/Rfc822.vala"
				break;
#line 590 "Rfc822.c"
			}
		}
	} else if ((_tmp45_ == ((0 != _tmp44_label1) ? _tmp44_label1 : (_tmp44_label1 = g_quark_from_static_string ("CDT")))) || (_tmp45_ == ((0 != _tmp44_label2) ? _tmp44_label2 : (_tmp44_label2 = g_quark_from_static_string ("EST"))))) {
#line 118 "../src/Rfc822.vala"
		switch (0) {
#line 596 "Rfc822.c"
			default:
			{
				GTimeZone* _tmp47_;
#line 126 "../src/Rfc822.vala"
				_tmp47_ = g_time_zone_new ("-05");
#line 126 "../src/Rfc822.vala"
				_g_time_zone_unref0 (zone);
#line 126 "../src/Rfc822.vala"
				zone = _tmp47_;
#line 127 "../src/Rfc822.vala"
				break;
#line 608 "Rfc822.c"
			}
		}
	} else if ((_tmp45_ == ((0 != _tmp44_label3) ? _tmp44_label3 : (_tmp44_label3 = g_quark_from_static_string ("CST")))) || (_tmp45_ == ((0 != _tmp44_label4) ? _tmp44_label4 : (_tmp44_label4 = g_quark_from_static_string ("MDT"))))) {
#line 118 "../src/Rfc822.vala"
		switch (0) {
#line 614 "Rfc822.c"
			default:
			{
				GTimeZone* _tmp48_;
#line 130 "../src/Rfc822.vala"
				_tmp48_ = g_time_zone_new ("-06");
#line 130 "../src/Rfc822.vala"
				_g_time_zone_unref0 (zone);
#line 130 "../src/Rfc822.vala"
				zone = _tmp48_;
#line 131 "../src/Rfc822.vala"
				break;
#line 626 "Rfc822.c"
			}
		}
	} else if ((_tmp45_ == ((0 != _tmp44_label5) ? _tmp44_label5 : (_tmp44_label5 = g_quark_from_static_string ("MST")))) || (_tmp45_ == ((0 != _tmp44_label6) ? _tmp44_label6 : (_tmp44_label6 = g_quark_from_static_string ("PDT"))))) {
#line 118 "../src/Rfc822.vala"
		switch (0) {
#line 632 "Rfc822.c"
			default:
			{
				GTimeZone* _tmp49_;
#line 134 "../src/Rfc822.vala"
				_tmp49_ = g_time_zone_new ("-07");
#line 134 "../src/Rfc822.vala"
				_g_time_zone_unref0 (zone);
#line 134 "../src/Rfc822.vala"
				zone = _tmp49_;
#line 135 "../src/Rfc822.vala"
				break;
#line 644 "Rfc822.c"
			}
		}
	} else if (_tmp45_ == ((0 != _tmp44_label7) ? _tmp44_label7 : (_tmp44_label7 = g_quark_from_static_string ("PST")))) {
#line 118 "../src/Rfc822.vala"
		switch (0) {
#line 650 "Rfc822.c"
			default:
			{
				GTimeZone* _tmp50_;
#line 137 "../src/Rfc822.vala"
				_tmp50_ = g_time_zone_new ("-08");
#line 137 "../src/Rfc822.vala"
				_g_time_zone_unref0 (zone);
#line 137 "../src/Rfc822.vala"
				zone = _tmp50_;
#line 138 "../src/Rfc822.vala"
				break;
#line 662 "Rfc822.c"
			}
		}
	} else if (((_tmp45_ == ((0 != _tmp44_label8) ? _tmp44_label8 : (_tmp44_label8 = g_quark_from_static_string ("GMT")))) || (_tmp45_ == ((0 != _tmp44_label9) ? _tmp44_label9 : (_tmp44_label9 = g_quark_from_static_string ("UT"))))) || (_tmp45_ == ((0 != _tmp44_label10) ? _tmp44_label10 : (_tmp44_label10 = g_quark_from_static_string ("Z"))))) {
#line 118 "../src/Rfc822.vala"
		switch (0) {
#line 668 "Rfc822.c"
			default:
			{
				GTimeZone* _tmp51_;
#line 143 "../src/Rfc822.vala"
				_tmp51_ = g_time_zone_new_utc ();
#line 143 "../src/Rfc822.vala"
				_g_time_zone_unref0 (zone);
#line 143 "../src/Rfc822.vala"
				zone = _tmp51_;
#line 144 "../src/Rfc822.vala"
				break;
#line 680 "Rfc822.c"
			}
		}
	} else {
#line 118 "../src/Rfc822.vala"
		switch (0) {
#line 686 "Rfc822.c"
			default:
			{
				const gchar* _tmp52_;
				GTimeZone* _tmp53_;
#line 146 "../src/Rfc822.vala"
				_tmp52_ = zoneStr;
#line 146 "../src/Rfc822.vala"
				_tmp53_ = g_time_zone_new (_tmp52_);
#line 146 "../src/Rfc822.vala"
				_g_time_zone_unref0 (zone);
#line 146 "../src/Rfc822.vala"
				zone = _tmp53_;
#line 147 "../src/Rfc822.vala"
				break;
#line 701 "Rfc822.c"
			}
		}
	}
#line 150 "../src/Rfc822.vala"
	_tmp54_ = zone;
#line 150 "../src/Rfc822.vala"
	_tmp55_ = g_date_time_new (_tmp54_, year, month, day, hour, minute, (gdouble) second);
#line 150 "../src/Rfc822.vala"
	result = _tmp55_;
#line 150 "../src/Rfc822.vala"
	_g_time_zone_unref0 (zone);
#line 150 "../src/Rfc822.vala"
	_g_free0 (zoneStr);
#line 150 "../src/Rfc822.vala"
	_g_free0 (secondStr);
#line 150 "../src/Rfc822.vala"
	_g_free0 (minuteStr);
#line 150 "../src/Rfc822.vala"
	_g_free0 (hourStr);
#line 150 "../src/Rfc822.vala"
	_g_free0 (yearStr);
#line 150 "../src/Rfc822.vala"
	_g_free0 (monthStr);
#line 150 "../src/Rfc822.vala"
	_g_free0 (dayStr);
#line 150 "../src/Rfc822.vala"
	_g_match_info_unref0 (info);
#line 150 "../src/Rfc822.vala"
	_g_regex_unref0 (re);
#line 150 "../src/Rfc822.vala"
	return result;
#line 733 "Rfc822.c"
}

