/* MediaPlayer.c generated by valac 0.45.3, the Vala compiler
 * generated from MediaPlayer.vala, do not modify */

/*This file is part of FeedReader.*/
/**/
/*FeedReader is free software: you can redistribute it and/or modify*/
/*it under the terms of the GNU General Public License as published by*/
/*the Free Software Foundation, either version 3 of the License, or*/
/*(at your option) any later version.*/
/**/
/*FeedReader is distributed in the hope that it will be useful,*/
/*but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*GNU General Public License for more details.*/
/**/
/*You should have received a copy of the GNU General Public License*/
/*along with FeedReader.  If not, see <http://www.gnu.org/licenses/>.*/

#include <gtk/gtk.h>
#include <glib-object.h>
#include <gst/gst.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gst/pbutils/pbutils.h>
#include <cairo.h>

#define FEED_READER_TYPE_MEDIA_PLAYER (feed_reader_media_player_get_type ())
#define FEED_READER_MEDIA_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FEED_READER_TYPE_MEDIA_PLAYER, FeedReaderMediaPlayer))
#define FEED_READER_MEDIA_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FEED_READER_TYPE_MEDIA_PLAYER, FeedReaderMediaPlayerClass))
#define FEED_READER_IS_MEDIA_PLAYER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FEED_READER_TYPE_MEDIA_PLAYER))
#define FEED_READER_IS_MEDIA_PLAYER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FEED_READER_TYPE_MEDIA_PLAYER))
#define FEED_READER_MEDIA_PLAYER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FEED_READER_TYPE_MEDIA_PLAYER, FeedReaderMediaPlayerClass))

typedef struct _FeedReaderMediaPlayer FeedReaderMediaPlayer;
typedef struct _FeedReaderMediaPlayerClass FeedReaderMediaPlayerClass;
typedef struct _FeedReaderMediaPlayerPrivate FeedReaderMediaPlayerPrivate;
typedef enum  {
	FEED_READER_MEDIA_TYPE_VIDEO,
	FEED_READER_MEDIA_TYPE_AUDIO
} FeedReaderMediaType;

#define FEED_READER_TYPE_MEDIA_TYPE (feed_reader_media_type_get_type ())
typedef enum  {
	FEED_READER_DISPLAY_POSITION_ALL,
	FEED_READER_DISPLAY_POSITION_POS,
	FEED_READER_DISPLAY_POSITION_LEFT
} FeedReaderDisplayPosition;

#define FEED_READER_TYPE_DISPLAY_POSITION (feed_reader_display_position_get_type ())
enum  {
	FEED_READER_MEDIA_PLAYER_0_PROPERTY,
	FEED_READER_MEDIA_PLAYER_NUM_PROPERTIES
};
static GParamSpec* feed_reader_media_player_properties[FEED_READER_MEDIA_PLAYER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block27Data Block27Data;
enum  {
	FEED_READER_MEDIA_PLAYER_LOADED_SIGNAL,
	FEED_READER_MEDIA_PLAYER_NUM_SIGNALS
};
static guint feed_reader_media_player_signals[FEED_READER_MEDIA_PLAYER_NUM_SIGNALS] = {0};

struct _FeedReaderMediaPlayer {
	GtkBox parent_instance;
	FeedReaderMediaPlayerPrivate * priv;
};

struct _FeedReaderMediaPlayerClass {
	GtkBoxClass parent_class;
};

struct _FeedReaderMediaPlayerPrivate {
	GstElement* m_player;
	GtkWidget* m_videoWidget;
	GtkStack* m_playStack;
	GtkButton* m_playButton;
	GtkSpinner* m_playSpinner;
	GtkButton* m_muteButton;
	GtkButton* m_closeButton;
	GtkScale* m_scale;
	GtkButton* m_labelButton;
	GtkLabel* m_bufferLabel;
	gint m_margin;
	GtkImage* m_playIcon;
	GtkImage* m_pauseIcon;
	GtkImage* m_muteIcon;
	GtkImage* m_noiseIcon;
	GtkImage* m_closeIcon;
	gboolean m_muted;
	gdouble m_aspectRatio;
	guint m_seek_source_id;
	FeedReaderMediaType m_type;
	gchar* m_URL;
	FeedReaderDisplayPosition m_display;
};

struct _Block27Data {
	int _ref_count_;
	FeedReaderMediaPlayer* self;
	gdouble startValue;
};

static gint FeedReaderMediaPlayer_private_offset;
static gpointer feed_reader_media_player_parent_class = NULL;

GType feed_reader_media_player_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FeedReaderMediaPlayer, g_object_unref)
GType feed_reader_media_type_get_type (void) G_GNUC_CONST;
GType feed_reader_display_position_get_type (void) G_GNUC_CONST;
FeedReaderMediaPlayer* feed_reader_media_player_new (const gchar* url);
FeedReaderMediaPlayer* feed_reader_media_player_construct (GType object_type,
                                                           const gchar* url);
static void feed_reader_media_player_inspectMedia (FeedReaderMediaPlayer* self);
static void feed_reader_media_player_buildUI (FeedReaderMediaPlayer* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
void feed_reader_logger_error (const gchar* message);
static void feed_reader_media_player_onAllocation (FeedReaderMediaPlayer* self,
                                            GtkAllocation* allocation);
static void _feed_reader_media_player_onAllocation_gtk_widget_size_allocate (GtkWidget* _sender,
                                                                      GtkAllocation* allocation,
                                                                      gpointer self);
static gboolean feed_reader_media_player_busCallback (FeedReaderMediaPlayer* self,
                                               GstBus* bus,
                                               GstMessage* message);
static gboolean _feed_reader_media_player_busCallback_gst_bus_func (GstBus* bus,
                                                             GstMessage* message,
                                                             gpointer self);
static gboolean __lambda95_ (FeedReaderMediaPlayer* self);
static void feed_reader_media_player_calcTime (FeedReaderMediaPlayer* self);
static gboolean ___lambda95__gsource_func (gpointer self);
static void feed_reader_media_player_togglePause (FeedReaderMediaPlayer* self);
static void _feed_reader_media_player_togglePause_gtk_button_clicked (GtkButton* _sender,
                                                               gpointer self);
#define FEED_READER_MEDIA_BUTTON_PLAY "Play"
#define FEED_READER_MEDIA_BUTTON_MUTE "Mute"
static void feed_reader_media_player_toggleMute (FeedReaderMediaPlayer* self);
static void _feed_reader_media_player_toggleMute_gtk_button_clicked (GtkButton* _sender,
                                                              gpointer self);
static void __lambda96_ (FeedReaderMediaPlayer* self);
void feed_reader_media_player_kill (FeedReaderMediaPlayer* self);
static void ___lambda96__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
#define FEED_READER_MEDIA_BUTTON_CLOSE "Close"
static gboolean feed_reader_media_player_valueChanged (FeedReaderMediaPlayer* self,
                                                GtkScrollType scroll,
                                                gdouble new_value);
static gboolean _feed_reader_media_player_valueChanged_gtk_range_change_value (GtkRange* _sender,
                                                                        GtkScrollType scroll,
                                                                        gdouble new_value,
                                                                        gpointer self);
static void feed_reader_media_player_switchDisplay (FeedReaderMediaPlayer* self);
static void _feed_reader_media_player_switchDisplay_gtk_button_clicked (GtkButton* _sender,
                                                                 gpointer self);
#define FEED_READER_MEDIA_BUTTON_PAUSE "Pause"
static gdouble* _double_dup (gdouble* self);
static Block27Data* block27_data_ref (Block27Data* _data27_);
static void block27_data_unref (void * _userdata_);
static gboolean ___lambda97_ (Block27Data* _data27_);
static void feed_reader_media_player_seek (FeedReaderMediaPlayer* self,
                                    gdouble new_value);
static gboolean ____lambda97__gsource_func (gpointer self);
#define FEED_READER_MEDIA_BUTTON_UNMUTE "Unmute"
static void feed_reader_media_player_finalize (GObject * obj);

static inline gpointer
feed_reader_media_player_get_instance_private (FeedReaderMediaPlayer* self)
{
	return G_STRUCT_MEMBER_P (self, FeedReaderMediaPlayer_private_offset);
}

FeedReaderMediaPlayer*
feed_reader_media_player_construct (GType object_type,
                                    const gchar* url)
{
	FeedReaderMediaPlayer * self = NULL;
	gchar* _tmp0_;
#line 42 "../src/Widgets/MediaPlayer.vala"
	g_return_val_if_fail (url != NULL, NULL);
#line 42 "../src/Widgets/MediaPlayer.vala"
	self = (FeedReaderMediaPlayer*) g_object_new (object_type, NULL);
#line 44 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_type = FEED_READER_MEDIA_TYPE_AUDIO;
#line 45 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = g_strdup (url);
#line 45 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (self->priv->m_URL);
#line 45 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_URL = _tmp0_;
#line 47 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_inspectMedia (self);
#line 48 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_buildUI (self);
#line 49 "../src/Widgets/MediaPlayer.vala"
	g_signal_emit (self, feed_reader_media_player_signals[FEED_READER_MEDIA_PLAYER_LOADED_SIGNAL], 0);
#line 42 "../src/Widgets/MediaPlayer.vala"
	return self;
#line 204 "MediaPlayer.c"
}

FeedReaderMediaPlayer*
feed_reader_media_player_new (const gchar* url)
{
#line 42 "../src/Widgets/MediaPlayer.vala"
	return feed_reader_media_player_construct (FEED_READER_TYPE_MEDIA_PLAYER, url);
#line 212 "MediaPlayer.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 59 "../src/Widgets/MediaPlayer.vala"
	return self ? g_object_ref (self) : NULL;
#line 220 "MediaPlayer.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 59 "../src/Widgets/MediaPlayer.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 228 "MediaPlayer.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 59 "../src/Widgets/MediaPlayer.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 236 "MediaPlayer.c"
}

static void
feed_reader_media_player_inspectMedia (FeedReaderMediaPlayer* self)
{
	GError* _inner_error0_ = NULL;
#line 52 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 245 "MediaPlayer.c"
	{
		GstDiscoverer* discoverer = NULL;
		GstDiscoverer* _tmp0_;
		GstDiscovererInfo* info = NULL;
		GstDiscoverer* _tmp1_;
		const gchar* _tmp2_;
		GstDiscovererInfo* _tmp3_;
		GstDiscovererInfo* _tmp4_;
		GList* _tmp5_;
#line 56 "../src/Widgets/MediaPlayer.vala"
		_tmp0_ = gst_discoverer_new ((GstClockTime) (10 * GST_SECOND), &_inner_error0_);
#line 56 "../src/Widgets/MediaPlayer.vala"
		discoverer = _tmp0_;
#line 56 "../src/Widgets/MediaPlayer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 261 "MediaPlayer.c"
			goto __catch29_g_error;
		}
#line 57 "../src/Widgets/MediaPlayer.vala"
		_tmp1_ = discoverer;
#line 57 "../src/Widgets/MediaPlayer.vala"
		_tmp2_ = self->priv->m_URL;
#line 57 "../src/Widgets/MediaPlayer.vala"
		_tmp3_ = gst_discoverer_discover_uri (_tmp1_, _tmp2_, &_inner_error0_);
#line 57 "../src/Widgets/MediaPlayer.vala"
		info = _tmp3_;
#line 57 "../src/Widgets/MediaPlayer.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 57 "../src/Widgets/MediaPlayer.vala"
			_g_object_unref0 (discoverer);
#line 276 "MediaPlayer.c"
			goto __catch29_g_error;
		}
#line 59 "../src/Widgets/MediaPlayer.vala"
		_tmp4_ = info;
#line 59 "../src/Widgets/MediaPlayer.vala"
		_tmp5_ = gst_discoverer_info_get_stream_list (_tmp4_);
#line 283 "MediaPlayer.c"
		{
			GList* i_collection = NULL;
			GList* i_it = NULL;
#line 59 "../src/Widgets/MediaPlayer.vala"
			i_collection = _tmp5_;
#line 59 "../src/Widgets/MediaPlayer.vala"
			for (i_it = i_collection; i_it != NULL; i_it = i_it->next) {
#line 291 "MediaPlayer.c"
				GstDiscovererStreamInfo* _tmp6_;
				GstDiscovererStreamInfo* i = NULL;
#line 59 "../src/Widgets/MediaPlayer.vala"
				_tmp6_ = _g_object_ref0 ((GstDiscovererStreamInfo*) i_it->data);
#line 59 "../src/Widgets/MediaPlayer.vala"
				i = _tmp6_;
#line 298 "MediaPlayer.c"
				{
					GstDiscovererStreamInfo* _tmp7_;
#line 61 "../src/Widgets/MediaPlayer.vala"
					_tmp7_ = i;
#line 61 "../src/Widgets/MediaPlayer.vala"
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, gst_discoverer_video_info_get_type ())) {
#line 305 "MediaPlayer.c"
						GstDiscovererVideoInfo* v = NULL;
						GstDiscovererStreamInfo* _tmp8_;
						GstDiscovererVideoInfo* _tmp9_;
						GstDiscovererVideoInfo* _tmp10_;
						GstDiscovererVideoInfo* _tmp11_;
#line 63 "../src/Widgets/MediaPlayer.vala"
						_tmp8_ = i;
#line 63 "../src/Widgets/MediaPlayer.vala"
						_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gst_discoverer_video_info_get_type (), GstDiscovererVideoInfo));
#line 63 "../src/Widgets/MediaPlayer.vala"
						v = _tmp9_;
#line 64 "../src/Widgets/MediaPlayer.vala"
						_tmp10_ = v;
#line 64 "../src/Widgets/MediaPlayer.vala"
						_tmp11_ = v;
#line 64 "../src/Widgets/MediaPlayer.vala"
						self->priv->m_aspectRatio = ((gdouble) gst_discoverer_video_info_get_width (_tmp10_)) / ((gdouble) gst_discoverer_video_info_get_height (_tmp11_));
#line 65 "../src/Widgets/MediaPlayer.vala"
						self->priv->m_type = FEED_READER_MEDIA_TYPE_VIDEO;
#line 61 "../src/Widgets/MediaPlayer.vala"
						_g_object_unref0 (v);
#line 327 "MediaPlayer.c"
					}
#line 59 "../src/Widgets/MediaPlayer.vala"
					_g_object_unref0 (i);
#line 331 "MediaPlayer.c"
				}
			}
#line 59 "../src/Widgets/MediaPlayer.vala"
			(i_collection == NULL) ? NULL : (i_collection = (_g_list_free__g_object_unref0_ (i_collection), NULL));
#line 336 "MediaPlayer.c"
		}
#line 54 "../src/Widgets/MediaPlayer.vala"
		_g_object_unref0 (info);
#line 54 "../src/Widgets/MediaPlayer.vala"
		_g_object_unref0 (discoverer);
#line 342 "MediaPlayer.c"
	}
	goto __finally29;
	__catch29_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 54 "../src/Widgets/MediaPlayer.vala"
		e = _inner_error0_;
#line 54 "../src/Widgets/MediaPlayer.vala"
		_inner_error0_ = NULL;
#line 71 "../src/Widgets/MediaPlayer.vala"
		_tmp12_ = e;
#line 71 "../src/Widgets/MediaPlayer.vala"
		_tmp13_ = _tmp12_->message;
#line 71 "../src/Widgets/MediaPlayer.vala"
		_tmp14_ = g_strconcat ("Unable discover_uri: ", _tmp13_, NULL);
#line 71 "../src/Widgets/MediaPlayer.vala"
		_tmp15_ = _tmp14_;
#line 71 "../src/Widgets/MediaPlayer.vala"
		feed_reader_logger_error (_tmp15_);
#line 71 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (_tmp15_);
#line 54 "../src/Widgets/MediaPlayer.vala"
		_g_error_free0 (e);
#line 370 "MediaPlayer.c"
	}
	__finally29:
#line 54 "../src/Widgets/MediaPlayer.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 54 "../src/Widgets/MediaPlayer.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 54 "../src/Widgets/MediaPlayer.vala"
		g_clear_error (&_inner_error0_);
#line 54 "../src/Widgets/MediaPlayer.vala"
		return;
#line 381 "MediaPlayer.c"
	}
}

static void
_feed_reader_media_player_onAllocation_gtk_widget_size_allocate (GtkWidget* _sender,
                                                                 GtkAllocation* allocation,
                                                                 gpointer self)
{
#line 82 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_onAllocation ((FeedReaderMediaPlayer*) self, allocation);
#line 392 "MediaPlayer.c"
}

static gboolean
_feed_reader_media_player_busCallback_gst_bus_func (GstBus* bus,
                                                    GstMessage* message,
                                                    gpointer self)
{
	gboolean result;
	result = feed_reader_media_player_busCallback ((FeedReaderMediaPlayer*) self, bus, message);
#line 90 "../src/Widgets/MediaPlayer.vala"
	return result;
#line 404 "MediaPlayer.c"
}

static gboolean
__lambda95_ (FeedReaderMediaPlayer* self)
{
	gboolean result = FALSE;
	GstState state = 0;
	GstState pending = 0;
	GstElement* _tmp0_;
	GstState _tmp1_ = 0;
	GstState _tmp2_ = 0;
	GstState _tmp3_;
#line 95 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_player;
#line 95 "../src/Widgets/MediaPlayer.vala"
	gst_element_get_state (_tmp0_, &_tmp1_, &_tmp2_, (GstClockTime) 1000);
#line 95 "../src/Widgets/MediaPlayer.vala"
	state = _tmp1_;
#line 95 "../src/Widgets/MediaPlayer.vala"
	pending = _tmp2_;
#line 96 "../src/Widgets/MediaPlayer.vala"
	_tmp3_ = state;
#line 96 "../src/Widgets/MediaPlayer.vala"
	if (_tmp3_ == GST_STATE_PLAYING) {
#line 429 "MediaPlayer.c"
		gint64 pos = 0LL;
		gint64 dur = 0LL;
		GstElement* _tmp4_;
		gint64 _tmp5_ = 0LL;
		GstElement* _tmp6_;
		gint64 _tmp7_ = 0LL;
		gdouble position = 0.0;
		gdouble duration = 0.0;
		gdouble percent = 0.0;
#line 100 "../src/Widgets/MediaPlayer.vala"
		_tmp4_ = self->priv->m_player;
#line 100 "../src/Widgets/MediaPlayer.vala"
		gst_element_query_position (_tmp4_, GST_FORMAT_TIME, &_tmp5_);
#line 100 "../src/Widgets/MediaPlayer.vala"
		pos = _tmp5_;
#line 101 "../src/Widgets/MediaPlayer.vala"
		_tmp6_ = self->priv->m_player;
#line 101 "../src/Widgets/MediaPlayer.vala"
		gst_element_query_duration (_tmp6_, GST_FORMAT_TIME, &_tmp7_);
#line 101 "../src/Widgets/MediaPlayer.vala"
		dur = _tmp7_;
#line 102 "../src/Widgets/MediaPlayer.vala"
		position = ((gdouble) pos) / 1000000000;
#line 103 "../src/Widgets/MediaPlayer.vala"
		duration = ((gdouble) dur) / 1000000000;
#line 104 "../src/Widgets/MediaPlayer.vala"
		percent = (position * 100.0) / duration;
#line 105 "../src/Widgets/MediaPlayer.vala"
		if (self->priv->m_seek_source_id == ((guint) 0)) {
#line 459 "MediaPlayer.c"
			GtkScale* _tmp8_;
#line 107 "../src/Widgets/MediaPlayer.vala"
			_tmp8_ = self->priv->m_scale;
#line 107 "../src/Widgets/MediaPlayer.vala"
			gtk_range_set_value ((GtkRange*) _tmp8_, percent);
#line 465 "MediaPlayer.c"
		}
#line 109 "../src/Widgets/MediaPlayer.vala"
		feed_reader_media_player_calcTime (self);
#line 469 "MediaPlayer.c"
	}
#line 111 "../src/Widgets/MediaPlayer.vala"
	result = TRUE;
#line 111 "../src/Widgets/MediaPlayer.vala"
	return result;
#line 475 "MediaPlayer.c"
}

static gboolean
___lambda95__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda95_ ((FeedReaderMediaPlayer*) self);
#line 92 "../src/Widgets/MediaPlayer.vala"
	return result;
#line 485 "MediaPlayer.c"
}

static void
_feed_reader_media_player_togglePause_gtk_button_clicked (GtkButton* _sender,
                                                          gpointer self)
{
#line 122 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_togglePause ((FeedReaderMediaPlayer*) self);
#line 494 "MediaPlayer.c"
}

static void
_feed_reader_media_player_toggleMute_gtk_button_clicked (GtkButton* _sender,
                                                         gpointer self)
{
#line 137 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_toggleMute ((FeedReaderMediaPlayer*) self);
#line 503 "MediaPlayer.c"
}

static void
__lambda96_ (FeedReaderMediaPlayer* self)
{
#line 145 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_kill (self);
#line 511 "MediaPlayer.c"
}

static void
___lambda96__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 144 "../src/Widgets/MediaPlayer.vala"
	__lambda96_ ((FeedReaderMediaPlayer*) self);
#line 520 "MediaPlayer.c"
}

static gboolean
_feed_reader_media_player_valueChanged_gtk_range_change_value (GtkRange* _sender,
                                                               GtkScrollType scroll,
                                                               gdouble new_value,
                                                               gpointer self)
{
	gboolean result;
	result = feed_reader_media_player_valueChanged ((FeedReaderMediaPlayer*) self, scroll, new_value);
#line 155 "../src/Widgets/MediaPlayer.vala"
	return result;
#line 533 "MediaPlayer.c"
}

static void
_feed_reader_media_player_switchDisplay_gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self)
{
#line 160 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_switchDisplay ((FeedReaderMediaPlayer*) self);
#line 542 "MediaPlayer.c"
}

static void
feed_reader_media_player_buildUI (FeedReaderMediaPlayer* self)
{
	GstElement* gtksink = NULL;
	GstElement* _tmp0_;
	GstElement* _tmp1_;
	GtkWidget* _tmp2_ = NULL;
	GtkWidget* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
	GtkWidget* _tmp6_;
	GstElement* _tmp7_;
	GstElement* _tmp8_;
	GstElement* _tmp9_;
	GstElement* _tmp10_;
	GstElement* _tmp11_;
	const gchar* _tmp12_;
	GstBus* bus = NULL;
	GstElement* _tmp13_;
	GstBus* _tmp14_;
	GstBus* _tmp15_;
	GtkImage* _tmp16_;
	GtkImage* _tmp17_;
	GtkImage* _tmp18_;
	GtkImage* _tmp19_;
	GtkImage* _tmp20_;
	GtkButton* _tmp21_;
	GtkButton* _tmp22_;
	GtkImage* _tmp23_;
	GtkButton* _tmp24_;
	GtkButton* _tmp25_;
	GtkButton* _tmp26_;
	GtkButton* _tmp27_;
	GtkButton* _tmp28_;
	GtkSpinner* _tmp29_;
	GtkStack* _tmp30_;
	GtkStack* _tmp31_;
	GtkButton* _tmp32_;
	GtkStack* _tmp33_;
	GtkSpinner* _tmp34_;
	GtkStack* _tmp35_;
	GtkButton* _tmp36_;
	GtkButton* _tmp37_;
	GtkImage* _tmp38_;
	GtkButton* _tmp39_;
	GtkButton* _tmp40_;
	GtkButton* _tmp41_;
	GtkButton* _tmp42_;
	GtkButton* _tmp43_;
	GtkButton* _tmp44_;
	GtkButton* _tmp45_;
	GtkImage* _tmp46_;
	GtkButton* _tmp47_;
	GtkButton* _tmp48_;
	GtkButton* _tmp49_;
	GtkButton* _tmp50_;
	GtkButton* _tmp51_;
	GtkScale* _tmp52_;
	GtkScale* _tmp53_;
	GtkScale* _tmp54_;
	GtkScale* _tmp55_;
	GtkButton* _tmp56_;
	GtkButton* _tmp57_;
	GtkButton* _tmp58_;
	GtkStyleContext* _tmp59_;
	GtkButton* _tmp60_;
	GtkButton* _tmp61_;
	GtkButton* _tmp62_;
	GtkButton* _tmp63_;
	GtkBox* hBox = NULL;
	GtkBox* _tmp64_;
	GtkBox* _tmp65_;
	GtkBox* _tmp66_;
	GtkStack* _tmp67_;
	GtkBox* _tmp68_;
	GtkButton* _tmp69_;
	GtkBox* _tmp70_;
	GtkScale* _tmp71_;
	GtkBox* _tmp72_;
	GtkButton* _tmp73_;
	GtkBox* _tmp74_;
	GtkButton* _tmp75_;
	GtkLabel* _tmp76_;
	GtkLabel* _tmp77_;
	GtkLabel* _tmp78_;
	GtkLabel* _tmp79_;
	GtkLabel* _tmp80_;
	GtkOverlay* bufferOverlay = NULL;
	GtkOverlay* _tmp81_;
	GtkOverlay* _tmp82_;
	GtkWidget* _tmp83_;
	GtkOverlay* _tmp84_;
	GtkLabel* _tmp85_;
	GtkStyleContext* _tmp86_;
	FeedReaderMediaType _tmp87_;
	GtkBox* _tmp89_;
#line 75 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 77 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = gst_element_factory_make ("gtksink", "sink");
#line 77 "../src/Widgets/MediaPlayer.vala"
	if (_tmp0_ != NULL) {
#line 77 "../src/Widgets/MediaPlayer.vala"
		g_object_ref_sink (_tmp0_);
#line 649 "MediaPlayer.c"
	}
#line 77 "../src/Widgets/MediaPlayer.vala"
	gtksink = _tmp0_;
#line 78 "../src/Widgets/MediaPlayer.vala"
	_tmp1_ = gtksink;
#line 78 "../src/Widgets/MediaPlayer.vala"
	g_object_get ((GObject*) _tmp1_, "widget", &_tmp2_, NULL);
#line 78 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_videoWidget);
#line 78 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_videoWidget = _tmp2_;
#line 79 "../src/Widgets/MediaPlayer.vala"
	_tmp3_ = self->priv->m_videoWidget;
#line 79 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_margin_start (_tmp3_, self->priv->m_margin);
#line 80 "../src/Widgets/MediaPlayer.vala"
	_tmp4_ = self->priv->m_videoWidget;
#line 80 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_margin_end (_tmp4_, self->priv->m_margin);
#line 81 "../src/Widgets/MediaPlayer.vala"
	_tmp5_ = self->priv->m_videoWidget;
#line 81 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_margin_top (_tmp5_, self->priv->m_margin);
#line 82 "../src/Widgets/MediaPlayer.vala"
	_tmp6_ = self->priv->m_videoWidget;
#line 82 "../src/Widgets/MediaPlayer.vala"
	g_signal_connect_object (_tmp6_, "size-allocate", (GCallback) _feed_reader_media_player_onAllocation_gtk_widget_size_allocate, self, 0);
#line 84 "../src/Widgets/MediaPlayer.vala"
	_tmp7_ = gst_element_factory_make ("playbin", "player");
#line 84 "../src/Widgets/MediaPlayer.vala"
	if (_tmp7_ != NULL) {
#line 84 "../src/Widgets/MediaPlayer.vala"
		g_object_ref_sink (_tmp7_);
#line 683 "MediaPlayer.c"
	}
#line 84 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_player);
#line 84 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_player = _tmp7_;
#line 85 "../src/Widgets/MediaPlayer.vala"
	_tmp8_ = self->priv->m_player;
#line 85 "../src/Widgets/MediaPlayer.vala"
	_tmp9_ = gtksink;
#line 85 "../src/Widgets/MediaPlayer.vala"
	g_object_set ((GObject*) _tmp8_, "video_sink", _tmp9_, NULL);
#line 86 "../src/Widgets/MediaPlayer.vala"
	_tmp10_ = self->priv->m_player;
#line 86 "../src/Widgets/MediaPlayer.vala"
	g_object_set ((GObject*) _tmp10_, "volume", 1.0, NULL);
#line 87 "../src/Widgets/MediaPlayer.vala"
	_tmp11_ = self->priv->m_player;
#line 87 "../src/Widgets/MediaPlayer.vala"
	_tmp12_ = self->priv->m_URL;
#line 87 "../src/Widgets/MediaPlayer.vala"
	g_object_set ((GObject*) _tmp11_, "uri", _tmp12_, NULL);
#line 89 "../src/Widgets/MediaPlayer.vala"
	_tmp13_ = self->priv->m_player;
#line 89 "../src/Widgets/MediaPlayer.vala"
	_tmp14_ = gst_element_get_bus (_tmp13_);
#line 89 "../src/Widgets/MediaPlayer.vala"
	bus = _tmp14_;
#line 90 "../src/Widgets/MediaPlayer.vala"
	_tmp15_ = bus;
#line 90 "../src/Widgets/MediaPlayer.vala"
	gst_bus_add_watch_full (_tmp15_, G_PRIORITY_LOW, _feed_reader_media_player_busCallback_gst_bus_func, g_object_ref (self), g_object_unref);
#line 92 "../src/Widgets/MediaPlayer.vala"
	g_timeout_add_full (G_PRIORITY_LOW, (guint) 500, ___lambda95__gsource_func, g_object_ref (self), g_object_unref);
#line 114 "../src/Widgets/MediaPlayer.vala"
	_tmp16_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playback-start-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 114 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp16_);
#line 114 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_playIcon);
#line 114 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_playIcon = _tmp16_;
#line 115 "../src/Widgets/MediaPlayer.vala"
	_tmp17_ = (GtkImage*) gtk_image_new_from_icon_name ("media-playback-pause-symbolic", (GtkIconSize) GTK_ICON_SIZE_LARGE_TOOLBAR);
#line 115 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp17_);
#line 115 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_pauseIcon);
#line 115 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_pauseIcon = _tmp17_;
#line 116 "../src/Widgets/MediaPlayer.vala"
	_tmp18_ = (GtkImage*) gtk_image_new_from_icon_name ("audio-volume-muted-symbolic", (GtkIconSize) GTK_ICON_SIZE_DND);
#line 116 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp18_);
#line 116 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_muteIcon);
#line 116 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_muteIcon = _tmp18_;
#line 117 "../src/Widgets/MediaPlayer.vala"
	_tmp19_ = (GtkImage*) gtk_image_new_from_icon_name ("audio-volume-high-symbolic", (GtkIconSize) GTK_ICON_SIZE_DND);
#line 117 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp19_);
#line 117 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_noiseIcon);
#line 117 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_noiseIcon = _tmp19_;
#line 118 "../src/Widgets/MediaPlayer.vala"
	_tmp20_ = (GtkImage*) gtk_image_new_from_icon_name ("window-close-symbolic", (GtkIconSize) GTK_ICON_SIZE_SMALL_TOOLBAR);
#line 118 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp20_);
#line 118 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_closeIcon);
#line 118 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_closeIcon = _tmp20_;
#line 120 "../src/Widgets/MediaPlayer.vala"
	_tmp21_ = (GtkButton*) gtk_button_new ();
#line 120 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp21_);
#line 120 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_playButton);
#line 120 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_playButton = _tmp21_;
#line 121 "../src/Widgets/MediaPlayer.vala"
	_tmp22_ = self->priv->m_playButton;
#line 121 "../src/Widgets/MediaPlayer.vala"
	_tmp23_ = self->priv->m_playIcon;
#line 121 "../src/Widgets/MediaPlayer.vala"
	gtk_button_set_image (_tmp22_, (GtkWidget*) _tmp23_);
#line 122 "../src/Widgets/MediaPlayer.vala"
	_tmp24_ = self->priv->m_playButton;
#line 122 "../src/Widgets/MediaPlayer.vala"
	g_signal_connect_object (_tmp24_, "clicked", (GCallback) _feed_reader_media_player_togglePause_gtk_button_clicked, self, 0);
#line 123 "../src/Widgets/MediaPlayer.vala"
	_tmp25_ = self->priv->m_playButton;
#line 123 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp25_, FEED_READER_MEDIA_BUTTON_PLAY);
#line 124 "../src/Widgets/MediaPlayer.vala"
	_tmp26_ = self->priv->m_playButton;
#line 124 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp26_, GTK_ALIGN_CENTER);
#line 125 "../src/Widgets/MediaPlayer.vala"
	_tmp27_ = self->priv->m_playButton;
#line 125 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp27_, GTK_ALIGN_CENTER);
#line 126 "../src/Widgets/MediaPlayer.vala"
	_tmp28_ = self->priv->m_playButton;
#line 126 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp28_, 48, 48);
#line 128 "../src/Widgets/MediaPlayer.vala"
	_tmp29_ = (GtkSpinner*) gtk_spinner_new ();
#line 128 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp29_);
#line 128 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_playSpinner);
#line 128 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_playSpinner = _tmp29_;
#line 129 "../src/Widgets/MediaPlayer.vala"
	_tmp30_ = (GtkStack*) gtk_stack_new ();
#line 129 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp30_);
#line 129 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_playStack);
#line 129 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_playStack = _tmp30_;
#line 130 "../src/Widgets/MediaPlayer.vala"
	_tmp31_ = self->priv->m_playStack;
#line 130 "../src/Widgets/MediaPlayer.vala"
	_tmp32_ = self->priv->m_playButton;
#line 130 "../src/Widgets/MediaPlayer.vala"
	gtk_stack_add_named (_tmp31_, (GtkWidget*) _tmp32_, "button");
#line 131 "../src/Widgets/MediaPlayer.vala"
	_tmp33_ = self->priv->m_playStack;
#line 131 "../src/Widgets/MediaPlayer.vala"
	_tmp34_ = self->priv->m_playSpinner;
#line 131 "../src/Widgets/MediaPlayer.vala"
	gtk_stack_add_named (_tmp33_, (GtkWidget*) _tmp34_, "spinner");
#line 132 "../src/Widgets/MediaPlayer.vala"
	_tmp35_ = self->priv->m_playStack;
#line 132 "../src/Widgets/MediaPlayer.vala"
	gtk_stack_set_visible_child_name (_tmp35_, "button");
#line 134 "../src/Widgets/MediaPlayer.vala"
	_tmp36_ = (GtkButton*) gtk_button_new ();
#line 134 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp36_);
#line 134 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_muteButton);
#line 134 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_muteButton = _tmp36_;
#line 135 "../src/Widgets/MediaPlayer.vala"
	_tmp37_ = self->priv->m_muteButton;
#line 135 "../src/Widgets/MediaPlayer.vala"
	_tmp38_ = self->priv->m_noiseIcon;
#line 135 "../src/Widgets/MediaPlayer.vala"
	gtk_button_set_image (_tmp37_, (GtkWidget*) _tmp38_);
#line 136 "../src/Widgets/MediaPlayer.vala"
	_tmp39_ = self->priv->m_muteButton;
#line 136 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp39_, FEED_READER_MEDIA_BUTTON_MUTE);
#line 137 "../src/Widgets/MediaPlayer.vala"
	_tmp40_ = self->priv->m_muteButton;
#line 137 "../src/Widgets/MediaPlayer.vala"
	g_signal_connect_object (_tmp40_, "clicked", (GCallback) _feed_reader_media_player_toggleMute_gtk_button_clicked, self, 0);
#line 138 "../src/Widgets/MediaPlayer.vala"
	_tmp41_ = self->priv->m_muteButton;
#line 138 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp41_, GTK_ALIGN_CENTER);
#line 139 "../src/Widgets/MediaPlayer.vala"
	_tmp42_ = self->priv->m_muteButton;
#line 139 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp42_, GTK_ALIGN_CENTER);
#line 140 "../src/Widgets/MediaPlayer.vala"
	_tmp43_ = self->priv->m_muteButton;
#line 140 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp43_, 48, 48);
#line 142 "../src/Widgets/MediaPlayer.vala"
	_tmp44_ = (GtkButton*) gtk_button_new ();
#line 142 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp44_);
#line 142 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_closeButton);
#line 142 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_closeButton = _tmp44_;
#line 143 "../src/Widgets/MediaPlayer.vala"
	_tmp45_ = self->priv->m_closeButton;
#line 143 "../src/Widgets/MediaPlayer.vala"
	_tmp46_ = self->priv->m_closeIcon;
#line 143 "../src/Widgets/MediaPlayer.vala"
	gtk_button_set_image (_tmp45_, (GtkWidget*) _tmp46_);
#line 144 "../src/Widgets/MediaPlayer.vala"
	_tmp47_ = self->priv->m_closeButton;
#line 144 "../src/Widgets/MediaPlayer.vala"
	g_signal_connect_object (_tmp47_, "clicked", (GCallback) ___lambda96__gtk_button_clicked, self, 0);
#line 147 "../src/Widgets/MediaPlayer.vala"
	_tmp48_ = self->priv->m_closeButton;
#line 147 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp48_, FEED_READER_MEDIA_BUTTON_CLOSE);
#line 148 "../src/Widgets/MediaPlayer.vala"
	_tmp49_ = self->priv->m_closeButton;
#line 148 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp49_, GTK_ALIGN_CENTER);
#line 149 "../src/Widgets/MediaPlayer.vala"
	_tmp50_ = self->priv->m_closeButton;
#line 149 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp50_, GTK_ALIGN_CENTER);
#line 150 "../src/Widgets/MediaPlayer.vala"
	_tmp51_ = self->priv->m_closeButton;
#line 150 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp51_, 48, 48);
#line 152 "../src/Widgets/MediaPlayer.vala"
	_tmp52_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, 0.0, 100.0, 5.0);
#line 152 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp52_);
#line 152 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_scale);
#line 152 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_scale = _tmp52_;
#line 153 "../src/Widgets/MediaPlayer.vala"
	_tmp53_ = self->priv->m_scale;
#line 153 "../src/Widgets/MediaPlayer.vala"
	gtk_scale_set_draw_value (_tmp53_, FALSE);
#line 154 "../src/Widgets/MediaPlayer.vala"
	_tmp54_ = self->priv->m_scale;
#line 154 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp54_, 200, 48);
#line 155 "../src/Widgets/MediaPlayer.vala"
	_tmp55_ = self->priv->m_scale;
#line 155 "../src/Widgets/MediaPlayer.vala"
	g_signal_connect_object ((GtkRange*) _tmp55_, "change-value", (GCallback) _feed_reader_media_player_valueChanged_gtk_range_change_value, self, 0);
#line 157 "../src/Widgets/MediaPlayer.vala"
	_tmp56_ = (GtkButton*) gtk_button_new_with_label ("00:00");
#line 157 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp56_);
#line 157 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_labelButton);
#line 157 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_labelButton = _tmp56_;
#line 158 "../src/Widgets/MediaPlayer.vala"
	_tmp57_ = self->priv->m_labelButton;
#line 158 "../src/Widgets/MediaPlayer.vala"
	gtk_button_set_relief (_tmp57_, GTK_RELIEF_NONE);
#line 159 "../src/Widgets/MediaPlayer.vala"
	_tmp58_ = self->priv->m_labelButton;
#line 159 "../src/Widgets/MediaPlayer.vala"
	_tmp59_ = gtk_widget_get_style_context ((GtkWidget*) _tmp58_);
#line 159 "../src/Widgets/MediaPlayer.vala"
	gtk_style_context_add_class (_tmp59_, "h3");
#line 160 "../src/Widgets/MediaPlayer.vala"
	_tmp60_ = self->priv->m_labelButton;
#line 160 "../src/Widgets/MediaPlayer.vala"
	g_signal_connect_object (_tmp60_, "clicked", (GCallback) _feed_reader_media_player_switchDisplay_gtk_button_clicked, self, 0);
#line 161 "../src/Widgets/MediaPlayer.vala"
	_tmp61_ = self->priv->m_labelButton;
#line 161 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp61_, GTK_ALIGN_CENTER);
#line 162 "../src/Widgets/MediaPlayer.vala"
	_tmp62_ = self->priv->m_labelButton;
#line 162 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp62_, GTK_ALIGN_CENTER);
#line 163 "../src/Widgets/MediaPlayer.vala"
	_tmp63_ = self->priv->m_labelButton;
#line 163 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp63_, 48, 48);
#line 165 "../src/Widgets/MediaPlayer.vala"
	_tmp64_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 10);
#line 165 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp64_);
#line 165 "../src/Widgets/MediaPlayer.vala"
	hBox = _tmp64_;
#line 166 "../src/Widgets/MediaPlayer.vala"
	_tmp65_ = hBox;
#line 166 "../src/Widgets/MediaPlayer.vala"
	g_object_set ((GtkWidget*) _tmp65_, "margin", self->priv->m_margin, NULL);
#line 167 "../src/Widgets/MediaPlayer.vala"
	_tmp66_ = hBox;
#line 167 "../src/Widgets/MediaPlayer.vala"
	_tmp67_ = self->priv->m_playStack;
#line 167 "../src/Widgets/MediaPlayer.vala"
	gtk_box_pack_start (_tmp66_, (GtkWidget*) _tmp67_, FALSE, FALSE, (guint) 0);
#line 168 "../src/Widgets/MediaPlayer.vala"
	_tmp68_ = hBox;
#line 168 "../src/Widgets/MediaPlayer.vala"
	_tmp69_ = self->priv->m_muteButton;
#line 168 "../src/Widgets/MediaPlayer.vala"
	gtk_box_pack_start (_tmp68_, (GtkWidget*) _tmp69_, FALSE, FALSE, (guint) 0);
#line 169 "../src/Widgets/MediaPlayer.vala"
	_tmp70_ = hBox;
#line 169 "../src/Widgets/MediaPlayer.vala"
	_tmp71_ = self->priv->m_scale;
#line 169 "../src/Widgets/MediaPlayer.vala"
	gtk_box_pack_start (_tmp70_, (GtkWidget*) _tmp71_, TRUE, TRUE, (guint) 0);
#line 170 "../src/Widgets/MediaPlayer.vala"
	_tmp72_ = hBox;
#line 170 "../src/Widgets/MediaPlayer.vala"
	_tmp73_ = self->priv->m_labelButton;
#line 170 "../src/Widgets/MediaPlayer.vala"
	gtk_box_pack_start (_tmp72_, (GtkWidget*) _tmp73_, FALSE, FALSE, (guint) 0);
#line 171 "../src/Widgets/MediaPlayer.vala"
	_tmp74_ = hBox;
#line 171 "../src/Widgets/MediaPlayer.vala"
	_tmp75_ = self->priv->m_closeButton;
#line 171 "../src/Widgets/MediaPlayer.vala"
	gtk_box_pack_start (_tmp74_, (GtkWidget*) _tmp75_, FALSE, FALSE, (guint) 0);
#line 173 "../src/Widgets/MediaPlayer.vala"
	_tmp76_ = (GtkLabel*) gtk_label_new ("0%");
#line 173 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp76_);
#line 173 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_bufferLabel);
#line 173 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_bufferLabel = _tmp76_;
#line 174 "../src/Widgets/MediaPlayer.vala"
	_tmp77_ = self->priv->m_bufferLabel;
#line 174 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp77_, GTK_ALIGN_CENTER);
#line 175 "../src/Widgets/MediaPlayer.vala"
	_tmp78_ = self->priv->m_bufferLabel;
#line 175 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp78_, GTK_ALIGN_CENTER);
#line 176 "../src/Widgets/MediaPlayer.vala"
	_tmp79_ = self->priv->m_bufferLabel;
#line 176 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp79_, 48, 48);
#line 177 "../src/Widgets/MediaPlayer.vala"
	_tmp80_ = self->priv->m_bufferLabel;
#line 177 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp80_, TRUE);
#line 179 "../src/Widgets/MediaPlayer.vala"
	_tmp81_ = (GtkOverlay*) gtk_overlay_new ();
#line 179 "../src/Widgets/MediaPlayer.vala"
	g_object_ref_sink (_tmp81_);
#line 179 "../src/Widgets/MediaPlayer.vala"
	bufferOverlay = _tmp81_;
#line 180 "../src/Widgets/MediaPlayer.vala"
	_tmp82_ = bufferOverlay;
#line 180 "../src/Widgets/MediaPlayer.vala"
	_tmp83_ = self->priv->m_videoWidget;
#line 180 "../src/Widgets/MediaPlayer.vala"
	gtk_container_add ((GtkContainer*) _tmp82_, _tmp83_);
#line 181 "../src/Widgets/MediaPlayer.vala"
	_tmp84_ = bufferOverlay;
#line 181 "../src/Widgets/MediaPlayer.vala"
	_tmp85_ = self->priv->m_bufferLabel;
#line 181 "../src/Widgets/MediaPlayer.vala"
	gtk_overlay_add_overlay (_tmp84_, (GtkWidget*) _tmp85_);
#line 183 "../src/Widgets/MediaPlayer.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
#line 184 "../src/Widgets/MediaPlayer.vala"
	_tmp86_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 184 "../src/Widgets/MediaPlayer.vala"
	gtk_style_context_add_class (_tmp86_, "osd");
#line 185 "../src/Widgets/MediaPlayer.vala"
	g_object_set ((GtkWidget*) self, "margin", 40, NULL);
#line 186 "../src/Widgets/MediaPlayer.vala"
	_tmp87_ = self->priv->m_type;
#line 186 "../src/Widgets/MediaPlayer.vala"
	if (_tmp87_ == FEED_READER_MEDIA_TYPE_VIDEO) {
#line 1039 "MediaPlayer.c"
		GtkOverlay* _tmp88_;
#line 188 "../src/Widgets/MediaPlayer.vala"
		_tmp88_ = bufferOverlay;
#line 188 "../src/Widgets/MediaPlayer.vala"
		gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp88_, TRUE, TRUE, (guint) 0);
#line 1045 "MediaPlayer.c"
	}
#line 190 "../src/Widgets/MediaPlayer.vala"
	_tmp89_ = hBox;
#line 190 "../src/Widgets/MediaPlayer.vala"
	gtk_box_pack_start ((GtkBox*) self, (GtkWidget*) _tmp89_, FALSE, FALSE, (guint) 0);
#line 191 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_END);
#line 192 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 75 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (bufferOverlay);
#line 75 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (hBox);
#line 75 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (bus);
#line 75 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (gtksink);
#line 1063 "MediaPlayer.c"
}

static void
feed_reader_media_player_togglePause (FeedReaderMediaPlayer* self)
{
	GstState state = 0;
	GstState pending = 0;
	GstElement* _tmp0_;
	GstState _tmp1_ = 0;
	GstState _tmp2_ = 0;
	GstState _tmp3_;
#line 195 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 199 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_player;
#line 199 "../src/Widgets/MediaPlayer.vala"
	gst_element_get_state (_tmp0_, &_tmp1_, &_tmp2_, (GstClockTime) 1000);
#line 199 "../src/Widgets/MediaPlayer.vala"
	state = _tmp1_;
#line 199 "../src/Widgets/MediaPlayer.vala"
	pending = _tmp2_;
#line 201 "../src/Widgets/MediaPlayer.vala"
	_tmp3_ = state;
#line 201 "../src/Widgets/MediaPlayer.vala"
	switch (_tmp3_) {
#line 201 "../src/Widgets/MediaPlayer.vala"
		case GST_STATE_PLAYING:
#line 1091 "MediaPlayer.c"
		{
			GtkButton* _tmp4_;
			GtkImage* _tmp5_;
			GtkButton* _tmp6_;
			GstElement* _tmp7_;
#line 204 "../src/Widgets/MediaPlayer.vala"
			_tmp4_ = self->priv->m_playButton;
#line 204 "../src/Widgets/MediaPlayer.vala"
			_tmp5_ = self->priv->m_playIcon;
#line 204 "../src/Widgets/MediaPlayer.vala"
			gtk_button_set_image (_tmp4_, (GtkWidget*) _tmp5_);
#line 205 "../src/Widgets/MediaPlayer.vala"
			_tmp6_ = self->priv->m_playButton;
#line 205 "../src/Widgets/MediaPlayer.vala"
			gtk_widget_set_tooltip_text ((GtkWidget*) _tmp6_, FEED_READER_MEDIA_BUTTON_PLAY);
#line 206 "../src/Widgets/MediaPlayer.vala"
			_tmp7_ = self->priv->m_player;
#line 206 "../src/Widgets/MediaPlayer.vala"
			gst_element_set_state (_tmp7_, GST_STATE_PAUSED);
#line 207 "../src/Widgets/MediaPlayer.vala"
			break;
#line 1113 "MediaPlayer.c"
		}
		default:
#line 201 "../src/Widgets/MediaPlayer.vala"
		case GST_STATE_PAUSED:
#line 201 "../src/Widgets/MediaPlayer.vala"
		case GST_STATE_READY:
#line 1120 "MediaPlayer.c"
		{
			GtkButton* _tmp8_;
			GtkImage* _tmp9_;
			GtkButton* _tmp10_;
			GstElement* _tmp11_;
#line 212 "../src/Widgets/MediaPlayer.vala"
			_tmp8_ = self->priv->m_playButton;
#line 212 "../src/Widgets/MediaPlayer.vala"
			_tmp9_ = self->priv->m_pauseIcon;
#line 212 "../src/Widgets/MediaPlayer.vala"
			gtk_button_set_image (_tmp8_, (GtkWidget*) _tmp9_);
#line 213 "../src/Widgets/MediaPlayer.vala"
			_tmp10_ = self->priv->m_playButton;
#line 213 "../src/Widgets/MediaPlayer.vala"
			gtk_widget_set_tooltip_text ((GtkWidget*) _tmp10_, FEED_READER_MEDIA_BUTTON_PAUSE);
#line 214 "../src/Widgets/MediaPlayer.vala"
			_tmp11_ = self->priv->m_player;
#line 214 "../src/Widgets/MediaPlayer.vala"
			gst_element_set_state (_tmp11_, GST_STATE_PLAYING);
#line 215 "../src/Widgets/MediaPlayer.vala"
			break;
#line 1142 "MediaPlayer.c"
		}
	}
#line 218 "../src/Widgets/MediaPlayer.vala"
	if (self->priv->m_muted) {
#line 1147 "MediaPlayer.c"
		GstElement* _tmp12_;
#line 220 "../src/Widgets/MediaPlayer.vala"
		_tmp12_ = self->priv->m_player;
#line 220 "../src/Widgets/MediaPlayer.vala"
		g_object_set ((GObject*) _tmp12_, "volume", 0.0, NULL);
#line 1153 "MediaPlayer.c"
	} else {
		GstElement* _tmp13_;
#line 224 "../src/Widgets/MediaPlayer.vala"
		_tmp13_ = self->priv->m_player;
#line 224 "../src/Widgets/MediaPlayer.vala"
		g_object_set ((GObject*) _tmp13_, "volume", 1.0, NULL);
#line 1160 "MediaPlayer.c"
	}
}

static void
feed_reader_media_player_switchDisplay (FeedReaderMediaPlayer* self)
{
	FeedReaderDisplayPosition _tmp0_;
#line 228 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 230 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_display;
#line 230 "../src/Widgets/MediaPlayer.vala"
	switch (_tmp0_) {
#line 230 "../src/Widgets/MediaPlayer.vala"
		case FEED_READER_DISPLAY_POSITION_ALL:
#line 1176 "MediaPlayer.c"
		{
#line 233 "../src/Widgets/MediaPlayer.vala"
			self->priv->m_display = FEED_READER_DISPLAY_POSITION_POS;
#line 234 "../src/Widgets/MediaPlayer.vala"
			break;
#line 1182 "MediaPlayer.c"
		}
#line 230 "../src/Widgets/MediaPlayer.vala"
		case FEED_READER_DISPLAY_POSITION_POS:
#line 1186 "MediaPlayer.c"
		{
#line 237 "../src/Widgets/MediaPlayer.vala"
			self->priv->m_display = FEED_READER_DISPLAY_POSITION_LEFT;
#line 238 "../src/Widgets/MediaPlayer.vala"
			break;
#line 1192 "MediaPlayer.c"
		}
#line 230 "../src/Widgets/MediaPlayer.vala"
		case FEED_READER_DISPLAY_POSITION_LEFT:
#line 1196 "MediaPlayer.c"
		{
#line 241 "../src/Widgets/MediaPlayer.vala"
			self->priv->m_display = FEED_READER_DISPLAY_POSITION_ALL;
#line 242 "../src/Widgets/MediaPlayer.vala"
			break;
#line 1202 "MediaPlayer.c"
		}
		default:
#line 230 "../src/Widgets/MediaPlayer.vala"
		break;
#line 1207 "MediaPlayer.c"
	}
#line 244 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_calcTime (self);
#line 1211 "MediaPlayer.c"
}

static gdouble*
_double_dup (gdouble* self)
{
	gdouble* dup;
#line 258 "../src/Widgets/MediaPlayer.vala"
	dup = g_new0 (gdouble, 1);
#line 258 "../src/Widgets/MediaPlayer.vala"
	memcpy (dup, self, sizeof (gdouble));
#line 258 "../src/Widgets/MediaPlayer.vala"
	return dup;
#line 1224 "MediaPlayer.c"
}

static gpointer
__double_dup0 (gpointer self)
{
#line 258 "../src/Widgets/MediaPlayer.vala"
	return self ? _double_dup (self) : NULL;
#line 1232 "MediaPlayer.c"
}

static void
feed_reader_media_player_calcTime (FeedReaderMediaPlayer* self)
{
	gint64 pos = 0LL;
	gint64 dur = 0LL;
	GstElement* _tmp0_;
	gint64 _tmp1_ = 0LL;
	GstElement* _tmp2_;
	gint64 _tmp3_ = 0LL;
	gdouble position = 0.0;
	gdouble duration = 0.0;
	gdouble* sd = NULL;
	gdouble* _tmp4_;
	gdouble* md = NULL;
	gdouble* hd = NULL;
	gdouble* _tmp5_;
	gdouble* sp = NULL;
	gdouble* _tmp21_;
	gdouble* mp = NULL;
	gdouble* hp = NULL;
	gdouble* _tmp22_;
	gdouble* sr = NULL;
	gdouble _tmp38_;
	gdouble* _tmp39_;
	gdouble* mr = NULL;
	gdouble* hr = NULL;
	gdouble* _tmp40_;
	gchar* pLabel = NULL;
	gchar* _tmp56_;
	const gchar* _tmp57_ = NULL;
	gdouble* _tmp58_;
	const gchar* _tmp65_ = NULL;
	gdouble* _tmp66_;
	const gchar* _tmp73_ = NULL;
	gdouble* _tmp74_;
	const gchar* _tmp81_;
	gdouble* _tmp82_;
	gchar* _tmp83_;
	gchar* _tmp84_;
	gchar* _tmp85_;
	gchar* dLabel = NULL;
	gchar* _tmp86_;
	const gchar* _tmp87_ = NULL;
	gdouble* _tmp88_;
	const gchar* _tmp95_ = NULL;
	gdouble* _tmp96_;
	const gchar* _tmp103_ = NULL;
	gdouble* _tmp104_;
	const gchar* _tmp111_;
	gdouble* _tmp112_;
	gchar* _tmp113_;
	gchar* _tmp114_;
	gchar* _tmp115_;
	gchar* rLabel = NULL;
	gchar* _tmp116_;
	const gchar* _tmp117_ = NULL;
	gdouble* _tmp118_;
	const gchar* _tmp125_ = NULL;
	gdouble* _tmp126_;
	const gchar* _tmp133_ = NULL;
	gdouble* _tmp134_;
	const gchar* _tmp141_;
	gdouble* _tmp142_;
	gchar* _tmp143_;
	gchar* _tmp144_;
	gchar* _tmp145_;
	FeedReaderDisplayPosition _tmp148_;
#line 247 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 251 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_player;
#line 251 "../src/Widgets/MediaPlayer.vala"
	gst_element_query_position (_tmp0_, GST_FORMAT_TIME, &_tmp1_);
#line 251 "../src/Widgets/MediaPlayer.vala"
	pos = _tmp1_;
#line 252 "../src/Widgets/MediaPlayer.vala"
	_tmp2_ = self->priv->m_player;
#line 252 "../src/Widgets/MediaPlayer.vala"
	gst_element_query_duration (_tmp2_, GST_FORMAT_TIME, &_tmp3_);
#line 252 "../src/Widgets/MediaPlayer.vala"
	dur = _tmp3_;
#line 253 "../src/Widgets/MediaPlayer.vala"
	position = (gdouble) ((gint) (((gdouble) pos) / 1000000000));
#line 254 "../src/Widgets/MediaPlayer.vala"
	duration = (gdouble) ((gint) (((gdouble) dur) / 1000000000));
#line 258 "../src/Widgets/MediaPlayer.vala"
	_tmp4_ = __double_dup0 (&duration);
#line 258 "../src/Widgets/MediaPlayer.vala"
	sd = _tmp4_;
#line 259 "../src/Widgets/MediaPlayer.vala"
	md = NULL;
#line 260 "../src/Widgets/MediaPlayer.vala"
	hd = NULL;
#line 262 "../src/Widgets/MediaPlayer.vala"
	_tmp5_ = sd;
#line 262 "../src/Widgets/MediaPlayer.vala"
	if (((gint) (*_tmp5_)) >= 60) {
#line 1332 "MediaPlayer.c"
		gdouble* _tmp6_;
		gdouble _tmp7_;
		gdouble* _tmp8_;
		gdouble* _tmp9_;
		gdouble* _tmp10_;
		gdouble _tmp11_;
		gdouble* _tmp12_;
		gdouble* _tmp13_;
#line 264 "../src/Widgets/MediaPlayer.vala"
		_tmp6_ = sd;
#line 264 "../src/Widgets/MediaPlayer.vala"
		_tmp7_ = (gdouble) ((gint) ((*_tmp6_) / 60));
#line 264 "../src/Widgets/MediaPlayer.vala"
		_tmp8_ = __double_dup0 (&_tmp7_);
#line 264 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (md);
#line 264 "../src/Widgets/MediaPlayer.vala"
		md = _tmp8_;
#line 265 "../src/Widgets/MediaPlayer.vala"
		_tmp9_ = sd;
#line 265 "../src/Widgets/MediaPlayer.vala"
		_tmp10_ = md;
#line 265 "../src/Widgets/MediaPlayer.vala"
		_tmp11_ = (*_tmp9_) - ((*_tmp10_) * 60);
#line 265 "../src/Widgets/MediaPlayer.vala"
		_tmp12_ = __double_dup0 (&_tmp11_);
#line 265 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (sd);
#line 265 "../src/Widgets/MediaPlayer.vala"
		sd = _tmp12_;
#line 267 "../src/Widgets/MediaPlayer.vala"
		_tmp13_ = md;
#line 267 "../src/Widgets/MediaPlayer.vala"
		if (((gint) (*_tmp13_)) >= 60) {
#line 1367 "MediaPlayer.c"
			gdouble* _tmp14_;
			gdouble _tmp15_;
			gdouble* _tmp16_;
			gdouble* _tmp17_;
			gdouble* _tmp18_;
			gdouble _tmp19_;
			gdouble* _tmp20_;
#line 269 "../src/Widgets/MediaPlayer.vala"
			_tmp14_ = md;
#line 269 "../src/Widgets/MediaPlayer.vala"
			_tmp15_ = (gdouble) ((gint) ((*_tmp14_) / 60));
#line 269 "../src/Widgets/MediaPlayer.vala"
			_tmp16_ = __double_dup0 (&_tmp15_);
#line 269 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (hd);
#line 269 "../src/Widgets/MediaPlayer.vala"
			hd = _tmp16_;
#line 270 "../src/Widgets/MediaPlayer.vala"
			_tmp17_ = md;
#line 270 "../src/Widgets/MediaPlayer.vala"
			_tmp18_ = hd;
#line 270 "../src/Widgets/MediaPlayer.vala"
			_tmp19_ = (*_tmp17_) - ((*_tmp18_) * 60);
#line 270 "../src/Widgets/MediaPlayer.vala"
			_tmp20_ = __double_dup0 (&_tmp19_);
#line 270 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (md);
#line 270 "../src/Widgets/MediaPlayer.vala"
			md = _tmp20_;
#line 1397 "MediaPlayer.c"
		}
	}
#line 274 "../src/Widgets/MediaPlayer.vala"
	_tmp21_ = __double_dup0 (&position);
#line 274 "../src/Widgets/MediaPlayer.vala"
	sp = _tmp21_;
#line 275 "../src/Widgets/MediaPlayer.vala"
	mp = NULL;
#line 276 "../src/Widgets/MediaPlayer.vala"
	hp = NULL;
#line 278 "../src/Widgets/MediaPlayer.vala"
	_tmp22_ = sp;
#line 278 "../src/Widgets/MediaPlayer.vala"
	if (((gint) (*_tmp22_)) >= 60) {
#line 1412 "MediaPlayer.c"
		gdouble* _tmp23_;
		gdouble _tmp24_;
		gdouble* _tmp25_;
		gdouble* _tmp26_;
		gdouble* _tmp27_;
		gdouble _tmp28_;
		gdouble* _tmp29_;
		gdouble* _tmp30_;
#line 280 "../src/Widgets/MediaPlayer.vala"
		_tmp23_ = sp;
#line 280 "../src/Widgets/MediaPlayer.vala"
		_tmp24_ = (gdouble) ((gint) ((*_tmp23_) / 60));
#line 280 "../src/Widgets/MediaPlayer.vala"
		_tmp25_ = __double_dup0 (&_tmp24_);
#line 280 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (mp);
#line 280 "../src/Widgets/MediaPlayer.vala"
		mp = _tmp25_;
#line 281 "../src/Widgets/MediaPlayer.vala"
		_tmp26_ = sp;
#line 281 "../src/Widgets/MediaPlayer.vala"
		_tmp27_ = mp;
#line 281 "../src/Widgets/MediaPlayer.vala"
		_tmp28_ = (*_tmp26_) - ((*_tmp27_) * 60);
#line 281 "../src/Widgets/MediaPlayer.vala"
		_tmp29_ = __double_dup0 (&_tmp28_);
#line 281 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (sp);
#line 281 "../src/Widgets/MediaPlayer.vala"
		sp = _tmp29_;
#line 283 "../src/Widgets/MediaPlayer.vala"
		_tmp30_ = mp;
#line 283 "../src/Widgets/MediaPlayer.vala"
		if (((gint) (*_tmp30_)) >= 60) {
#line 1447 "MediaPlayer.c"
			gdouble* _tmp31_;
			gdouble _tmp32_;
			gdouble* _tmp33_;
			gdouble* _tmp34_;
			gdouble* _tmp35_;
			gdouble _tmp36_;
			gdouble* _tmp37_;
#line 285 "../src/Widgets/MediaPlayer.vala"
			_tmp31_ = mp;
#line 285 "../src/Widgets/MediaPlayer.vala"
			_tmp32_ = (gdouble) ((gint) ((*_tmp31_) / 60));
#line 285 "../src/Widgets/MediaPlayer.vala"
			_tmp33_ = __double_dup0 (&_tmp32_);
#line 285 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (hp);
#line 285 "../src/Widgets/MediaPlayer.vala"
			hp = _tmp33_;
#line 286 "../src/Widgets/MediaPlayer.vala"
			_tmp34_ = mp;
#line 286 "../src/Widgets/MediaPlayer.vala"
			_tmp35_ = hp;
#line 286 "../src/Widgets/MediaPlayer.vala"
			_tmp36_ = (*_tmp34_) - ((*_tmp35_) * 60);
#line 286 "../src/Widgets/MediaPlayer.vala"
			_tmp37_ = __double_dup0 (&_tmp36_);
#line 286 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (mp);
#line 286 "../src/Widgets/MediaPlayer.vala"
			mp = _tmp37_;
#line 1477 "MediaPlayer.c"
		}
	}
#line 290 "../src/Widgets/MediaPlayer.vala"
	_tmp38_ = duration - position;
#line 290 "../src/Widgets/MediaPlayer.vala"
	_tmp39_ = __double_dup0 (&_tmp38_);
#line 290 "../src/Widgets/MediaPlayer.vala"
	sr = _tmp39_;
#line 291 "../src/Widgets/MediaPlayer.vala"
	mr = NULL;
#line 292 "../src/Widgets/MediaPlayer.vala"
	hr = NULL;
#line 294 "../src/Widgets/MediaPlayer.vala"
	_tmp40_ = sr;
#line 294 "../src/Widgets/MediaPlayer.vala"
	if (((gint) (*_tmp40_)) >= 60) {
#line 1494 "MediaPlayer.c"
		gdouble* _tmp41_;
		gdouble _tmp42_;
		gdouble* _tmp43_;
		gdouble* _tmp44_;
		gdouble* _tmp45_;
		gdouble _tmp46_;
		gdouble* _tmp47_;
		gdouble* _tmp48_;
#line 296 "../src/Widgets/MediaPlayer.vala"
		_tmp41_ = sr;
#line 296 "../src/Widgets/MediaPlayer.vala"
		_tmp42_ = (gdouble) ((gint) ((*_tmp41_) / 60));
#line 296 "../src/Widgets/MediaPlayer.vala"
		_tmp43_ = __double_dup0 (&_tmp42_);
#line 296 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (mr);
#line 296 "../src/Widgets/MediaPlayer.vala"
		mr = _tmp43_;
#line 297 "../src/Widgets/MediaPlayer.vala"
		_tmp44_ = sr;
#line 297 "../src/Widgets/MediaPlayer.vala"
		_tmp45_ = mr;
#line 297 "../src/Widgets/MediaPlayer.vala"
		_tmp46_ = (*_tmp44_) - ((*_tmp45_) * 60);
#line 297 "../src/Widgets/MediaPlayer.vala"
		_tmp47_ = __double_dup0 (&_tmp46_);
#line 297 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (sr);
#line 297 "../src/Widgets/MediaPlayer.vala"
		sr = _tmp47_;
#line 299 "../src/Widgets/MediaPlayer.vala"
		_tmp48_ = mr;
#line 299 "../src/Widgets/MediaPlayer.vala"
		if (((gint) (*_tmp48_)) >= 60) {
#line 1529 "MediaPlayer.c"
			gdouble* _tmp49_;
			gdouble _tmp50_;
			gdouble* _tmp51_;
			gdouble* _tmp52_;
			gdouble* _tmp53_;
			gdouble _tmp54_;
			gdouble* _tmp55_;
#line 301 "../src/Widgets/MediaPlayer.vala"
			_tmp49_ = mr;
#line 301 "../src/Widgets/MediaPlayer.vala"
			_tmp50_ = (gdouble) ((gint) ((*_tmp49_) / 60));
#line 301 "../src/Widgets/MediaPlayer.vala"
			_tmp51_ = __double_dup0 (&_tmp50_);
#line 301 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (hr);
#line 301 "../src/Widgets/MediaPlayer.vala"
			hr = _tmp51_;
#line 302 "../src/Widgets/MediaPlayer.vala"
			_tmp52_ = mr;
#line 302 "../src/Widgets/MediaPlayer.vala"
			_tmp53_ = hr;
#line 302 "../src/Widgets/MediaPlayer.vala"
			_tmp54_ = (*_tmp52_) - ((*_tmp53_) * 60);
#line 302 "../src/Widgets/MediaPlayer.vala"
			_tmp55_ = __double_dup0 (&_tmp54_);
#line 302 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (mr);
#line 302 "../src/Widgets/MediaPlayer.vala"
			mr = _tmp55_;
#line 1559 "MediaPlayer.c"
		}
	}
#line 306 "../src/Widgets/MediaPlayer.vala"
	_tmp56_ = g_strdup ("");
#line 306 "../src/Widgets/MediaPlayer.vala"
	pLabel = _tmp56_;
#line 307 "../src/Widgets/MediaPlayer.vala"
	_tmp58_ = hp;
#line 307 "../src/Widgets/MediaPlayer.vala"
	if (_tmp58_ != NULL) {
#line 1570 "MediaPlayer.c"
		const gchar* _tmp59_;
		gdouble* _tmp60_;
		gchar* _tmp61_;
		gchar* _tmp62_;
		gchar* _tmp63_;
		const gchar* _tmp64_;
#line 307 "../src/Widgets/MediaPlayer.vala"
		_tmp59_ = pLabel;
#line 307 "../src/Widgets/MediaPlayer.vala"
		_tmp60_ = hp;
#line 307 "../src/Widgets/MediaPlayer.vala"
		_tmp61_ = g_strdup_printf ("%02.0f:", *_tmp60_);
#line 307 "../src/Widgets/MediaPlayer.vala"
		_tmp62_ = _tmp61_;
#line 307 "../src/Widgets/MediaPlayer.vala"
		_tmp63_ = g_strconcat (_tmp59_, _tmp62_, NULL);
#line 307 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (pLabel);
#line 307 "../src/Widgets/MediaPlayer.vala"
		pLabel = _tmp63_;
#line 307 "../src/Widgets/MediaPlayer.vala"
		_tmp64_ = pLabel;
#line 307 "../src/Widgets/MediaPlayer.vala"
		_tmp57_ = _tmp64_;
#line 307 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (_tmp62_);
#line 1597 "MediaPlayer.c"
	} else {
#line 307 "../src/Widgets/MediaPlayer.vala"
		_tmp57_ = NULL;
#line 1601 "MediaPlayer.c"
	}
#line 308 "../src/Widgets/MediaPlayer.vala"
	_tmp66_ = mp;
#line 308 "../src/Widgets/MediaPlayer.vala"
	if (_tmp66_ != NULL) {
#line 1607 "MediaPlayer.c"
		const gchar* _tmp67_;
		gdouble* _tmp68_;
		gchar* _tmp69_;
		gchar* _tmp70_;
		gchar* _tmp71_;
		const gchar* _tmp72_;
#line 308 "../src/Widgets/MediaPlayer.vala"
		_tmp67_ = pLabel;
#line 308 "../src/Widgets/MediaPlayer.vala"
		_tmp68_ = mp;
#line 308 "../src/Widgets/MediaPlayer.vala"
		_tmp69_ = g_strdup_printf ("%02.0f", *_tmp68_);
#line 308 "../src/Widgets/MediaPlayer.vala"
		_tmp70_ = _tmp69_;
#line 308 "../src/Widgets/MediaPlayer.vala"
		_tmp71_ = g_strconcat (_tmp67_, _tmp70_, NULL);
#line 308 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (pLabel);
#line 308 "../src/Widgets/MediaPlayer.vala"
		pLabel = _tmp71_;
#line 308 "../src/Widgets/MediaPlayer.vala"
		_tmp72_ = pLabel;
#line 308 "../src/Widgets/MediaPlayer.vala"
		_tmp65_ = _tmp72_;
#line 308 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (_tmp70_);
#line 1634 "MediaPlayer.c"
	} else {
#line 308 "../src/Widgets/MediaPlayer.vala"
		_tmp65_ = NULL;
#line 1638 "MediaPlayer.c"
	}
#line 309 "../src/Widgets/MediaPlayer.vala"
	_tmp74_ = mp;
#line 309 "../src/Widgets/MediaPlayer.vala"
	if (_tmp74_ != NULL) {
#line 1644 "MediaPlayer.c"
		const gchar* _tmp75_;
		gchar* _tmp76_;
		const gchar* _tmp77_;
#line 309 "../src/Widgets/MediaPlayer.vala"
		_tmp75_ = pLabel;
#line 309 "../src/Widgets/MediaPlayer.vala"
		_tmp76_ = g_strconcat (_tmp75_, ":", NULL);
#line 309 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (pLabel);
#line 309 "../src/Widgets/MediaPlayer.vala"
		pLabel = _tmp76_;
#line 309 "../src/Widgets/MediaPlayer.vala"
		_tmp77_ = pLabel;
#line 309 "../src/Widgets/MediaPlayer.vala"
		_tmp73_ = _tmp77_;
#line 1660 "MediaPlayer.c"
	} else {
		const gchar* _tmp78_;
		gchar* _tmp79_;
		const gchar* _tmp80_;
#line 309 "../src/Widgets/MediaPlayer.vala"
		_tmp78_ = pLabel;
#line 309 "../src/Widgets/MediaPlayer.vala"
		_tmp79_ = g_strconcat (_tmp78_, "0:", NULL);
#line 309 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (pLabel);
#line 309 "../src/Widgets/MediaPlayer.vala"
		pLabel = _tmp79_;
#line 309 "../src/Widgets/MediaPlayer.vala"
		_tmp80_ = pLabel;
#line 309 "../src/Widgets/MediaPlayer.vala"
		_tmp73_ = _tmp80_;
#line 1677 "MediaPlayer.c"
	}
#line 310 "../src/Widgets/MediaPlayer.vala"
	_tmp81_ = pLabel;
#line 310 "../src/Widgets/MediaPlayer.vala"
	_tmp82_ = sp;
#line 310 "../src/Widgets/MediaPlayer.vala"
	_tmp83_ = g_strdup_printf ("%02.0f", *_tmp82_);
#line 310 "../src/Widgets/MediaPlayer.vala"
	_tmp84_ = _tmp83_;
#line 310 "../src/Widgets/MediaPlayer.vala"
	_tmp85_ = g_strconcat (_tmp81_, _tmp84_, NULL);
#line 310 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (pLabel);
#line 310 "../src/Widgets/MediaPlayer.vala"
	pLabel = _tmp85_;
#line 310 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (_tmp84_);
#line 312 "../src/Widgets/MediaPlayer.vala"
	_tmp86_ = g_strdup ("");
#line 312 "../src/Widgets/MediaPlayer.vala"
	dLabel = _tmp86_;
#line 313 "../src/Widgets/MediaPlayer.vala"
	_tmp88_ = hd;
#line 313 "../src/Widgets/MediaPlayer.vala"
	if (_tmp88_ != NULL) {
#line 1703 "MediaPlayer.c"
		const gchar* _tmp89_;
		gdouble* _tmp90_;
		gchar* _tmp91_;
		gchar* _tmp92_;
		gchar* _tmp93_;
		const gchar* _tmp94_;
#line 313 "../src/Widgets/MediaPlayer.vala"
		_tmp89_ = dLabel;
#line 313 "../src/Widgets/MediaPlayer.vala"
		_tmp90_ = hd;
#line 313 "../src/Widgets/MediaPlayer.vala"
		_tmp91_ = g_strdup_printf ("%02.0f:", *_tmp90_);
#line 313 "../src/Widgets/MediaPlayer.vala"
		_tmp92_ = _tmp91_;
#line 313 "../src/Widgets/MediaPlayer.vala"
		_tmp93_ = g_strconcat (_tmp89_, _tmp92_, NULL);
#line 313 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (dLabel);
#line 313 "../src/Widgets/MediaPlayer.vala"
		dLabel = _tmp93_;
#line 313 "../src/Widgets/MediaPlayer.vala"
		_tmp94_ = dLabel;
#line 313 "../src/Widgets/MediaPlayer.vala"
		_tmp87_ = _tmp94_;
#line 313 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (_tmp92_);
#line 1730 "MediaPlayer.c"
	} else {
#line 313 "../src/Widgets/MediaPlayer.vala"
		_tmp87_ = NULL;
#line 1734 "MediaPlayer.c"
	}
#line 314 "../src/Widgets/MediaPlayer.vala"
	_tmp96_ = md;
#line 314 "../src/Widgets/MediaPlayer.vala"
	if (_tmp96_ != NULL) {
#line 1740 "MediaPlayer.c"
		const gchar* _tmp97_;
		gdouble* _tmp98_;
		gchar* _tmp99_;
		gchar* _tmp100_;
		gchar* _tmp101_;
		const gchar* _tmp102_;
#line 314 "../src/Widgets/MediaPlayer.vala"
		_tmp97_ = dLabel;
#line 314 "../src/Widgets/MediaPlayer.vala"
		_tmp98_ = md;
#line 314 "../src/Widgets/MediaPlayer.vala"
		_tmp99_ = g_strdup_printf ("%02.0f", *_tmp98_);
#line 314 "../src/Widgets/MediaPlayer.vala"
		_tmp100_ = _tmp99_;
#line 314 "../src/Widgets/MediaPlayer.vala"
		_tmp101_ = g_strconcat (_tmp97_, _tmp100_, NULL);
#line 314 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (dLabel);
#line 314 "../src/Widgets/MediaPlayer.vala"
		dLabel = _tmp101_;
#line 314 "../src/Widgets/MediaPlayer.vala"
		_tmp102_ = dLabel;
#line 314 "../src/Widgets/MediaPlayer.vala"
		_tmp95_ = _tmp102_;
#line 314 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (_tmp100_);
#line 1767 "MediaPlayer.c"
	} else {
#line 314 "../src/Widgets/MediaPlayer.vala"
		_tmp95_ = NULL;
#line 1771 "MediaPlayer.c"
	}
#line 315 "../src/Widgets/MediaPlayer.vala"
	_tmp104_ = md;
#line 315 "../src/Widgets/MediaPlayer.vala"
	if (_tmp104_ != NULL) {
#line 1777 "MediaPlayer.c"
		const gchar* _tmp105_;
		gchar* _tmp106_;
		const gchar* _tmp107_;
#line 315 "../src/Widgets/MediaPlayer.vala"
		_tmp105_ = dLabel;
#line 315 "../src/Widgets/MediaPlayer.vala"
		_tmp106_ = g_strconcat (_tmp105_, ":", NULL);
#line 315 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (dLabel);
#line 315 "../src/Widgets/MediaPlayer.vala"
		dLabel = _tmp106_;
#line 315 "../src/Widgets/MediaPlayer.vala"
		_tmp107_ = dLabel;
#line 315 "../src/Widgets/MediaPlayer.vala"
		_tmp103_ = _tmp107_;
#line 1793 "MediaPlayer.c"
	} else {
		const gchar* _tmp108_;
		gchar* _tmp109_;
		const gchar* _tmp110_;
#line 315 "../src/Widgets/MediaPlayer.vala"
		_tmp108_ = dLabel;
#line 315 "../src/Widgets/MediaPlayer.vala"
		_tmp109_ = g_strconcat (_tmp108_, "0:", NULL);
#line 315 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (dLabel);
#line 315 "../src/Widgets/MediaPlayer.vala"
		dLabel = _tmp109_;
#line 315 "../src/Widgets/MediaPlayer.vala"
		_tmp110_ = dLabel;
#line 315 "../src/Widgets/MediaPlayer.vala"
		_tmp103_ = _tmp110_;
#line 1810 "MediaPlayer.c"
	}
#line 316 "../src/Widgets/MediaPlayer.vala"
	_tmp111_ = dLabel;
#line 316 "../src/Widgets/MediaPlayer.vala"
	_tmp112_ = sd;
#line 316 "../src/Widgets/MediaPlayer.vala"
	_tmp113_ = g_strdup_printf ("%02.0f", *_tmp112_);
#line 316 "../src/Widgets/MediaPlayer.vala"
	_tmp114_ = _tmp113_;
#line 316 "../src/Widgets/MediaPlayer.vala"
	_tmp115_ = g_strconcat (_tmp111_, _tmp114_, NULL);
#line 316 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (dLabel);
#line 316 "../src/Widgets/MediaPlayer.vala"
	dLabel = _tmp115_;
#line 316 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (_tmp114_);
#line 318 "../src/Widgets/MediaPlayer.vala"
	_tmp116_ = g_strdup ("-");
#line 318 "../src/Widgets/MediaPlayer.vala"
	rLabel = _tmp116_;
#line 319 "../src/Widgets/MediaPlayer.vala"
	_tmp118_ = hr;
#line 319 "../src/Widgets/MediaPlayer.vala"
	if (_tmp118_ != NULL) {
#line 1836 "MediaPlayer.c"
		const gchar* _tmp119_;
		gdouble* _tmp120_;
		gchar* _tmp121_;
		gchar* _tmp122_;
		gchar* _tmp123_;
		const gchar* _tmp124_;
#line 319 "../src/Widgets/MediaPlayer.vala"
		_tmp119_ = rLabel;
#line 319 "../src/Widgets/MediaPlayer.vala"
		_tmp120_ = hr;
#line 319 "../src/Widgets/MediaPlayer.vala"
		_tmp121_ = g_strdup_printf ("%02.0f:", *_tmp120_);
#line 319 "../src/Widgets/MediaPlayer.vala"
		_tmp122_ = _tmp121_;
#line 319 "../src/Widgets/MediaPlayer.vala"
		_tmp123_ = g_strconcat (_tmp119_, _tmp122_, NULL);
#line 319 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (rLabel);
#line 319 "../src/Widgets/MediaPlayer.vala"
		rLabel = _tmp123_;
#line 319 "../src/Widgets/MediaPlayer.vala"
		_tmp124_ = rLabel;
#line 319 "../src/Widgets/MediaPlayer.vala"
		_tmp117_ = _tmp124_;
#line 319 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (_tmp122_);
#line 1863 "MediaPlayer.c"
	} else {
#line 319 "../src/Widgets/MediaPlayer.vala"
		_tmp117_ = NULL;
#line 1867 "MediaPlayer.c"
	}
#line 320 "../src/Widgets/MediaPlayer.vala"
	_tmp126_ = mr;
#line 320 "../src/Widgets/MediaPlayer.vala"
	if (_tmp126_ != NULL) {
#line 1873 "MediaPlayer.c"
		const gchar* _tmp127_;
		gdouble* _tmp128_;
		gchar* _tmp129_;
		gchar* _tmp130_;
		gchar* _tmp131_;
		const gchar* _tmp132_;
#line 320 "../src/Widgets/MediaPlayer.vala"
		_tmp127_ = rLabel;
#line 320 "../src/Widgets/MediaPlayer.vala"
		_tmp128_ = mr;
#line 320 "../src/Widgets/MediaPlayer.vala"
		_tmp129_ = g_strdup_printf ("%02.0f", *_tmp128_);
#line 320 "../src/Widgets/MediaPlayer.vala"
		_tmp130_ = _tmp129_;
#line 320 "../src/Widgets/MediaPlayer.vala"
		_tmp131_ = g_strconcat (_tmp127_, _tmp130_, NULL);
#line 320 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (rLabel);
#line 320 "../src/Widgets/MediaPlayer.vala"
		rLabel = _tmp131_;
#line 320 "../src/Widgets/MediaPlayer.vala"
		_tmp132_ = rLabel;
#line 320 "../src/Widgets/MediaPlayer.vala"
		_tmp125_ = _tmp132_;
#line 320 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (_tmp130_);
#line 1900 "MediaPlayer.c"
	} else {
#line 320 "../src/Widgets/MediaPlayer.vala"
		_tmp125_ = NULL;
#line 1904 "MediaPlayer.c"
	}
#line 321 "../src/Widgets/MediaPlayer.vala"
	_tmp134_ = mr;
#line 321 "../src/Widgets/MediaPlayer.vala"
	if (_tmp134_ != NULL) {
#line 1910 "MediaPlayer.c"
		const gchar* _tmp135_;
		gchar* _tmp136_;
		const gchar* _tmp137_;
#line 321 "../src/Widgets/MediaPlayer.vala"
		_tmp135_ = rLabel;
#line 321 "../src/Widgets/MediaPlayer.vala"
		_tmp136_ = g_strconcat (_tmp135_, ":", NULL);
#line 321 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (rLabel);
#line 321 "../src/Widgets/MediaPlayer.vala"
		rLabel = _tmp136_;
#line 321 "../src/Widgets/MediaPlayer.vala"
		_tmp137_ = rLabel;
#line 321 "../src/Widgets/MediaPlayer.vala"
		_tmp133_ = _tmp137_;
#line 1926 "MediaPlayer.c"
	} else {
		const gchar* _tmp138_;
		gchar* _tmp139_;
		const gchar* _tmp140_;
#line 321 "../src/Widgets/MediaPlayer.vala"
		_tmp138_ = rLabel;
#line 321 "../src/Widgets/MediaPlayer.vala"
		_tmp139_ = g_strconcat (_tmp138_, "0:", NULL);
#line 321 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (rLabel);
#line 321 "../src/Widgets/MediaPlayer.vala"
		rLabel = _tmp139_;
#line 321 "../src/Widgets/MediaPlayer.vala"
		_tmp140_ = rLabel;
#line 321 "../src/Widgets/MediaPlayer.vala"
		_tmp133_ = _tmp140_;
#line 1943 "MediaPlayer.c"
	}
#line 322 "../src/Widgets/MediaPlayer.vala"
	_tmp141_ = rLabel;
#line 322 "../src/Widgets/MediaPlayer.vala"
	_tmp142_ = sr;
#line 322 "../src/Widgets/MediaPlayer.vala"
	_tmp143_ = g_strdup_printf ("%02.0f", *_tmp142_);
#line 322 "../src/Widgets/MediaPlayer.vala"
	_tmp144_ = _tmp143_;
#line 322 "../src/Widgets/MediaPlayer.vala"
	_tmp145_ = g_strconcat (_tmp141_, _tmp144_, NULL);
#line 322 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (rLabel);
#line 322 "../src/Widgets/MediaPlayer.vala"
	rLabel = _tmp145_;
#line 322 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (_tmp144_);
#line 324 "../src/Widgets/MediaPlayer.vala"
	if (dur == ((gint64) -1)) {
#line 1963 "MediaPlayer.c"
		GtkButton* _tmp146_;
		const gchar* _tmp147_;
#line 326 "../src/Widgets/MediaPlayer.vala"
		_tmp146_ = self->priv->m_labelButton;
#line 326 "../src/Widgets/MediaPlayer.vala"
		_tmp147_ = pLabel;
#line 326 "../src/Widgets/MediaPlayer.vala"
		gtk_button_set_label (_tmp146_, _tmp147_);
#line 327 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (rLabel);
#line 327 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (dLabel);
#line 327 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (pLabel);
#line 327 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (hr);
#line 327 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (mr);
#line 327 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (sr);
#line 327 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (hp);
#line 327 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (mp);
#line 327 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (sp);
#line 327 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (hd);
#line 327 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (md);
#line 327 "../src/Widgets/MediaPlayer.vala"
		_g_free0 (sd);
#line 327 "../src/Widgets/MediaPlayer.vala"
		return;
#line 1998 "MediaPlayer.c"
	}
#line 331 "../src/Widgets/MediaPlayer.vala"
	_tmp148_ = self->priv->m_display;
#line 331 "../src/Widgets/MediaPlayer.vala"
	switch (_tmp148_) {
#line 331 "../src/Widgets/MediaPlayer.vala"
		case FEED_READER_DISPLAY_POSITION_ALL:
#line 2006 "MediaPlayer.c"
		{
			GtkButton* _tmp149_;
			const gchar* _tmp150_;
			gchar* _tmp151_;
			gchar* _tmp152_;
			const gchar* _tmp153_;
			gchar* _tmp154_;
			gchar* _tmp155_;
#line 334 "../src/Widgets/MediaPlayer.vala"
			_tmp149_ = self->priv->m_labelButton;
#line 334 "../src/Widgets/MediaPlayer.vala"
			_tmp150_ = pLabel;
#line 334 "../src/Widgets/MediaPlayer.vala"
			_tmp151_ = g_strconcat (_tmp150_, " / ", NULL);
#line 334 "../src/Widgets/MediaPlayer.vala"
			_tmp152_ = _tmp151_;
#line 334 "../src/Widgets/MediaPlayer.vala"
			_tmp153_ = dLabel;
#line 334 "../src/Widgets/MediaPlayer.vala"
			_tmp154_ = g_strconcat (_tmp152_, _tmp153_, NULL);
#line 334 "../src/Widgets/MediaPlayer.vala"
			_tmp155_ = _tmp154_;
#line 334 "../src/Widgets/MediaPlayer.vala"
			gtk_button_set_label (_tmp149_, _tmp155_);
#line 334 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (_tmp155_);
#line 334 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (_tmp152_);
#line 335 "../src/Widgets/MediaPlayer.vala"
			break;
#line 2037 "MediaPlayer.c"
		}
#line 331 "../src/Widgets/MediaPlayer.vala"
		case FEED_READER_DISPLAY_POSITION_POS:
#line 2041 "MediaPlayer.c"
		{
			GtkButton* _tmp156_;
			const gchar* _tmp157_;
#line 338 "../src/Widgets/MediaPlayer.vala"
			_tmp156_ = self->priv->m_labelButton;
#line 338 "../src/Widgets/MediaPlayer.vala"
			_tmp157_ = pLabel;
#line 338 "../src/Widgets/MediaPlayer.vala"
			gtk_button_set_label (_tmp156_, _tmp157_);
#line 339 "../src/Widgets/MediaPlayer.vala"
			break;
#line 2053 "MediaPlayer.c"
		}
#line 331 "../src/Widgets/MediaPlayer.vala"
		case FEED_READER_DISPLAY_POSITION_LEFT:
#line 2057 "MediaPlayer.c"
		{
			GtkButton* _tmp158_;
			const gchar* _tmp159_;
#line 342 "../src/Widgets/MediaPlayer.vala"
			_tmp158_ = self->priv->m_labelButton;
#line 342 "../src/Widgets/MediaPlayer.vala"
			_tmp159_ = rLabel;
#line 342 "../src/Widgets/MediaPlayer.vala"
			gtk_button_set_label (_tmp158_, _tmp159_);
#line 343 "../src/Widgets/MediaPlayer.vala"
			break;
#line 2069 "MediaPlayer.c"
		}
		default:
#line 331 "../src/Widgets/MediaPlayer.vala"
		break;
#line 2074 "MediaPlayer.c"
	}
#line 247 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (rLabel);
#line 247 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (dLabel);
#line 247 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (pLabel);
#line 247 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (hr);
#line 247 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (mr);
#line 247 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (sr);
#line 247 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (hp);
#line 247 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (mp);
#line 247 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (sp);
#line 247 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (hd);
#line 247 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (md);
#line 247 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (sd);
#line 2100 "MediaPlayer.c"
}

static Block27Data*
block27_data_ref (Block27Data* _data27_)
{
#line 351 "../src/Widgets/MediaPlayer.vala"
	g_atomic_int_inc (&_data27_->_ref_count_);
#line 351 "../src/Widgets/MediaPlayer.vala"
	return _data27_;
#line 2110 "MediaPlayer.c"
}

static void
block27_data_unref (void * _userdata_)
{
	Block27Data* _data27_;
	_data27_ = (Block27Data*) _userdata_;
#line 351 "../src/Widgets/MediaPlayer.vala"
	if (g_atomic_int_dec_and_test (&_data27_->_ref_count_)) {
#line 2120 "MediaPlayer.c"
		FeedReaderMediaPlayer* self;
#line 351 "../src/Widgets/MediaPlayer.vala"
		self = _data27_->self;
#line 351 "../src/Widgets/MediaPlayer.vala"
		_g_object_unref0 (self);
#line 351 "../src/Widgets/MediaPlayer.vala"
		g_slice_free (Block27Data, _data27_);
#line 2128 "MediaPlayer.c"
	}
}

static gboolean
___lambda97_ (Block27Data* _data27_)
{
	FeedReaderMediaPlayer* self;
	gboolean result = FALSE;
	GtkScale* _tmp0_;
#line 355 "../src/Widgets/MediaPlayer.vala"
	self = _data27_->self;
#line 356 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_scale;
#line 356 "../src/Widgets/MediaPlayer.vala"
	if (gtk_range_get_value ((GtkRange*) _tmp0_) != _data27_->startValue) {
#line 2144 "MediaPlayer.c"
		GtkScale* _tmp1_;
#line 358 "../src/Widgets/MediaPlayer.vala"
		_tmp1_ = self->priv->m_scale;
#line 358 "../src/Widgets/MediaPlayer.vala"
		_data27_->startValue = gtk_range_get_value ((GtkRange*) _tmp1_);
#line 359 "../src/Widgets/MediaPlayer.vala"
		result = TRUE;
#line 359 "../src/Widgets/MediaPlayer.vala"
		return result;
#line 2154 "MediaPlayer.c"
	} else {
#line 363 "../src/Widgets/MediaPlayer.vala"
		self->priv->m_seek_source_id = (guint) 0;
#line 364 "../src/Widgets/MediaPlayer.vala"
		feed_reader_media_player_seek (self, _data27_->startValue);
#line 365 "../src/Widgets/MediaPlayer.vala"
		result = FALSE;
#line 365 "../src/Widgets/MediaPlayer.vala"
		return result;
#line 2164 "MediaPlayer.c"
	}
}

static gboolean
____lambda97__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda97_ (self);
#line 355 "../src/Widgets/MediaPlayer.vala"
	return result;
#line 2175 "MediaPlayer.c"
}

static gboolean
feed_reader_media_player_valueChanged (FeedReaderMediaPlayer* self,
                                       GtkScrollType scroll,
                                       gdouble new_value)
{
	gboolean result = FALSE;
	GtkScale* _tmp0_;
#line 347 "../src/Widgets/MediaPlayer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 349 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_scale;
#line 349 "../src/Widgets/MediaPlayer.vala"
	gtk_range_set_value ((GtkRange*) _tmp0_, new_value);
#line 351 "../src/Widgets/MediaPlayer.vala"
	if (self->priv->m_seek_source_id == ((guint) 0)) {
#line 2193 "MediaPlayer.c"
		Block27Data* _data27_;
#line 351 "../src/Widgets/MediaPlayer.vala"
		_data27_ = g_slice_new0 (Block27Data);
#line 351 "../src/Widgets/MediaPlayer.vala"
		_data27_->_ref_count_ = 1;
#line 351 "../src/Widgets/MediaPlayer.vala"
		_data27_->self = g_object_ref (self);
#line 353 "../src/Widgets/MediaPlayer.vala"
		_data27_->startValue = new_value;
#line 355 "../src/Widgets/MediaPlayer.vala"
		self->priv->m_seek_source_id = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 500, ____lambda97__gsource_func, block27_data_ref (_data27_), block27_data_unref);
#line 351 "../src/Widgets/MediaPlayer.vala"
		block27_data_unref (_data27_);
#line 351 "../src/Widgets/MediaPlayer.vala"
		_data27_ = NULL;
#line 2209 "MediaPlayer.c"
	}
#line 369 "../src/Widgets/MediaPlayer.vala"
	result = TRUE;
#line 369 "../src/Widgets/MediaPlayer.vala"
	return result;
#line 2215 "MediaPlayer.c"
}

static void
feed_reader_media_player_seek (FeedReaderMediaPlayer* self,
                               gdouble new_value)
{
	gint64 dur = 0LL;
	gdouble percent = 0.0;
	GstElement* _tmp0_;
	gint64 _tmp1_ = 0LL;
	gint64 pos = 0LL;
	GstElement* _tmp2_;
	GtkButton* _tmp3_;
	GtkImage* _tmp4_;
	GstElement* _tmp5_;
#line 372 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 375 "../src/Widgets/MediaPlayer.vala"
	percent = new_value / 100.0;
#line 376 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_player;
#line 376 "../src/Widgets/MediaPlayer.vala"
	gst_element_query_duration (_tmp0_, GST_FORMAT_TIME, &_tmp1_);
#line 376 "../src/Widgets/MediaPlayer.vala"
	dur = _tmp1_;
#line 377 "../src/Widgets/MediaPlayer.vala"
	pos = (gint64) (percent * ((gdouble) dur));
#line 378 "../src/Widgets/MediaPlayer.vala"
	_tmp2_ = self->priv->m_player;
#line 378 "../src/Widgets/MediaPlayer.vala"
	gst_element_seek_simple (_tmp2_, GST_FORMAT_TIME, GST_SEEK_FLAG_FLUSH | GST_SEEK_FLAG_KEY_UNIT, pos);
#line 380 "../src/Widgets/MediaPlayer.vala"
	_tmp3_ = self->priv->m_playButton;
#line 380 "../src/Widgets/MediaPlayer.vala"
	_tmp4_ = self->priv->m_pauseIcon;
#line 380 "../src/Widgets/MediaPlayer.vala"
	gtk_button_set_image (_tmp3_, (GtkWidget*) _tmp4_);
#line 381 "../src/Widgets/MediaPlayer.vala"
	_tmp5_ = self->priv->m_player;
#line 381 "../src/Widgets/MediaPlayer.vala"
	gst_element_set_state (_tmp5_, GST_STATE_PLAYING);
#line 2257 "MediaPlayer.c"
}

static void
feed_reader_media_player_toggleMute (FeedReaderMediaPlayer* self)
{
#line 384 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 386 "../src/Widgets/MediaPlayer.vala"
	if (self->priv->m_muted) {
#line 2267 "MediaPlayer.c"
		GtkButton* _tmp0_;
		GtkImage* _tmp1_;
		GtkButton* _tmp2_;
		GstElement* _tmp3_;
#line 388 "../src/Widgets/MediaPlayer.vala"
		_tmp0_ = self->priv->m_muteButton;
#line 388 "../src/Widgets/MediaPlayer.vala"
		_tmp1_ = self->priv->m_noiseIcon;
#line 388 "../src/Widgets/MediaPlayer.vala"
		gtk_button_set_image (_tmp0_, (GtkWidget*) _tmp1_);
#line 389 "../src/Widgets/MediaPlayer.vala"
		_tmp2_ = self->priv->m_muteButton;
#line 389 "../src/Widgets/MediaPlayer.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp2_, FEED_READER_MEDIA_BUTTON_MUTE);
#line 390 "../src/Widgets/MediaPlayer.vala"
		_tmp3_ = self->priv->m_player;
#line 390 "../src/Widgets/MediaPlayer.vala"
		g_object_set ((GObject*) _tmp3_, "volume", 1.0, NULL);
#line 391 "../src/Widgets/MediaPlayer.vala"
		self->priv->m_muted = FALSE;
#line 2288 "MediaPlayer.c"
	} else {
		GtkButton* _tmp4_;
		GtkImage* _tmp5_;
		GtkButton* _tmp6_;
		GstElement* _tmp7_;
#line 395 "../src/Widgets/MediaPlayer.vala"
		_tmp4_ = self->priv->m_muteButton;
#line 395 "../src/Widgets/MediaPlayer.vala"
		_tmp5_ = self->priv->m_muteIcon;
#line 395 "../src/Widgets/MediaPlayer.vala"
		gtk_button_set_image (_tmp4_, (GtkWidget*) _tmp5_);
#line 396 "../src/Widgets/MediaPlayer.vala"
		_tmp6_ = self->priv->m_muteButton;
#line 396 "../src/Widgets/MediaPlayer.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp6_, FEED_READER_MEDIA_BUTTON_UNMUTE);
#line 397 "../src/Widgets/MediaPlayer.vala"
		_tmp7_ = self->priv->m_player;
#line 397 "../src/Widgets/MediaPlayer.vala"
		g_object_set ((GObject*) _tmp7_, "volume", 0.0, NULL);
#line 398 "../src/Widgets/MediaPlayer.vala"
		self->priv->m_muted = TRUE;
#line 2310 "MediaPlayer.c"
	}
}

static gboolean
feed_reader_media_player_busCallback (FeedReaderMediaPlayer* self,
                                      GstBus* bus,
                                      GstMessage* message)
{
	gboolean result = FALSE;
	GstMessageType _tmp0_;
#line 402 "../src/Widgets/MediaPlayer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 402 "../src/Widgets/MediaPlayer.vala"
	g_return_val_if_fail (bus != NULL, FALSE);
#line 402 "../src/Widgets/MediaPlayer.vala"
	g_return_val_if_fail (message != NULL, FALSE);
#line 404 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = message->type;
#line 404 "../src/Widgets/MediaPlayer.vala"
	switch (_tmp0_) {
#line 404 "../src/Widgets/MediaPlayer.vala"
		case GST_MESSAGE_ERROR:
#line 2333 "MediaPlayer.c"
		{
			GError* err = NULL;
			gchar* debug = NULL;
			GError* _tmp1_ = NULL;
			gchar* _tmp2_ = NULL;
			GError* _tmp3_;
			const gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			GstElement* _tmp7_;
#line 409 "../src/Widgets/MediaPlayer.vala"
			gst_message_parse_error (message, &_tmp1_, &_tmp2_);
#line 409 "../src/Widgets/MediaPlayer.vala"
			_g_error_free0 (err);
#line 409 "../src/Widgets/MediaPlayer.vala"
			err = _tmp1_;
#line 409 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (debug);
#line 409 "../src/Widgets/MediaPlayer.vala"
			debug = _tmp2_;
#line 410 "../src/Widgets/MediaPlayer.vala"
			_tmp3_ = err;
#line 410 "../src/Widgets/MediaPlayer.vala"
			_tmp4_ = _tmp3_->message;
#line 410 "../src/Widgets/MediaPlayer.vala"
			_tmp5_ = g_strconcat ("MediaPlayer: ", _tmp4_, NULL);
#line 410 "../src/Widgets/MediaPlayer.vala"
			_tmp6_ = _tmp5_;
#line 410 "../src/Widgets/MediaPlayer.vala"
			feed_reader_logger_error (_tmp6_);
#line 410 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (_tmp6_);
#line 411 "../src/Widgets/MediaPlayer.vala"
			_tmp7_ = self->priv->m_player;
#line 411 "../src/Widgets/MediaPlayer.vala"
			gst_element_set_state (_tmp7_, GST_STATE_NULL);
#line 412 "../src/Widgets/MediaPlayer.vala"
			_g_free0 (debug);
#line 412 "../src/Widgets/MediaPlayer.vala"
			_g_error_free0 (err);
#line 412 "../src/Widgets/MediaPlayer.vala"
			break;
#line 2376 "MediaPlayer.c"
		}
#line 404 "../src/Widgets/MediaPlayer.vala"
		case GST_MESSAGE_EOS:
#line 2380 "MediaPlayer.c"
		{
			GstElement* _tmp8_;
			GtkButton* _tmp9_;
			GtkImage* _tmp10_;
#line 415 "../src/Widgets/MediaPlayer.vala"
			_tmp8_ = self->priv->m_player;
#line 415 "../src/Widgets/MediaPlayer.vala"
			gst_element_set_state (_tmp8_, GST_STATE_READY);
#line 416 "../src/Widgets/MediaPlayer.vala"
			_tmp9_ = self->priv->m_playButton;
#line 416 "../src/Widgets/MediaPlayer.vala"
			_tmp10_ = self->priv->m_playIcon;
#line 416 "../src/Widgets/MediaPlayer.vala"
			gtk_button_set_image (_tmp9_, (GtkWidget*) _tmp10_);
#line 417 "../src/Widgets/MediaPlayer.vala"
			break;
#line 2397 "MediaPlayer.c"
		}
#line 404 "../src/Widgets/MediaPlayer.vala"
		case GST_MESSAGE_BUFFERING:
#line 2401 "MediaPlayer.c"
		{
			gint percent = 0;
			gint _tmp11_ = 0;
#line 420 "../src/Widgets/MediaPlayer.vala"
			percent = 0;
#line 421 "../src/Widgets/MediaPlayer.vala"
			gst_message_parse_buffering (message, &_tmp11_);
#line 421 "../src/Widgets/MediaPlayer.vala"
			percent = _tmp11_;
#line 422 "../src/Widgets/MediaPlayer.vala"
			if (percent < 100) {
#line 2413 "MediaPlayer.c"
				GstElement* _tmp12_;
				FeedReaderMediaType _tmp13_;
#line 424 "../src/Widgets/MediaPlayer.vala"
				_tmp12_ = self->priv->m_player;
#line 424 "../src/Widgets/MediaPlayer.vala"
				gst_element_set_state (_tmp12_, GST_STATE_PAUSED);
#line 426 "../src/Widgets/MediaPlayer.vala"
				_tmp13_ = self->priv->m_type;
#line 426 "../src/Widgets/MediaPlayer.vala"
				if (_tmp13_ == FEED_READER_MEDIA_TYPE_VIDEO) {
#line 2424 "MediaPlayer.c"
					GtkLabel* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					GtkLabel* _tmp19_;
#line 428 "../src/Widgets/MediaPlayer.vala"
					_tmp14_ = self->priv->m_bufferLabel;
#line 428 "../src/Widgets/MediaPlayer.vala"
					_tmp15_ = g_strdup_printf ("%i", percent);
#line 428 "../src/Widgets/MediaPlayer.vala"
					_tmp16_ = _tmp15_;
#line 428 "../src/Widgets/MediaPlayer.vala"
					_tmp17_ = g_strconcat (_tmp16_, "%", NULL);
#line 428 "../src/Widgets/MediaPlayer.vala"
					_tmp18_ = _tmp17_;
#line 428 "../src/Widgets/MediaPlayer.vala"
					gtk_label_set_text (_tmp14_, _tmp18_);
#line 428 "../src/Widgets/MediaPlayer.vala"
					_g_free0 (_tmp18_);
#line 428 "../src/Widgets/MediaPlayer.vala"
					_g_free0 (_tmp16_);
#line 429 "../src/Widgets/MediaPlayer.vala"
					_tmp19_ = self->priv->m_bufferLabel;
#line 429 "../src/Widgets/MediaPlayer.vala"
					gtk_widget_show ((GtkWidget*) _tmp19_);
#line 2451 "MediaPlayer.c"
				} else {
					GtkStack* _tmp20_;
					GtkSpinner* _tmp21_;
#line 433 "../src/Widgets/MediaPlayer.vala"
					_tmp20_ = self->priv->m_playStack;
#line 433 "../src/Widgets/MediaPlayer.vala"
					gtk_stack_set_visible_child_name (_tmp20_, "spinner");
#line 434 "../src/Widgets/MediaPlayer.vala"
					_tmp21_ = self->priv->m_playSpinner;
#line 434 "../src/Widgets/MediaPlayer.vala"
					gtk_spinner_start (_tmp21_);
#line 2463 "MediaPlayer.c"
				}
			} else {
				GstElement* _tmp22_;
				FeedReaderMediaType _tmp23_;
#line 439 "../src/Widgets/MediaPlayer.vala"
				_tmp22_ = self->priv->m_player;
#line 439 "../src/Widgets/MediaPlayer.vala"
				gst_element_set_state (_tmp22_, GST_STATE_PLAYING);
#line 440 "../src/Widgets/MediaPlayer.vala"
				_tmp23_ = self->priv->m_type;
#line 440 "../src/Widgets/MediaPlayer.vala"
				if (_tmp23_ == FEED_READER_MEDIA_TYPE_VIDEO) {
#line 2476 "MediaPlayer.c"
					GtkLabel* _tmp24_;
#line 442 "../src/Widgets/MediaPlayer.vala"
					_tmp24_ = self->priv->m_bufferLabel;
#line 442 "../src/Widgets/MediaPlayer.vala"
					gtk_widget_hide ((GtkWidget*) _tmp24_);
#line 2482 "MediaPlayer.c"
				} else {
					GtkStack* _tmp25_;
#line 446 "../src/Widgets/MediaPlayer.vala"
					_tmp25_ = self->priv->m_playStack;
#line 446 "../src/Widgets/MediaPlayer.vala"
					gtk_stack_set_visible_child_name (_tmp25_, "button");
#line 2489 "MediaPlayer.c"
				}
			}
#line 449 "../src/Widgets/MediaPlayer.vala"
			break;
#line 2494 "MediaPlayer.c"
		}
#line 404 "../src/Widgets/MediaPlayer.vala"
		case GST_MESSAGE_STATE_CHANGED:
#line 2498 "MediaPlayer.c"
		{
			GstState oldstate = 0;
			GstState newstate = 0;
			GstState pending = 0;
			GstState _tmp26_ = 0;
			GstState _tmp27_ = 0;
			GstState _tmp28_ = 0;
#line 455 "../src/Widgets/MediaPlayer.vala"
			gst_message_parse_state_changed (message, &_tmp26_, &_tmp27_, &_tmp28_);
#line 455 "../src/Widgets/MediaPlayer.vala"
			oldstate = _tmp26_;
#line 455 "../src/Widgets/MediaPlayer.vala"
			newstate = _tmp27_;
#line 455 "../src/Widgets/MediaPlayer.vala"
			pending = _tmp28_;
#line 456 "../src/Widgets/MediaPlayer.vala"
			break;
#line 2516 "MediaPlayer.c"
		}
		default:
#line 404 "../src/Widgets/MediaPlayer.vala"
		break;
#line 2521 "MediaPlayer.c"
	}
#line 458 "../src/Widgets/MediaPlayer.vala"
	result = TRUE;
#line 458 "../src/Widgets/MediaPlayer.vala"
	return result;
#line 2527 "MediaPlayer.c"
}

static void
feed_reader_media_player_onAllocation (FeedReaderMediaPlayer* self,
                                       GtkAllocation* allocation)
{
#line 461 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 461 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (allocation != NULL);
#line 463 "../src/Widgets/MediaPlayer.vala"
	if (self->priv->m_aspectRatio != ((gdouble) 0)) {
#line 2540 "MediaPlayer.c"
		gdouble width = 0.0;
		GtkAllocation _tmp0_;
		gint height = 0;
		GtkWidget* _tmp1_;
#line 465 "../src/Widgets/MediaPlayer.vala"
		_tmp0_ = *allocation;
#line 465 "../src/Widgets/MediaPlayer.vala"
		width = (gdouble) _tmp0_.width;
#line 466 "../src/Widgets/MediaPlayer.vala"
		height = (gint) (width / self->priv->m_aspectRatio);
#line 467 "../src/Widgets/MediaPlayer.vala"
		_tmp1_ = self->priv->m_videoWidget;
#line 467 "../src/Widgets/MediaPlayer.vala"
		gtk_widget_set_size_request (_tmp1_, -1, height);
#line 2555 "MediaPlayer.c"
	}
}

void
feed_reader_media_player_kill (FeedReaderMediaPlayer* self)
{
	GstElement* _tmp0_;
#line 471 "../src/Widgets/MediaPlayer.vala"
	g_return_if_fail (self != NULL);
#line 473 "../src/Widgets/MediaPlayer.vala"
	_tmp0_ = self->priv->m_player;
#line 473 "../src/Widgets/MediaPlayer.vala"
	gst_element_set_state (_tmp0_, GST_STATE_NULL);
#line 474 "../src/Widgets/MediaPlayer.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 2571 "MediaPlayer.c"
}

static void
feed_reader_media_player_class_init (FeedReaderMediaPlayerClass * klass,
                                     gpointer klass_data)
{
#line 16 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_parent_class = g_type_class_peek_parent (klass);
#line 16 "../src/Widgets/MediaPlayer.vala"
	g_type_class_adjust_private_offset (klass, &FeedReaderMediaPlayer_private_offset);
#line 16 "../src/Widgets/MediaPlayer.vala"
	G_OBJECT_CLASS (klass)->finalize = feed_reader_media_player_finalize;
#line 16 "../src/Widgets/MediaPlayer.vala"
	feed_reader_media_player_signals[FEED_READER_MEDIA_PLAYER_LOADED_SIGNAL] = g_signal_new ("loaded", FEED_READER_TYPE_MEDIA_PLAYER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2586 "MediaPlayer.c"
}

static void
feed_reader_media_player_instance_init (FeedReaderMediaPlayer * self,
                                        gpointer klass)
{
#line 16 "../src/Widgets/MediaPlayer.vala"
	self->priv = feed_reader_media_player_get_instance_private (self);
#line 28 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_margin = 20;
#line 34 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_muted = FALSE;
#line 35 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_aspectRatio = 0.0;
#line 36 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_seek_source_id = (guint) 0;
#line 39 "../src/Widgets/MediaPlayer.vala"
	self->priv->m_display = FEED_READER_DISPLAY_POSITION_ALL;
#line 2605 "MediaPlayer.c"
}

static void
feed_reader_media_player_finalize (GObject * obj)
{
	FeedReaderMediaPlayer * self;
#line 16 "../src/Widgets/MediaPlayer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FEED_READER_TYPE_MEDIA_PLAYER, FeedReaderMediaPlayer);
#line 18 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_player);
#line 19 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_videoWidget);
#line 20 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_playStack);
#line 21 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_playButton);
#line 22 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_playSpinner);
#line 23 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_muteButton);
#line 24 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_closeButton);
#line 25 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_scale);
#line 26 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_labelButton);
#line 27 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_bufferLabel);
#line 29 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_playIcon);
#line 30 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_pauseIcon);
#line 31 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_muteIcon);
#line 32 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_noiseIcon);
#line 33 "../src/Widgets/MediaPlayer.vala"
	_g_object_unref0 (self->priv->m_closeIcon);
#line 38 "../src/Widgets/MediaPlayer.vala"
	_g_free0 (self->priv->m_URL);
#line 16 "../src/Widgets/MediaPlayer.vala"
	G_OBJECT_CLASS (feed_reader_media_player_parent_class)->finalize (obj);
#line 2648 "MediaPlayer.c"
}

GType
feed_reader_media_player_get_type (void)
{
	static volatile gsize feed_reader_media_player_type_id__volatile = 0;
	if (g_once_init_enter (&feed_reader_media_player_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FeedReaderMediaPlayerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) feed_reader_media_player_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FeedReaderMediaPlayer), 0, (GInstanceInitFunc) feed_reader_media_player_instance_init, NULL };
		GType feed_reader_media_player_type_id;
		feed_reader_media_player_type_id = g_type_register_static (gtk_box_get_type (), "FeedReaderMediaPlayer", &g_define_type_info, 0);
		FeedReaderMediaPlayer_private_offset = g_type_add_instance_private (feed_reader_media_player_type_id, sizeof (FeedReaderMediaPlayerPrivate));
		g_once_init_leave (&feed_reader_media_player_type_id__volatile, feed_reader_media_player_type_id);
	}
	return feed_reader_media_player_type_id__volatile;
}

