/* feedbinAPI.c generated by valac 0.45.3, the Vala compiler
 * generated from feedbinAPI.vala, do not modify */

/*This file is part of FeedReader.*/
/**/
/*FeedReader is free software: you can redistribute it and/or modify*/
/*it under the terms of the GNU General Public License as published by*/
/*the Free Software Foundation, either version 3 of the License, or*/
/*(at your option) any later version.*/
/**/
/*FeedReader is distributed in the hope that it will be useful,*/
/*but WITHOUT ANY WARRANTY; without even the implied warranty of*/
/*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the*/
/*GNU General Public License for more details.*/
/**/
/*You should have received a copy of the GNU General Public License*/
/*along with FeedReader.  If not, see <http://www.gnu.org/licenses/>.*/
/* TODO: Make a general-purpose HttpClient module with these errors*/

#include <glib.h>
#include <glib-object.h>
#include <libsoup/soup.h>
#include <stdlib.h>
#include <string.h>
#include <json-glib/json-glib.h>
#include <gee.h>

#define TYPE_FEEDBIN_API (feedbin_api_get_type ())
#define FEEDBIN_API(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FEEDBIN_API, FeedbinAPI))
#define FEEDBIN_API_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FEEDBIN_API, FeedbinAPIClass))
#define IS_FEEDBIN_API(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FEEDBIN_API))
#define IS_FEEDBIN_API_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FEEDBIN_API))
#define FEEDBIN_API_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FEEDBIN_API, FeedbinAPIClass))

typedef struct _FeedbinAPI FeedbinAPI;
typedef struct _FeedbinAPIClass FeedbinAPIClass;
typedef struct _FeedbinAPIPrivate FeedbinAPIPrivate;
enum  {
	FEEDBIN_API_0_PROPERTY,
	FEEDBIN_API_USERNAME_PROPERTY,
	FEEDBIN_API_PASSWORD_PROPERTY,
	FEEDBIN_API_NUM_PROPERTIES
};
static GParamSpec* feedbin_api_properties[FEEDBIN_API_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define __vala_SoupBuffer_free0(var) ((var == NULL) ? NULL : (var = (_vala_SoupBuffer_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))

#define FEEDBIN_API_TYPE_SUBSCRIPTION (feedbin_api_subscription_get_type ())
typedef struct _FeedbinAPISubscription FeedbinAPISubscription;
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))

#define FEEDBIN_API_TYPE_TAGGING (feedbin_api_tagging_get_type ())
typedef struct _FeedbinAPITagging FeedbinAPITagging;

#define FEEDBIN_API_TYPE_ENTRY (feedbin_api_entry_get_type ())
typedef struct _FeedbinAPIEntry FeedbinAPIEntry;
#define _g_bytes_unref0(var) ((var == NULL) ? NULL : (var = (g_bytes_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

typedef enum  {
	FEEDBIN_ERROR_INVALID_FORMAT,
	FEEDBIN_ERROR_MULTIPLE_CHOICES,
	FEEDBIN_ERROR_NO_CONNECTION,
	FEEDBIN_ERROR_NOT_AUTHORIZED,
	FEEDBIN_ERROR_NOT_FOUND,
	FEEDBIN_ERROR_UNKNOWN_ERROR
} FeedbinError;
#define FEEDBIN_ERROR feedbin_error_quark ()
struct _FeedbinAPI {
	GObject parent_instance;
	FeedbinAPIPrivate * priv;
};

struct _FeedbinAPIClass {
	GObjectClass parent_class;
};

struct _FeedbinAPIPrivate {
	SoupSession* m_session;
	gchar* m_base_uri;
	gchar* _username;
	gchar* _password;
};

struct _FeedbinAPISubscription {
	gint64 id;
	GDateTime* created_at;
	gint64 feed_id;
	gchar* title;
	gchar* feed_url;
	gchar* site_url;
};

struct _FeedbinAPITagging {
	gint64 id;
	gint64 feed_id;
	gchar* name;
};

struct _FeedbinAPIEntry {
	gint64 id;
	gint64 feed_id;
	gchar* title;
	gchar* url;
	gchar* author;
	gchar* content;
	gchar* summary;
	GDateTime* published;
	GDateTime* created_at;
};

static gint FeedbinAPI_private_offset;
static gpointer feedbin_api_parent_class = NULL;

GQuark feedbin_error_quark (void);
GType feedbin_api_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (FeedbinAPI, g_object_unref)
static void feedbin_api_authenticate (FeedbinAPI* self,
                               SoupMessage* msg,
                               SoupAuth* auth,
                               gboolean retrying);
static void _feedbin_api_authenticate_soup_session_authenticate (SoupSession* _sender,
                                                          SoupMessage* msg,
                                                          SoupAuth* auth,
                                                          gboolean retrying,
                                                          gpointer self);
#define FEEDBIN_API_BASE_URI_FORMAT "%s/v2/"
FeedbinAPI* feedbin_api_new (const gchar* username,
                             const gchar* password,
                             const gchar* user_agent,
                             const gchar* host);
FeedbinAPI* feedbin_api_construct (GType object_type,
                                   const gchar* username,
                                   const gchar* password,
                                   const gchar* user_agent,
                                   const gchar* host);
void feedbin_api_set_username (FeedbinAPI* self,
                               const gchar* value);
void feedbin_api_set_password (FeedbinAPI* self,
                               const gchar* value);
const gchar* feedbin_api_get_username (FeedbinAPI* self);
const gchar* feedbin_api_get_password (FeedbinAPI* self);
static SoupMessage* feedbin_api_request (FeedbinAPI* self,
                                  const gchar* method,
                                  const gchar* last_part,
                                  const gchar* input,
                                  GError** error);
static guint8* _vala_array_dup1 (guint8* self,
                          int length);
static GDateTime* feedbin_api_string_to_datetime (const gchar* s,
                                           GError** error);
static GDateTime* feedbin_api_get_datetime_member (JsonObject* obj,
                                            const gchar* name,
                                            GError** error);
static SoupMessage* feedbin_api_post_request (FeedbinAPI* self,
                                       const gchar* path,
                                       const gchar* input,
                                       GError** error);
static SoupMessage* feedbin_api_delete_request (FeedbinAPI* self,
                                         const gchar* path,
                                         GError** error);
static SoupMessage* feedbin_api_get_request (FeedbinAPI* self,
                                      const gchar* path,
                                      GError** error);
static JsonNode* feedbin_api_parse_json (SoupMessage* response,
                                  GError** error);
static void _vala_SoupBuffer_free (SoupBuffer* self);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static JsonNode* feedbin_api_get_json (FeedbinAPI* self,
                                const gchar* path,
                                GError** error);
static void _vala_JsonNode_free (JsonNode* self);
static SoupMessage* feedbin_api_post_json_object (FeedbinAPI* self,
                                           const gchar* path,
                                           JsonObject* obj,
                                           GError** error);
gboolean feedbin_api_login (FeedbinAPI* self,
                            GError** error);
GType feedbin_api_subscription_get_type (void) G_GNUC_CONST;
FeedbinAPISubscription* feedbin_api_subscription_dup (const FeedbinAPISubscription* self);
void feedbin_api_subscription_free (FeedbinAPISubscription* self);
void feedbin_api_subscription_copy (const FeedbinAPISubscription* self,
                                    FeedbinAPISubscription* dest);
void feedbin_api_subscription_destroy (FeedbinAPISubscription* self);
void feedbin_api_get_subscription (FeedbinAPI* self,
                                   gint64 subscription_id,
                                   FeedbinAPISubscription* result,
                                   GError** error);
void feedbin_api_subscription_init_from_json (FeedbinAPISubscription *self,
                                              JsonObject* object,
                                              GError** error);
GeeList* feedbin_api_get_subscriptions (FeedbinAPI* self,
                                        GError** error);
void feedbin_api_delete_subscription (FeedbinAPI* self,
                                      gint64 subscription_id,
                                      GError** error);
FeedbinAPISubscription* feedbin_api_add_subscription (FeedbinAPI* self,
                                                      const gchar* url,
                                                      GError** error);
void feedbin_api_rename_subscription (FeedbinAPI* self,
                                      gint64 subscription_id,
                                      const gchar* title,
                                      GError** error);
void feedbin_api_add_tagging (FeedbinAPI* self,
                              gint64 feed_id,
                              const gchar* tag_name,
                              GError** error);
void feedbin_api_delete_tagging (FeedbinAPI* self,
                                 gint64 tagging_id,
                                 GError** error);
GType feedbin_api_tagging_get_type (void) G_GNUC_CONST;
FeedbinAPITagging* feedbin_api_tagging_dup (const FeedbinAPITagging* self);
void feedbin_api_tagging_free (FeedbinAPITagging* self);
void feedbin_api_tagging_copy (const FeedbinAPITagging* self,
                               FeedbinAPITagging* dest);
void feedbin_api_tagging_destroy (FeedbinAPITagging* self);
GeeList* feedbin_api_get_taggings (FeedbinAPI* self,
                                   GError** error);
void feedbin_api_tagging_init_from_json (FeedbinAPITagging *self,
                                         JsonObject* object);
GType feedbin_api_entry_get_type (void) G_GNUC_CONST;
FeedbinAPIEntry* feedbin_api_entry_dup (const FeedbinAPIEntry* self);
void feedbin_api_entry_free (FeedbinAPIEntry* self);
void feedbin_api_entry_copy (const FeedbinAPIEntry* self,
                             FeedbinAPIEntry* dest);
void feedbin_api_entry_destroy (FeedbinAPIEntry* self);
GeeList* feedbin_api_get_entries (FeedbinAPI* self,
                                  gint page,
                                  gboolean only_starred,
                                  GDateTime* since,
                                  gint64* feed_id,
                                  GError** error);
void feedbin_api_entry_init_from_json (FeedbinAPIEntry *self,
                                       JsonObject* object,
                                       GError** error);
static GeeSet* feedbin_api_get_x_entries (FeedbinAPI* self,
                                   const gchar* path,
                                   GError** error);
static guint __lambda4_ (FeedbinAPI* self,
                  gint64* n);
static guint ___lambda4__gee_hash_data_func (gconstpointer v,
                                      gpointer self);
static gboolean __lambda5_ (FeedbinAPI* self,
                     gint64* a,
                     gint64* b);
static gboolean ___lambda5__gee_equal_data_func (gconstpointer a,
                                          gconstpointer b,
                                          gpointer self);
static gint64* _int64_dup (gint64* self);
GeeSet* feedbin_api_get_unread_entries (FeedbinAPI* self,
                                        GError** error);
GeeSet* feedbin_api_get_starred_entries (FeedbinAPI* self,
                                         GError** error);
static void feedbin_api_set_entries_status (FeedbinAPI* self,
                                     const gchar* type,
                                     GeeCollection* entry_ids,
                                     gboolean create,
                                     GError** error);
void feedbin_api_set_entries_read (FeedbinAPI* self,
                                   GeeCollection* entry_ids,
                                   gboolean read,
                                   GError** error);
void feedbin_api_set_entries_starred (FeedbinAPI* self,
                                      GeeCollection* entry_ids,
                                      gboolean starred,
                                      GError** error);
GeeMap* feedbin_api_get_favicons (FeedbinAPI* self,
                                  GError** error);
static void feedbin_api_finalize (GObject * obj);
static void _vala_feedbin_api_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_feedbin_api_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

GQuark
feedbin_error_quark (void)
{
	return g_quark_from_static_string ("feedbin-error-quark");
}

static inline gpointer
feedbin_api_get_instance_private (FeedbinAPI* self)
{
	return G_STRUCT_MEMBER_P (self, FeedbinAPI_private_offset);
}

static void
_feedbin_api_authenticate_soup_session_authenticate (SoupSession* _sender,
                                                     SoupMessage* msg,
                                                     SoupAuth* auth,
                                                     gboolean retrying,
                                                     gpointer self)
{
#line 51 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_authenticate ((FeedbinAPI*) self, msg, auth, retrying);
#line 309 "feedbinAPI.c"
}

FeedbinAPI*
feedbin_api_construct (GType object_type,
                       const gchar* username,
                       const gchar* password,
                       const gchar* user_agent,
                       const gchar* host)
{
	FeedbinAPI * self = NULL;
	gchar* _tmp0_;
	SoupSession* _tmp1_;
	SoupSession* _tmp3_;
#line 34 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (username != NULL, NULL);
#line 34 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (password != NULL, NULL);
#line 34 "../plugins/backend/feedbin/feedbinAPI.vala"
	self = (FeedbinAPI*) g_object_new (object_type, NULL);
#line 36 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_set_username (self, username);
#line 37 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_set_password (self, password);
#line 38 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = g_strdup_printf (FEEDBIN_API_BASE_URI_FORMAT, host);
#line 38 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (self->priv->m_base_uri);
#line 38 "../plugins/backend/feedbin/feedbinAPI.vala"
	self->priv->m_base_uri = _tmp0_;
#line 39 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = soup_session_new ();
#line 39 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (self->priv->m_session);
#line 39 "../plugins/backend/feedbin/feedbinAPI.vala"
	self->priv->m_session = _tmp1_;
#line 41 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (user_agent != NULL) {
#line 347 "feedbinAPI.c"
		SoupSession* _tmp2_;
#line 43 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp2_ = self->priv->m_session;
#line 43 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_object_set (_tmp2_, "user-agent", user_agent, NULL);
#line 353 "feedbinAPI.c"
	}
#line 46 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = self->priv->m_session;
#line 46 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_signal_connect_object (_tmp3_, "authenticate", (GCallback) _feedbin_api_authenticate_soup_session_authenticate, self, 0);
#line 34 "../plugins/backend/feedbin/feedbinAPI.vala"
	return self;
#line 361 "feedbinAPI.c"
}

FeedbinAPI*
feedbin_api_new (const gchar* username,
                 const gchar* password,
                 const gchar* user_agent,
                 const gchar* host)
{
#line 34 "../plugins/backend/feedbin/feedbinAPI.vala"
	return feedbin_api_construct (TYPE_FEEDBIN_API, username, password, user_agent, host);
#line 372 "feedbinAPI.c"
}

static void
feedbin_api_authenticate (FeedbinAPI* self,
                          SoupMessage* msg,
                          SoupAuth* auth,
                          gboolean retrying)
{
#line 54 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 54 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (msg != NULL);
#line 54 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (auth != NULL);
#line 56 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (!retrying) {
#line 389 "feedbinAPI.c"
		const gchar* _tmp0_;
		const gchar* _tmp1_;
#line 58 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp0_ = self->priv->_username;
#line 58 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp1_ = self->priv->_password;
#line 58 "../plugins/backend/feedbin/feedbinAPI.vala"
		soup_auth_authenticate (auth, _tmp0_, _tmp1_);
#line 398 "feedbinAPI.c"
	}
}

static guint8*
string_get_data (const gchar* self,
                 gint* result_length1)
{
	guint8* result;
	guint8* res = NULL;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8* _tmp3_;
	gint _tmp3__length1;
#line 1501 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1502 "glib-2.0.vapi"
	res = (guint8*) self;
#line 1502 "glib-2.0.vapi"
	res_length1 = -1;
#line 1502 "glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1503 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1503 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1503 "glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1504 "glib-2.0.vapi"
	_tmp2_ = res;
#line 1504 "glib-2.0.vapi"
	_tmp2__length1 = res_length1;
#line 1504 "glib-2.0.vapi"
	_tmp3_ = _tmp2_;
#line 1504 "glib-2.0.vapi"
	_tmp3__length1 = _tmp2__length1;
#line 1504 "glib-2.0.vapi"
	if (result_length1) {
#line 1504 "glib-2.0.vapi"
		*result_length1 = _tmp3__length1;
#line 442 "feedbinAPI.c"
	}
#line 1504 "glib-2.0.vapi"
	result = _tmp3_;
#line 1504 "glib-2.0.vapi"
	return result;
#line 448 "feedbinAPI.c"
}

static guint8*
_vala_array_dup1 (guint8* self,
                  int length)
{
#line 78 "../plugins/backend/feedbin/feedbinAPI.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 457 "feedbinAPI.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result = NULL;
#line 1516 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1517 "glib-2.0.vapi"
	result = self;
#line 1517 "glib-2.0.vapi"
	return result;
#line 470 "feedbinAPI.c"
}

static SoupMessage*
feedbin_api_request (FeedbinAPI* self,
                     const gchar* method,
                     const gchar* last_part,
                     const gchar* input,
                     GError** error)
{
	SoupMessage* result = NULL;
	gchar* path = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	SoupMessage* message = NULL;
	const gchar* _tmp2_;
	SoupMessage* _tmp3_;
	SoupSession* _tmp11_;
	SoupMessage* _tmp12_;
	guint status = 0U;
	SoupMessage* _tmp13_;
	guint _tmp14_;
	guint _tmp15_;
	gboolean _tmp16_ = FALSE;
	SoupMessage* _tmp50_;
	guint _tmp51_;
	guint _tmp52_;
	SoupMessage* _tmp53_;
	guint _tmp54_;
	guint _tmp55_;
	SoupMessage* _tmp56_;
	guint _tmp57_;
	guint _tmp58_;
	SoupMessage* _tmp59_;
	guint _tmp60_;
	guint _tmp61_;
	GError* _inner_error0_ = NULL;
#line 62 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 62 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (method != NULL, NULL);
#line 62 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (last_part != NULL, NULL);
#line 62 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_return_val_if_fail (((g_strcmp0 (method, "DELETE") == 0) || (g_strcmp0 (method, "GET") == 0)) || (g_strcmp0 (method, "POST") == 0), "method == \"DELETE\" || method == \"GET\" || method == \"POST\"", NULL);
#line 62 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_return_val_if_fail ((input == NULL) || (g_strcmp0 (method, "GET") != 0), "input == null || method != \"GET\"", NULL);
#line 68 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = self->priv->m_base_uri;
#line 68 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = g_strconcat (_tmp0_, last_part, NULL);
#line 68 "../plugins/backend/feedbin/feedbinAPI.vala"
	path = _tmp1_;
#line 69 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = path;
#line 69 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = soup_message_new (method, _tmp2_);
#line 69 "../plugins/backend/feedbin/feedbinAPI.vala"
	message = _tmp3_;
#line 71 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (g_strcmp0 (method, "POST") == 0) {
#line 531 "feedbinAPI.c"
		SoupMessage* _tmp4_;
		SoupMessageHeaders* _tmp5_;
#line 73 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp4_ = message;
#line 73 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp5_ = _tmp4_->request_headers;
#line 73 "../plugins/backend/feedbin/feedbinAPI.vala"
		soup_message_headers_append (_tmp5_, "Content-Type", "application/json; charset=utf-8");
#line 540 "feedbinAPI.c"
	}
#line 76 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (input != NULL) {
#line 544 "feedbinAPI.c"
		SoupMessage* _tmp6_;
		SoupMessageBody* _tmp7_;
		guint8* _tmp8_;
		gint _tmp8__length1;
		guint8* _tmp9_;
		gint _tmp9__length1;
		guint8* _tmp10_;
		gint _tmp10__length1;
#line 78 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp6_ = message;
#line 78 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp7_ = _tmp6_->request_body;
#line 78 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp8_ = string_get_data (input, &_tmp8__length1);
#line 78 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp9_ = _tmp8_;
#line 78 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp9__length1 = _tmp8__length1;
#line 78 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp10_ = (_tmp9_ != NULL) ? _vala_array_dup1 (_tmp9_, _tmp9__length1) : ((gpointer) _tmp9_);
#line 78 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp10__length1 = _tmp9__length1;
#line 78 "../plugins/backend/feedbin/feedbinAPI.vala"
		soup_message_body_append_take (_tmp7_, _tmp10_, (gsize) _tmp10__length1);
#line 569 "feedbinAPI.c"
	}
#line 81 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp11_ = self->priv->m_session;
#line 81 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp12_ = message;
#line 81 "../plugins/backend/feedbin/feedbinAPI.vala"
	soup_session_send_message (_tmp11_, _tmp12_);
#line 82 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp13_ = message;
#line 82 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_object_get (_tmp13_, "status-code", &_tmp14_, NULL);
#line 82 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp15_ = _tmp14_;
#line 82 "../plugins/backend/feedbin/feedbinAPI.vala"
	status = _tmp15_;
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (status < ((guint) 200)) {
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp16_ = TRUE;
#line 589 "feedbinAPI.c"
	} else {
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp16_ = status >= ((guint) 400);
#line 593 "feedbinAPI.c"
	}
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (_tmp16_) {
#line 597 "feedbinAPI.c"
		gchar* phrase = NULL;
		const gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		const gchar* _tmp41_;
		const gchar* _tmp42_;
		const gchar* _tmp43_;
		const gchar* _tmp44_;
		const gchar* _tmp45_;
		gchar* _tmp46_;
		gchar* _tmp47_;
		GError* _tmp48_;
		GError* _tmp49_;
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
		switch (status) {
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
			case SOUP_STATUS_CANT_RESOLVE:
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
			case SOUP_STATUS_CANT_RESOLVE_PROXY:
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
			case SOUP_STATUS_CANT_CONNECT:
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
			case SOUP_STATUS_CANT_CONNECT_PROXY:
#line 622 "feedbinAPI.c"
			{
				const gchar* _tmp17_;
				const gchar* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				GError* _tmp21_;
				GError* _tmp22_;
#line 91 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp17_ = self->priv->m_base_uri;
#line 91 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp18_ = string_to_string (_tmp17_);
#line 91 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp19_ = g_strconcat ("Connection to ", _tmp18_, " failed", NULL);
#line 91 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp20_ = _tmp19_;
#line 91 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp21_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_NO_CONNECTION, _tmp20_);
#line 91 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp22_ = _tmp21_;
#line 91 "../plugins/backend/feedbin/feedbinAPI.vala"
				_g_free0 (_tmp20_);
#line 91 "../plugins/backend/feedbin/feedbinAPI.vala"
				_inner_error0_ = _tmp22_;
#line 91 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 91 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_propagate_error (error, _inner_error0_);
#line 91 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_object_unref0 (message);
#line 91 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_free0 (path);
#line 91 "../plugins/backend/feedbin/feedbinAPI.vala"
					return NULL;
#line 656 "feedbinAPI.c"
				} else {
#line 91 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_object_unref0 (message);
#line 91 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_free0 (path);
#line 91 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 91 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_clear_error (&_inner_error0_);
#line 91 "../plugins/backend/feedbin/feedbinAPI.vala"
					return NULL;
#line 668 "feedbinAPI.c"
				}
			}
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
			case SOUP_STATUS_UNAUTHORIZED:
#line 673 "feedbinAPI.c"
			{
				const gchar* _tmp23_;
				const gchar* _tmp24_;
				const gchar* _tmp25_;
				gchar* _tmp26_;
				gchar* _tmp27_;
				GError* _tmp28_;
				GError* _tmp29_;
#line 93 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp23_ = string_to_string (method);
#line 93 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp24_ = path;
#line 93 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp25_ = string_to_string (_tmp24_);
#line 93 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp26_ = g_strconcat ("Not authorized to ", _tmp23_, " ", _tmp25_, NULL);
#line 93 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp27_ = _tmp26_;
#line 93 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp28_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_AUTHORIZED, _tmp27_);
#line 93 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp29_ = _tmp28_;
#line 93 "../plugins/backend/feedbin/feedbinAPI.vala"
				_g_free0 (_tmp27_);
#line 93 "../plugins/backend/feedbin/feedbinAPI.vala"
				_inner_error0_ = _tmp29_;
#line 93 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 93 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_propagate_error (error, _inner_error0_);
#line 93 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_object_unref0 (message);
#line 93 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_free0 (path);
#line 93 "../plugins/backend/feedbin/feedbinAPI.vala"
					return NULL;
#line 710 "feedbinAPI.c"
				} else {
#line 93 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_object_unref0 (message);
#line 93 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_free0 (path);
#line 93 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 93 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_clear_error (&_inner_error0_);
#line 93 "../plugins/backend/feedbin/feedbinAPI.vala"
					return NULL;
#line 722 "feedbinAPI.c"
				}
			}
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
			case SOUP_STATUS_NOT_FOUND:
#line 727 "feedbinAPI.c"
			{
				const gchar* _tmp30_;
				const gchar* _tmp31_;
				const gchar* _tmp32_;
				gchar* _tmp33_;
				gchar* _tmp34_;
				GError* _tmp35_;
				GError* _tmp36_;
#line 95 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp30_ = string_to_string (method);
#line 95 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp31_ = path;
#line 95 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp32_ = string_to_string (_tmp31_);
#line 95 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp33_ = g_strconcat (_tmp30_, " ", _tmp32_, " not found", NULL);
#line 95 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp34_ = _tmp33_;
#line 95 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp35_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_FOUND, _tmp34_);
#line 95 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp36_ = _tmp35_;
#line 95 "../plugins/backend/feedbin/feedbinAPI.vala"
				_g_free0 (_tmp34_);
#line 95 "../plugins/backend/feedbin/feedbinAPI.vala"
				_inner_error0_ = _tmp36_;
#line 95 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 95 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_propagate_error (error, _inner_error0_);
#line 95 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_object_unref0 (message);
#line 95 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_free0 (path);
#line 95 "../plugins/backend/feedbin/feedbinAPI.vala"
					return NULL;
#line 764 "feedbinAPI.c"
				} else {
#line 95 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_object_unref0 (message);
#line 95 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_free0 (path);
#line 95 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 95 "../plugins/backend/feedbin/feedbinAPI.vala"
					g_clear_error (&_inner_error0_);
#line 95 "../plugins/backend/feedbin/feedbinAPI.vala"
					return NULL;
#line 776 "feedbinAPI.c"
				}
			}
			default:
#line 85 "../plugins/backend/feedbin/feedbinAPI.vala"
			break;
#line 782 "feedbinAPI.c"
		}
#line 97 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp37_ = soup_status_get_phrase (status);
#line 97 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp38_ = g_strdup (_tmp37_);
#line 97 "../plugins/backend/feedbin/feedbinAPI.vala"
		phrase = _tmp38_;
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp39_ = g_strdup_printf ("%u", status);
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp40_ = _tmp39_;
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp41_ = phrase;
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp42_ = string_to_string (_tmp41_);
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp43_ = string_to_string (method);
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp44_ = path;
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp45_ = string_to_string (_tmp44_);
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp46_ = g_strconcat ("Unexpected status ", _tmp40_, " (", _tmp42_, ") for ", _tmp43_, " ", _tmp45_, NULL);
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp47_ = _tmp46_;
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp48_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_UNKNOWN_ERROR, _tmp47_);
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp49_ = _tmp48_;
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp47_);
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp40_);
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error0_ = _tmp49_;
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (phrase);
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (message);
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (path);
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 830 "feedbinAPI.c"
		} else {
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (phrase);
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (message);
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (path);
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 98 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 844 "feedbinAPI.c"
		}
#line 83 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (phrase);
#line 848 "feedbinAPI.c"
	}
#line 100 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = message;
#line 100 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (path);
#line 100 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp50_ = result;
#line 100 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_object_get (_tmp50_, "status-code", &_tmp51_, NULL);
#line 100 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp52_ = _tmp51_;
#line 100 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_warn_if_fail (_tmp52_ >= ((guint) 200), "result.status_code >= 200");
#line 100 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp53_ = result;
#line 100 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_object_get (_tmp53_, "status-code", &_tmp54_, NULL);
#line 100 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp55_ = _tmp54_;
#line 100 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_warn_if_fail (_tmp55_ < ((guint) 400), "result.status_code < 400");
#line 100 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 872 "feedbinAPI.c"
}

static GDateTime*
feedbin_api_string_to_datetime (const gchar* s,
                                GError** error)
{
	GDateTime* result = NULL;
	GTimeVal time = {0};
	GTimeVal _tmp5_;
	GDateTime* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 104 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 106 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_get_current_time (&time);
#line 107 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (!g_time_val_from_iso8601 (s, &time)) {
#line 890 "feedbinAPI.c"
		const gchar* _tmp0_;
		gchar* _tmp1_;
		gchar* _tmp2_;
		GError* _tmp3_;
		GError* _tmp4_;
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp0_ = string_to_string (s);
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp1_ = g_strconcat ("Expected date but got ", _tmp0_, NULL);
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp2_ = _tmp1_;
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp3_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_INVALID_FORMAT, _tmp2_);
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp4_ = _tmp3_;
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp2_);
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error0_ = _tmp4_;
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 916 "feedbinAPI.c"
		} else {
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 109 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 924 "feedbinAPI.c"
		}
	}
#line 111 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = time;
#line 111 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp6_ = g_date_time_new_from_timeval_utc (&_tmp5_);
#line 111 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp6_;
#line 111 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 935 "feedbinAPI.c"
}

static GDateTime*
feedbin_api_get_datetime_member (JsonObject* obj,
                                 const gchar* name,
                                 GError** error)
{
	GDateTime* result = NULL;
	gchar* s = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	GDateTime* _tmp2_ = NULL;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 115 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (obj != NULL, NULL);
#line 115 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 115 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_return_val_if_fail (g_strcmp0 (name, "") != 0, "name != \"\"", NULL);
#line 118 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = json_object_get_string_member (obj, name);
#line 118 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 118 "../plugins/backend/feedbin/feedbinAPI.vala"
	s = _tmp1_;
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = feedbin_api_string_to_datetime (s, &_inner_error0_);
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp3_;
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (s);
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 977 "feedbinAPI.c"
		} else {
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (s);
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 987 "feedbinAPI.c"
		}
	}
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = _tmp2_;
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = NULL;
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp4_;
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 (_tmp2_);
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (s);
#line 119 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 1002 "feedbinAPI.c"
}

static SoupMessage*
feedbin_api_post_request (FeedbinAPI* self,
                          const gchar* path,
                          const gchar* input,
                          GError** error)
{
	SoupMessage* result = NULL;
	SoupMessage* _tmp0_ = NULL;
	SoupMessage* _tmp1_;
	SoupMessage* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 122 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 122 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 122 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 122 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_return_val_if_fail (g_strcmp0 (input, "") != 0, "input != \"\"", NULL);
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = feedbin_api_request (self, "POST", path, input, &_inner_error0_);
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = _tmp1_;
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1036 "feedbinAPI.c"
		} else {
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1044 "feedbinAPI.c"
		}
	}
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp0_;
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = NULL;
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp2_;
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp0_);
#line 125 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 1057 "feedbinAPI.c"
}

static SoupMessage*
feedbin_api_delete_request (FeedbinAPI* self,
                            const gchar* path,
                            GError** error)
{
	SoupMessage* result = NULL;
	SoupMessage* _tmp0_ = NULL;
	SoupMessage* _tmp1_;
	SoupMessage* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 128 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 128 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 130 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = feedbin_api_request (self, "DELETE", path, NULL, &_inner_error0_);
#line 130 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = _tmp1_;
#line 130 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 130 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 130 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 130 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1086 "feedbinAPI.c"
		} else {
#line 130 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 130 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 130 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1094 "feedbinAPI.c"
		}
	}
#line 130 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp0_;
#line 130 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = NULL;
#line 130 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp2_;
#line 130 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp0_);
#line 130 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 1107 "feedbinAPI.c"
}

static SoupMessage*
feedbin_api_get_request (FeedbinAPI* self,
                         const gchar* path,
                         GError** error)
{
	SoupMessage* result = NULL;
	SoupMessage* _tmp0_ = NULL;
	SoupMessage* _tmp1_;
	SoupMessage* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 133 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 133 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = feedbin_api_request (self, "GET", path, NULL, &_inner_error0_);
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = _tmp1_;
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1136 "feedbinAPI.c"
		} else {
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1144 "feedbinAPI.c"
		}
	}
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp0_;
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = NULL;
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp2_;
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp0_);
#line 135 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 1157 "feedbinAPI.c"
}

static void
_vala_SoupBuffer_free (SoupBuffer* self)
{
#line 142 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_boxed_free (soup_buffer_get_type (), self);
#line 1165 "feedbinAPI.c"
}

static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
#line 157 "../plugins/backend/feedbin/feedbinAPI.vala"
	return g_boxed_copy (json_node_get_type (), self);
#line 1173 "feedbinAPI.c"
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
#line 157 "../plugins/backend/feedbin/feedbinAPI.vala"
	return self ? _vala_JsonNode_copy (self) : NULL;
#line 1181 "feedbinAPI.c"
}

static JsonNode*
feedbin_api_parse_json (SoupMessage* response,
                        GError** error)
{
	JsonNode* result = NULL;
	gchar* method = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* uri = NULL;
	SoupURI* _tmp2_;
	SoupURI* _tmp3_;
	gchar* _tmp4_;
	gchar* content = NULL;
	SoupMessageBody* _tmp5_;
	SoupBuffer* _tmp6_;
	SoupBuffer* _tmp7_;
	guint8* _tmp8_;
	gint _tmp8__length1;
	gchar* _tmp9_;
	gchar* _tmp10_;
	const gchar* _tmp11_;
	JsonParser* parser = NULL;
	JsonParser* _tmp20_;
	JsonParser* _tmp37_;
	JsonNode* _tmp38_;
	JsonNode* _tmp39_;
	GError* _inner_error0_ = NULL;
#line 138 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (response != NULL, NULL);
#line 140 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_object_get (response, "method", &_tmp0_, NULL);
#line 140 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = _tmp0_;
#line 140 "../plugins/backend/feedbin/feedbinAPI.vala"
	method = _tmp1_;
#line 141 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = soup_message_get_uri (response);
#line 141 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = _tmp2_;
#line 141 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = soup_uri_to_string (_tmp3_, FALSE);
#line 141 "../plugins/backend/feedbin/feedbinAPI.vala"
	uri = _tmp4_;
#line 142 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = response->response_body;
#line 142 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp6_ = soup_message_body_flatten (_tmp5_);
#line 142 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp7_ = _tmp6_;
#line 142 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp8_ = _tmp7_->data;
#line 142 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp8__length1 = _tmp7_->length;
#line 142 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp9_ = g_strdup ((const gchar*) _tmp8_);
#line 142 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp10_ = _tmp9_;
#line 142 "../plugins/backend/feedbin/feedbinAPI.vala"
	__vala_SoupBuffer_free0 (_tmp7_);
#line 142 "../plugins/backend/feedbin/feedbinAPI.vala"
	content = _tmp10_;
#line 143 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp11_ = content;
#line 143 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (_tmp11_ == NULL) {
#line 1249 "feedbinAPI.c"
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		GError* _tmp18_;
		GError* _tmp19_;
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp12_ = method;
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp13_ = string_to_string (_tmp12_);
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp14_ = uri;
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp15_ = string_to_string (_tmp14_);
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp16_ = g_strconcat (_tmp13_, " ", _tmp15_, " returned no content but expected JSON", NULL);
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp17_ = _tmp16_;
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp18_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_INVALID_FORMAT, _tmp17_);
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp19_ = _tmp18_;
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp17_);
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error0_ = _tmp19_;
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (content);
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (uri);
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (method);
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1290 "feedbinAPI.c"
		} else {
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (content);
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (uri);
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (method);
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 145 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1304 "feedbinAPI.c"
		}
	}
#line 148 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp20_ = json_parser_new ();
#line 148 "../plugins/backend/feedbin/feedbinAPI.vala"
	parser = _tmp20_;
#line 1311 "feedbinAPI.c"
	{
		JsonParser* _tmp21_;
		const gchar* _tmp22_;
#line 151 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp21_ = parser;
#line 151 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp22_ = content;
#line 151 "../plugins/backend/feedbin/feedbinAPI.vala"
		json_parser_load_from_data (_tmp21_, _tmp22_, (gssize) -1, &_inner_error0_);
#line 151 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1323 "feedbinAPI.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp23_;
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		const gchar* _tmp26_;
		gchar* _tmp27_;
		gchar* _tmp28_;
		GError* _tmp29_;
		const gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		GError* _tmp35_;
		GError* _tmp36_;
#line 149 "../plugins/backend/feedbin/feedbinAPI.vala"
		e = _inner_error0_;
#line 149 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error0_ = NULL;
#line 155 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp23_ = method;
#line 155 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp24_ = string_to_string (_tmp23_);
#line 155 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp25_ = uri;
#line 155 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp26_ = string_to_string (_tmp25_);
#line 155 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp27_ = g_strconcat (_tmp24_, " ", _tmp26_, " returned invalid JSON: ", NULL);
#line 155 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp28_ = _tmp27_;
#line 155 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp29_ = e;
#line 155 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp30_ = _tmp29_->message;
#line 155 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp31_ = g_strconcat (_tmp28_, _tmp30_, NULL);
#line 155 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp32_ = _tmp31_;
#line 155 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp33_ = g_strconcat (_tmp32_, "\nContent is: $content", NULL);
#line 155 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp34_ = _tmp33_;
#line 155 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp35_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_INVALID_FORMAT, _tmp34_);
#line 155 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp36_ = _tmp35_;
#line 155 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp34_);
#line 155 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp32_);
#line 155 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp28_);
#line 155 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error0_ = _tmp36_;
#line 155 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_error_free0 (e);
#line 1387 "feedbinAPI.c"
		goto __finally0;
	}
	__finally0:
#line 149 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 149 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 149 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 149 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (parser);
#line 149 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (content);
#line 149 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (uri);
#line 149 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (method);
#line 149 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1407 "feedbinAPI.c"
		} else {
#line 149 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (parser);
#line 149 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (content);
#line 149 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (uri);
#line 149 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (method);
#line 149 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 149 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 149 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1423 "feedbinAPI.c"
		}
	}
#line 157 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp37_ = parser;
#line 157 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp38_ = json_parser_get_root (_tmp37_);
#line 157 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp39_ = __vala_JsonNode_copy0 (_tmp38_);
#line 157 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp39_;
#line 157 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (parser);
#line 157 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (content);
#line 157 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (uri);
#line 157 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (method);
#line 157 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 1444 "feedbinAPI.c"
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_boxed_free (json_node_get_type (), self);
#line 1452 "feedbinAPI.c"
}

static JsonNode*
feedbin_api_get_json (FeedbinAPI* self,
                      const gchar* path,
                      GError** error)
{
	JsonNode* result = NULL;
	SoupMessage* response = NULL;
	SoupMessage* _tmp0_;
	JsonNode* _tmp1_ = NULL;
	SoupMessage* _tmp2_;
	JsonNode* _tmp3_;
	JsonNode* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 160 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 160 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 160 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_return_val_if_fail (g_strcmp0 (path, "") != 0, "path != \"\"", NULL);
#line 163 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = feedbin_api_get_request (self, path, &_inner_error0_);
#line 163 "../plugins/backend/feedbin/feedbinAPI.vala"
	response = _tmp0_;
#line 163 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 163 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 163 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 163 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1486 "feedbinAPI.c"
		} else {
#line 163 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 163 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 163 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1494 "feedbinAPI.c"
		}
	}
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = response;
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = feedbin_api_parse_json (_tmp2_, &_inner_error0_);
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = _tmp3_;
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (response);
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1513 "feedbinAPI.c"
		} else {
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (response);
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1523 "feedbinAPI.c"
		}
	}
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = _tmp1_;
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = NULL;
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp4_;
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
	__vala_JsonNode_free0 (_tmp1_);
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (response);
#line 164 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 1538 "feedbinAPI.c"
}

static SoupMessage*
feedbin_api_post_json_object (FeedbinAPI* self,
                              const gchar* path,
                              JsonObject* obj,
                              GError** error)
{
	SoupMessage* result = NULL;
	JsonNode* root = NULL;
	JsonNode* _tmp0_;
	JsonGenerator* gen = NULL;
	JsonGenerator* _tmp1_;
	gchar* data = NULL;
	gchar* _tmp2_;
	SoupMessage* _tmp3_ = NULL;
	SoupMessage* _tmp4_;
	SoupMessage* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 167 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 167 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 167 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (obj != NULL, NULL);
#line 169 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = json_node_new (JSON_NODE_OBJECT);
#line 169 "../plugins/backend/feedbin/feedbinAPI.vala"
	root = _tmp0_;
#line 170 "../plugins/backend/feedbin/feedbinAPI.vala"
	json_node_set_object (root, obj);
#line 172 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = json_generator_new ();
#line 172 "../plugins/backend/feedbin/feedbinAPI.vala"
	gen = _tmp1_;
#line 173 "../plugins/backend/feedbin/feedbinAPI.vala"
	json_generator_set_root (gen, root);
#line 174 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = json_generator_to_data (gen, NULL);
#line 174 "../plugins/backend/feedbin/feedbinAPI.vala"
	data = _tmp2_;
#line 176 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = feedbin_api_post_request (self, path, data, &_inner_error0_);
#line 176 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = _tmp4_;
#line 176 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 176 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 176 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 176 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (data);
#line 176 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (gen);
#line 176 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 176 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1598 "feedbinAPI.c"
		} else {
#line 176 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (data);
#line 176 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (gen);
#line 176 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 176 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 176 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 176 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1612 "feedbinAPI.c"
		}
	}
#line 176 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = _tmp3_;
#line 176 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = NULL;
#line 176 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp5_;
#line 176 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp3_);
#line 176 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (data);
#line 176 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (gen);
#line 176 "../plugins/backend/feedbin/feedbinAPI.vala"
	__vala_JsonNode_free0 (root);
#line 176 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 1631 "feedbinAPI.c"
}

gboolean
feedbin_api_login (FeedbinAPI* self,
                   GError** error)
{
	gboolean result = FALSE;
	GError* _inner_error0_ = NULL;
#line 179 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1642 "feedbinAPI.c"
	{
		SoupMessage* res = NULL;
		SoupMessage* _tmp0_;
		guint _tmp1_;
		guint _tmp2_;
#line 183 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp0_ = feedbin_api_get_request (self, "authentication.json", &_inner_error0_);
#line 183 "../plugins/backend/feedbin/feedbinAPI.vala"
		res = _tmp0_;
#line 183 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 183 "../plugins/backend/feedbin/feedbinAPI.vala"
			if (g_error_matches (_inner_error0_, FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_AUTHORIZED)) {
#line 1656 "feedbinAPI.c"
				goto __catch1_feedbin_error_not_authorized;
			}
			goto __finally1;
		}
#line 184 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_object_get (res, "status-code", &_tmp1_, NULL);
#line 184 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp2_ = _tmp1_;
#line 184 "../plugins/backend/feedbin/feedbinAPI.vala"
		result = _tmp2_ == ((guint) SOUP_STATUS_OK);
#line 184 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_object_unref0 (res);
#line 184 "../plugins/backend/feedbin/feedbinAPI.vala"
		return result;
#line 1671 "feedbinAPI.c"
	}
	goto __finally1;
	__catch1_feedbin_error_not_authorized:
	{
		GError* e = NULL;
#line 181 "../plugins/backend/feedbin/feedbinAPI.vala"
		e = _inner_error0_;
#line 181 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error0_ = NULL;
#line 188 "../plugins/backend/feedbin/feedbinAPI.vala"
		result = FALSE;
#line 188 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_error_free0 (e);
#line 188 "../plugins/backend/feedbin/feedbinAPI.vala"
		return result;
#line 1687 "feedbinAPI.c"
	}
	__finally1:
#line 181 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 1692 "feedbinAPI.c"
		gboolean _tmp3_ = FALSE;
#line 181 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_propagate_error (error, _inner_error0_);
#line 181 "../plugins/backend/feedbin/feedbinAPI.vala"
		return _tmp3_;
#line 1698 "feedbinAPI.c"
	} else {
		gboolean _tmp4_ = FALSE;
#line 181 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 181 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_clear_error (&_inner_error0_);
#line 181 "../plugins/backend/feedbin/feedbinAPI.vala"
		return _tmp4_;
#line 1707 "feedbinAPI.c"
	}
}

void
feedbin_api_get_subscription (FeedbinAPI* self,
                              gint64 subscription_id,
                              FeedbinAPISubscription* result,
                              GError** error)
{
	JsonNode* root = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	JsonNode* _tmp4_;
	JsonNode* _tmp5_;
	FeedbinAPISubscription _tmp6_ = {0};
	JsonNode* _tmp7_;
	JsonObject* _tmp8_;
	FeedbinAPISubscription _tmp9_;
	GError* _inner_error0_ = NULL;
#line 211 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = g_strdup_printf ("%" G_GINT64_FORMAT, subscription_id);
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = _tmp0_;
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = g_strconcat ("subscriptions/", _tmp1_, ".json", NULL);
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = _tmp2_;
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = feedbin_api_get_json (self, _tmp3_, &_inner_error0_);
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = _tmp4_;
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp3_);
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp1_);
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
	root = _tmp5_;
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 1757 "feedbinAPI.c"
		} else {
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 213 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 1765 "feedbinAPI.c"
		}
	}
#line 214 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp7_ = root;
#line 214 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp8_ = json_node_get_object (_tmp7_);
#line 214 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_subscription_init_from_json (&_tmp6_, _tmp8_, &_inner_error0_);
#line 214 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 214 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 214 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 214 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 214 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 1784 "feedbinAPI.c"
		} else {
#line 214 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 214 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 214 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 214 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 1794 "feedbinAPI.c"
		}
	}
#line 214 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp9_ = _tmp6_;
#line 214 "../plugins/backend/feedbin/feedbinAPI.vala"
	memset (&_tmp6_, 0, sizeof (FeedbinAPISubscription));
#line 214 "../plugins/backend/feedbin/feedbinAPI.vala"
	*result = _tmp9_;
#line 214 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_subscription_destroy (&_tmp6_);
#line 214 "../plugins/backend/feedbin/feedbinAPI.vala"
	__vala_JsonNode_free0 (root);
#line 214 "../plugins/backend/feedbin/feedbinAPI.vala"
	return;
#line 1809 "feedbinAPI.c"
}

static gpointer
_json_array_ref0 (gpointer self)
{
#line 222 "../plugins/backend/feedbin/feedbinAPI.vala"
	return self ? json_array_ref (self) : NULL;
#line 1817 "feedbinAPI.c"
}

static gpointer
_json_object_ref0 (gpointer self)
{
#line 225 "../plugins/backend/feedbin/feedbinAPI.vala"
	return self ? json_object_ref (self) : NULL;
#line 1825 "feedbinAPI.c"
}

GeeList*
feedbin_api_get_subscriptions (FeedbinAPI* self,
                               GError** error)
{
	GeeList* result = NULL;
	JsonNode* root = NULL;
	JsonNode* _tmp0_;
	GeeArrayList* subscriptions = NULL;
	GeeArrayList* _tmp1_;
	JsonArray* array = NULL;
	JsonNode* _tmp2_;
	JsonArray* _tmp3_;
	JsonArray* _tmp4_;
	GeeList* _tmp13_;
	GeeList* _tmp14_;
	GError* _inner_error0_ = NULL;
#line 217 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 220 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = feedbin_api_get_json (self, "subscriptions.json", &_inner_error0_);
#line 220 "../plugins/backend/feedbin/feedbinAPI.vala"
	root = _tmp0_;
#line 220 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 220 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 220 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 220 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1858 "feedbinAPI.c"
		} else {
#line 220 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 220 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 220 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 1866 "feedbinAPI.c"
		}
	}
#line 221 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = gee_array_list_new (FEEDBIN_API_TYPE_SUBSCRIPTION, (GBoxedCopyFunc) feedbin_api_subscription_dup, (GDestroyNotify) feedbin_api_subscription_free, NULL, NULL, NULL);
#line 221 "../plugins/backend/feedbin/feedbinAPI.vala"
	subscriptions = _tmp1_;
#line 222 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = root;
#line 222 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = json_node_get_array (_tmp2_);
#line 222 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = _json_array_ref0 (_tmp3_);
#line 222 "../plugins/backend/feedbin/feedbinAPI.vala"
	array = _tmp4_;
#line 1881 "feedbinAPI.c"
	{
		gint i = 0;
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
		i = 0;
#line 1886 "feedbinAPI.c"
		{
			gboolean _tmp5_ = FALSE;
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp5_ = TRUE;
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
			while (TRUE) {
#line 1893 "feedbinAPI.c"
				JsonArray* _tmp6_;
				JsonObject* node = NULL;
				JsonArray* _tmp7_;
				JsonObject* _tmp8_;
				JsonObject* _tmp9_;
				FeedbinAPISubscription _tmp10_ = {0};
				JsonObject* _tmp11_;
				GeeArrayList* _tmp12_;
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (!_tmp5_) {
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
					i = i + 1;
#line 1906 "feedbinAPI.c"
				}
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp5_ = FALSE;
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp6_ = array;
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (!(((guint) i) < json_array_get_length (_tmp6_))) {
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
					break;
#line 1916 "feedbinAPI.c"
				}
#line 225 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp7_ = array;
#line 225 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp8_ = json_array_get_object_element (_tmp7_, (guint) i);
#line 225 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp9_ = _json_object_ref0 (_tmp8_);
#line 225 "../plugins/backend/feedbin/feedbinAPI.vala"
				node = _tmp9_;
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp11_ = node;
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
				feedbin_api_subscription_init_from_json (&_tmp10_, _tmp11_, &_inner_error0_);
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
					if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
						g_propagate_error (error, _inner_error0_);
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_object_unref0 (node);
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_array_unref0 (array);
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_object_unref0 (subscriptions);
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
						__vala_JsonNode_free0 (root);
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
						return NULL;
#line 1946 "feedbinAPI.c"
					} else {
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_object_unref0 (node);
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_array_unref0 (array);
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_object_unref0 (subscriptions);
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
						__vala_JsonNode_free0 (root);
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
						g_clear_error (&_inner_error0_);
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
						return NULL;
#line 1962 "feedbinAPI.c"
					}
				}
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp12_ = subscriptions;
#line 226 "../plugins/backend/feedbin/feedbinAPI.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp12_, &_tmp10_);
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
				feedbin_api_subscription_destroy (&_tmp10_);
#line 223 "../plugins/backend/feedbin/feedbinAPI.vala"
				_json_object_unref0 (node);
#line 1973 "feedbinAPI.c"
			}
		}
	}
#line 228 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = (GeeList*) subscriptions;
#line 228 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_array_unref0 (array);
#line 228 "../plugins/backend/feedbin/feedbinAPI.vala"
	__vala_JsonNode_free0 (root);
#line 228 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp13_ = result;
#line 228 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_warn_if_fail (!gee_collection_contains ((GeeCollection*) _tmp13_, NULL), "!result.contains(null)");
#line 228 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 1989 "feedbinAPI.c"
}

void
feedbin_api_delete_subscription (FeedbinAPI* self,
                                 gint64 subscription_id,
                                 GError** error)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	SoupMessage* _tmp4_;
	SoupMessage* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 231 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 233 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = g_strdup_printf ("%" G_GINT64_FORMAT, subscription_id);
#line 233 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = _tmp0_;
#line 233 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = g_strconcat ("subscriptions/", _tmp1_, ".json", NULL);
#line 233 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = _tmp2_;
#line 233 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = feedbin_api_delete_request (self, _tmp3_, &_inner_error0_);
#line 233 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = _tmp4_;
#line 233 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp5_);
#line 233 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp3_);
#line 233 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp1_);
#line 233 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 233 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 233 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 233 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 2032 "feedbinAPI.c"
		} else {
#line 233 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 233 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 233 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 2040 "feedbinAPI.c"
		}
	}
}

static gpointer
_feedbin_api_subscription_dup0 (gpointer self)
{
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
	return self ? feedbin_api_subscription_dup (self) : NULL;
#line 2050 "feedbinAPI.c"
}

FeedbinAPISubscription*
feedbin_api_add_subscription (FeedbinAPI* self,
                              const gchar* url,
                              GError** error)
{
	FeedbinAPISubscription* result = NULL;
	JsonObject* object = NULL;
	JsonObject* _tmp0_;
	JsonObject* _tmp1_;
	GError* _inner_error0_ = NULL;
#line 236 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 236 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (url != NULL, NULL);
#line 238 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = json_object_new ();
#line 238 "../plugins/backend/feedbin/feedbinAPI.vala"
	object = _tmp0_;
#line 239 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = object;
#line 239 "../plugins/backend/feedbin/feedbinAPI.vala"
	json_object_set_string_member (_tmp1_, "feed_url", url);
#line 2075 "feedbinAPI.c"
	{
		SoupMessage* response = NULL;
		JsonObject* _tmp2_;
		SoupMessage* _tmp3_;
		SoupMessage* _tmp4_;
		guint _tmp5_;
		guint _tmp6_;
		JsonNode* root = NULL;
		SoupMessage* _tmp8_;
		JsonNode* _tmp9_;
		FeedbinAPISubscription _tmp10_ = {0};
		JsonNode* _tmp11_;
		JsonObject* _tmp12_;
		FeedbinAPISubscription _tmp13_;
		FeedbinAPISubscription _tmp14_;
		FeedbinAPISubscription* _tmp15_;
		FeedbinAPISubscription* _tmp16_;
#line 243 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp2_ = object;
#line 243 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp3_ = feedbin_api_post_json_object (self, "subscriptions.json", _tmp2_, &_inner_error0_);
#line 243 "../plugins/backend/feedbin/feedbinAPI.vala"
		response = _tmp3_;
#line 243 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 243 "../plugins/backend/feedbin/feedbinAPI.vala"
			if (g_error_matches (_inner_error0_, FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_FOUND)) {
#line 2103 "feedbinAPI.c"
				goto __catch2_feedbin_error_not_found;
			}
			goto __finally2;
		}
#line 244 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp4_ = response;
#line 244 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_object_get (_tmp4_, "status-code", &_tmp5_, NULL);
#line 244 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp6_ = _tmp5_;
#line 244 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_tmp6_ == ((guint) 300)) {
#line 2116 "feedbinAPI.c"
			GError* _tmp7_;
#line 246 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp7_ = g_error_new_literal (FEEDBIN_ERROR, FEEDBIN_ERROR_MULTIPLE_CHOICES, "Site $url has multiple feeds to subscribe to");
#line 246 "../plugins/backend/feedbin/feedbinAPI.vala"
			_inner_error0_ = _tmp7_;
#line 246 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (response);
#line 246 "../plugins/backend/feedbin/feedbinAPI.vala"
			if (g_error_matches (_inner_error0_, FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_FOUND)) {
#line 2126 "feedbinAPI.c"
				goto __catch2_feedbin_error_not_found;
			}
			goto __finally2;
		}
#line 249 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp8_ = response;
#line 249 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp9_ = feedbin_api_parse_json (_tmp8_, &_inner_error0_);
#line 249 "../plugins/backend/feedbin/feedbinAPI.vala"
		root = _tmp9_;
#line 249 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 249 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (response);
#line 249 "../plugins/backend/feedbin/feedbinAPI.vala"
			if (g_error_matches (_inner_error0_, FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_FOUND)) {
#line 2143 "feedbinAPI.c"
				goto __catch2_feedbin_error_not_found;
			}
			goto __finally2;
		}
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp11_ = root;
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp12_ = json_node_get_object (_tmp11_);
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
		feedbin_api_subscription_init_from_json (&_tmp10_, _tmp12_, &_inner_error0_);
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_object_unref0 (response);
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
			if (g_error_matches (_inner_error0_, FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_FOUND)) {
#line 2162 "feedbinAPI.c"
				goto __catch2_feedbin_error_not_found;
			}
			goto __finally2;
		}
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp13_ = _tmp10_;
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
		memset (&_tmp10_, 0, sizeof (FeedbinAPISubscription));
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp14_ = _tmp13_;
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp15_ = _feedbin_api_subscription_dup0 (&_tmp14_);
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp16_ = _tmp15_;
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
		feedbin_api_subscription_destroy (&_tmp14_);
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
		result = _tmp16_;
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
		feedbin_api_subscription_destroy (&_tmp10_);
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
		__vala_JsonNode_free0 (root);
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_object_unref0 (response);
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
		_json_object_unref0 (object);
#line 250 "../plugins/backend/feedbin/feedbinAPI.vala"
		return result;
#line 2191 "feedbinAPI.c"
	}
	goto __finally2;
	__catch2_feedbin_error_not_found:
	{
		GError* e = NULL;
#line 241 "../plugins/backend/feedbin/feedbinAPI.vala"
		e = _inner_error0_;
#line 241 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error0_ = NULL;
#line 254 "../plugins/backend/feedbin/feedbinAPI.vala"
		result = NULL;
#line 254 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_error_free0 (e);
#line 254 "../plugins/backend/feedbin/feedbinAPI.vala"
		_json_object_unref0 (object);
#line 254 "../plugins/backend/feedbin/feedbinAPI.vala"
		return result;
#line 2209 "feedbinAPI.c"
	}
	__finally2:
#line 241 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 241 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_propagate_error (error, _inner_error0_);
#line 241 "../plugins/backend/feedbin/feedbinAPI.vala"
		_json_object_unref0 (object);
#line 241 "../plugins/backend/feedbin/feedbinAPI.vala"
		return NULL;
#line 2220 "feedbinAPI.c"
	} else {
#line 241 "../plugins/backend/feedbin/feedbinAPI.vala"
		_json_object_unref0 (object);
#line 241 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 241 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_clear_error (&_inner_error0_);
#line 241 "../plugins/backend/feedbin/feedbinAPI.vala"
		return NULL;
#line 2230 "feedbinAPI.c"
	}
#line 236 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_object_unref0 (object);
#line 2234 "feedbinAPI.c"
}

void
feedbin_api_rename_subscription (FeedbinAPI* self,
                                 gint64 subscription_id,
                                 const gchar* title,
                                 GError** error)
{
	JsonObject* object = NULL;
	JsonObject* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	SoupMessage* _tmp5_;
	SoupMessage* _tmp6_;
	GError* _inner_error0_ = NULL;
#line 258 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 258 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (title != NULL);
#line 260 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = json_object_new ();
#line 260 "../plugins/backend/feedbin/feedbinAPI.vala"
	object = _tmp0_;
#line 261 "../plugins/backend/feedbin/feedbinAPI.vala"
	json_object_set_string_member (object, "title", title);
#line 262 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = g_strdup_printf ("%" G_GINT64_FORMAT, subscription_id);
#line 262 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp1_;
#line 262 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = g_strconcat ("subscriptions/", _tmp2_, "/update.json", NULL);
#line 262 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = _tmp3_;
#line 262 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = feedbin_api_post_json_object (self, _tmp4_, object, &_inner_error0_);
#line 262 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp6_ = _tmp5_;
#line 262 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp6_);
#line 262 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp4_);
#line 262 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp2_);
#line 262 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 262 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 262 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 262 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_object_unref0 (object);
#line 262 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 2290 "feedbinAPI.c"
		} else {
#line 262 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_object_unref0 (object);
#line 262 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 262 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 262 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 2300 "feedbinAPI.c"
		}
	}
#line 258 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_object_unref0 (object);
#line 2305 "feedbinAPI.c"
}

void
feedbin_api_add_tagging (FeedbinAPI* self,
                         gint64 feed_id,
                         const gchar* tag_name,
                         GError** error)
{
	JsonObject* object = NULL;
	JsonObject* _tmp0_;
	SoupMessage* _tmp1_;
	SoupMessage* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (tag_name != NULL);
#line 281 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = json_object_new ();
#line 281 "../plugins/backend/feedbin/feedbinAPI.vala"
	object = _tmp0_;
#line 282 "../plugins/backend/feedbin/feedbinAPI.vala"
	json_object_set_int_member (object, "feed_id", feed_id);
#line 283 "../plugins/backend/feedbin/feedbinAPI.vala"
	json_object_set_string_member (object, "name", tag_name);
#line 285 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = feedbin_api_post_json_object (self, "taggings.json", object, &_inner_error0_);
#line 285 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp1_;
#line 285 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp2_);
#line 285 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 285 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 285 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 285 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_object_unref0 (object);
#line 285 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 2347 "feedbinAPI.c"
		} else {
#line 285 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_object_unref0 (object);
#line 285 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 285 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 285 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 2357 "feedbinAPI.c"
		}
	}
#line 279 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_object_unref0 (object);
#line 2362 "feedbinAPI.c"
}

void
feedbin_api_delete_tagging (FeedbinAPI* self,
                            gint64 tagging_id,
                            GError** error)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	SoupMessage* _tmp4_;
	SoupMessage* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 289 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 291 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = g_strdup_printf ("%" G_GINT64_FORMAT, tagging_id);
#line 291 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = _tmp0_;
#line 291 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = g_strconcat ("taggings/", _tmp1_, ".json", NULL);
#line 291 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = _tmp2_;
#line 291 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = feedbin_api_delete_request (self, _tmp3_, &_inner_error0_);
#line 291 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = _tmp4_;
#line 291 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp5_);
#line 291 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp3_);
#line 291 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp1_);
#line 291 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 291 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 291 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 291 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 2405 "feedbinAPI.c"
		} else {
#line 291 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 291 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 291 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 2413 "feedbinAPI.c"
		}
	}
}

GeeList*
feedbin_api_get_taggings (FeedbinAPI* self,
                          GError** error)
{
	GeeList* result = NULL;
	JsonNode* root = NULL;
	JsonNode* _tmp0_;
	GeeArrayList* taggings = NULL;
	GeeArrayList* _tmp1_;
	JsonArray* array = NULL;
	JsonArray* _tmp2_;
	JsonArray* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 294 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 297 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = feedbin_api_get_json (self, "taggings.json", &_inner_error0_);
#line 297 "../plugins/backend/feedbin/feedbinAPI.vala"
	root = _tmp0_;
#line 297 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 297 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 297 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 297 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 2445 "feedbinAPI.c"
		} else {
#line 297 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 297 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 297 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 2453 "feedbinAPI.c"
		}
	}
#line 298 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = gee_array_list_new (FEEDBIN_API_TYPE_TAGGING, (GBoxedCopyFunc) feedbin_api_tagging_dup, (GDestroyNotify) feedbin_api_tagging_free, NULL, NULL, NULL);
#line 298 "../plugins/backend/feedbin/feedbinAPI.vala"
	taggings = _tmp1_;
#line 299 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = json_node_get_array (root);
#line 299 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = _json_array_ref0 (_tmp2_);
#line 299 "../plugins/backend/feedbin/feedbinAPI.vala"
	array = _tmp3_;
#line 2466 "feedbinAPI.c"
	{
		gint i = 0;
#line 300 "../plugins/backend/feedbin/feedbinAPI.vala"
		i = 0;
#line 2471 "feedbinAPI.c"
		{
			gboolean _tmp4_ = FALSE;
#line 300 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp4_ = TRUE;
#line 300 "../plugins/backend/feedbin/feedbinAPI.vala"
			while (TRUE) {
#line 2478 "feedbinAPI.c"
				JsonArray* _tmp5_;
				JsonObject* object = NULL;
				JsonArray* _tmp6_;
				JsonObject* _tmp7_;
				JsonObject* _tmp8_;
				GeeArrayList* _tmp9_;
				JsonObject* _tmp10_;
				FeedbinAPITagging _tmp11_ = {0};
				FeedbinAPITagging _tmp12_;
				FeedbinAPITagging _tmp13_;
#line 300 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (!_tmp4_) {
#line 300 "../plugins/backend/feedbin/feedbinAPI.vala"
					i = i + 1;
#line 2493 "feedbinAPI.c"
				}
#line 300 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp4_ = FALSE;
#line 300 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp5_ = array;
#line 300 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (!(((guint) i) < json_array_get_length (_tmp5_))) {
#line 300 "../plugins/backend/feedbin/feedbinAPI.vala"
					break;
#line 2503 "feedbinAPI.c"
				}
#line 302 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp6_ = array;
#line 302 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp7_ = json_array_get_object_element (_tmp6_, (guint) i);
#line 302 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp8_ = _json_object_ref0 (_tmp7_);
#line 302 "../plugins/backend/feedbin/feedbinAPI.vala"
				object = _tmp8_;
#line 303 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp9_ = taggings;
#line 303 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp10_ = object;
#line 303 "../plugins/backend/feedbin/feedbinAPI.vala"
				feedbin_api_tagging_init_from_json (&_tmp11_, _tmp10_);
#line 303 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp12_ = _tmp11_;
#line 303 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp13_ = _tmp12_;
#line 303 "../plugins/backend/feedbin/feedbinAPI.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp9_, &_tmp13_);
#line 303 "../plugins/backend/feedbin/feedbinAPI.vala"
				feedbin_api_tagging_destroy (&_tmp12_);
#line 300 "../plugins/backend/feedbin/feedbinAPI.vala"
				_json_object_unref0 (object);
#line 2529 "feedbinAPI.c"
			}
		}
	}
#line 305 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = (GeeList*) taggings;
#line 305 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_array_unref0 (array);
#line 305 "../plugins/backend/feedbin/feedbinAPI.vala"
	__vala_JsonNode_free0 (root);
#line 305 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_warn_if_fail (!gee_collection_contains ((GeeCollection*) result, NULL), "!result.contains(null)");
#line 305 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 2543 "feedbinAPI.c"
}

GeeList*
feedbin_api_get_entries (FeedbinAPI* self,
                         gint page,
                         gboolean only_starred,
                         GDateTime* since,
                         gint64* feed_id,
                         GError** error)
{
	GeeList* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* starred = NULL;
	gchar* _tmp1_;
	gchar* path = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	JsonNode* root = NULL;
	GeeArrayList* entries = NULL;
	GeeArrayList* _tmp27_;
	JsonArray* array = NULL;
	JsonNode* _tmp28_;
	JsonArray* _tmp29_;
	JsonArray* _tmp30_;
	GeeList* _tmp39_;
	GeeList* _tmp40_;
	GError* _inner_error0_ = NULL;
#line 334 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 334 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_return_val_if_fail (page >= 0, "page >= 0", NULL);
#line 338 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (only_starred) {
#line 338 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp0_ = "true";
#line 2583 "feedbinAPI.c"
	} else {
#line 338 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp0_ = "false";
#line 2587 "feedbinAPI.c"
	}
#line 338 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 338 "../plugins/backend/feedbin/feedbinAPI.vala"
	starred = _tmp1_;
#line 339 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = g_strdup_printf ("%i", page);
#line 339 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = _tmp2_;
#line 339 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = starred;
#line 339 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = string_to_string (_tmp4_);
#line 339 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp6_ = g_strconcat ("entries.json?per_page=100&page=", _tmp3_, "&starred=", _tmp5_, "&include_enclosure=true", NULL);
#line 339 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp7_ = _tmp6_;
#line 339 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp3_);
#line 339 "../plugins/backend/feedbin/feedbinAPI.vala"
	path = _tmp7_;
#line 340 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (since != NULL) {
#line 2611 "feedbinAPI.c"
		GTimeVal t = {0};
		GTimeVal _tmp8_ = {0};
		gboolean _tmp9_;
#line 342 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_get_current_time (&t);
#line 343 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp9_ = g_date_time_to_timeval (since, &_tmp8_);
#line 343 "../plugins/backend/feedbin/feedbinAPI.vala"
		t = _tmp8_;
#line 343 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_tmp9_) {
#line 2623 "feedbinAPI.c"
			const gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
#line 345 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp10_ = path;
#line 345 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp11_ = g_time_val_to_iso8601 (&t);
#line 345 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp12_ = _tmp11_;
#line 345 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp13_ = g_strconcat ("&since=", _tmp12_, NULL);
#line 345 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp14_ = _tmp13_;
#line 345 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp15_ = g_strconcat (_tmp10_, _tmp14_, NULL);
#line 345 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (path);
#line 345 "../plugins/backend/feedbin/feedbinAPI.vala"
			path = _tmp15_;
#line 345 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (_tmp14_);
#line 345 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (_tmp12_);
#line 2650 "feedbinAPI.c"
		}
	}
#line 349 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (feed_id != NULL) {
#line 2655 "feedbinAPI.c"
		gchar* _tmp16_;
		gchar* _tmp17_;
		const gchar* _tmp18_;
		const gchar* _tmp19_;
		gchar* _tmp20_;
#line 351 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp16_ = g_strdup_printf ("%" G_GINT64_FORMAT, *feed_id);
#line 351 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp17_ = _tmp16_;
#line 351 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp18_ = path;
#line 351 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp19_ = string_to_string (_tmp18_);
#line 351 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp20_ = g_strconcat ("feeds/", _tmp17_, "/", _tmp19_, NULL);
#line 351 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (path);
#line 351 "../plugins/backend/feedbin/feedbinAPI.vala"
		path = _tmp20_;
#line 351 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp17_);
#line 2677 "feedbinAPI.c"
	}
	{
		JsonNode* _tmp21_ = NULL;
		const gchar* _tmp22_;
		JsonNode* _tmp23_;
		JsonNode* _tmp24_;
#line 357 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp22_ = path;
#line 357 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp23_ = feedbin_api_get_json (self, _tmp22_, &_inner_error0_);
#line 357 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp21_ = _tmp23_;
#line 357 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 357 "../plugins/backend/feedbin/feedbinAPI.vala"
			if (g_error_matches (_inner_error0_, FEEDBIN_ERROR, FEEDBIN_ERROR_NOT_FOUND)) {
#line 2694 "feedbinAPI.c"
				goto __catch3_feedbin_error_not_found;
			}
			goto __finally3;
		}
#line 357 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp24_ = _tmp21_;
#line 357 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp21_ = NULL;
#line 357 "../plugins/backend/feedbin/feedbinAPI.vala"
		__vala_JsonNode_free0 (root);
#line 357 "../plugins/backend/feedbin/feedbinAPI.vala"
		root = _tmp24_;
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
		__vala_JsonNode_free0 (_tmp21_);
#line 2709 "feedbinAPI.c"
	}
	goto __finally3;
	__catch3_feedbin_error_not_found:
	{
		GError* e = NULL;
		GeeList* _tmp25_;
		GeeList* _tmp26_;
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
		e = _inner_error0_;
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error0_ = NULL;
#line 361 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp25_ = gee_list_empty (FEEDBIN_API_TYPE_ENTRY, (GBoxedCopyFunc) feedbin_api_entry_dup, (GDestroyNotify) feedbin_api_entry_free);
#line 361 "../plugins/backend/feedbin/feedbinAPI.vala"
		result = _tmp25_;
#line 361 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_error_free0 (e);
#line 361 "../plugins/backend/feedbin/feedbinAPI.vala"
		__vala_JsonNode_free0 (root);
#line 361 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (path);
#line 361 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (starred);
#line 361 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp26_ = result;
#line 361 "../plugins/backend/feedbin/feedbinAPI.vala"
		_vala_warn_if_fail (!gee_collection_contains ((GeeCollection*) _tmp26_, NULL), "!result.contains(null)");
#line 361 "../plugins/backend/feedbin/feedbinAPI.vala"
		return result;
#line 2739 "feedbinAPI.c"
	}
	__finally3:
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (path);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (starred);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 2756 "feedbinAPI.c"
		} else {
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (path);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (starred);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 355 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 2770 "feedbinAPI.c"
		}
	}
#line 364 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp27_ = gee_array_list_new (FEEDBIN_API_TYPE_ENTRY, (GBoxedCopyFunc) feedbin_api_entry_dup, (GDestroyNotify) feedbin_api_entry_free, NULL, NULL, NULL);
#line 364 "../plugins/backend/feedbin/feedbinAPI.vala"
	entries = _tmp27_;
#line 365 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp28_ = root;
#line 365 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp29_ = json_node_get_array (_tmp28_);
#line 365 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp30_ = _json_array_ref0 (_tmp29_);
#line 365 "../plugins/backend/feedbin/feedbinAPI.vala"
	array = _tmp30_;
#line 2785 "feedbinAPI.c"
	{
		gint i = 0;
#line 366 "../plugins/backend/feedbin/feedbinAPI.vala"
		i = 0;
#line 2790 "feedbinAPI.c"
		{
			gboolean _tmp31_ = FALSE;
#line 366 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp31_ = TRUE;
#line 366 "../plugins/backend/feedbin/feedbinAPI.vala"
			while (TRUE) {
#line 2797 "feedbinAPI.c"
				JsonArray* _tmp32_;
				JsonObject* object = NULL;
				JsonArray* _tmp33_;
				JsonObject* _tmp34_;
				JsonObject* _tmp35_;
				FeedbinAPIEntry _tmp36_ = {0};
				JsonObject* _tmp37_;
				GeeArrayList* _tmp38_;
#line 366 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (!_tmp31_) {
#line 366 "../plugins/backend/feedbin/feedbinAPI.vala"
					i = i + 1;
#line 2810 "feedbinAPI.c"
				}
#line 366 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp31_ = FALSE;
#line 366 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp32_ = array;
#line 366 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (!(((guint) i) < json_array_get_length (_tmp32_))) {
#line 366 "../plugins/backend/feedbin/feedbinAPI.vala"
					break;
#line 2820 "feedbinAPI.c"
				}
#line 368 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp33_ = array;
#line 368 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp34_ = json_array_get_object_element (_tmp33_, (guint) i);
#line 368 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp35_ = _json_object_ref0 (_tmp34_);
#line 368 "../plugins/backend/feedbin/feedbinAPI.vala"
				object = _tmp35_;
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp37_ = object;
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
				feedbin_api_entry_init_from_json (&_tmp36_, _tmp37_, &_inner_error0_);
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
					if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
						g_propagate_error (error, _inner_error0_);
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_object_unref0 (object);
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_array_unref0 (array);
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_object_unref0 (entries);
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
						__vala_JsonNode_free0 (root);
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_free0 (path);
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_free0 (starred);
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
						return NULL;
#line 2854 "feedbinAPI.c"
					} else {
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_object_unref0 (object);
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_array_unref0 (array);
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_object_unref0 (entries);
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
						__vala_JsonNode_free0 (root);
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_free0 (path);
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_free0 (starred);
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
						g_clear_error (&_inner_error0_);
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
						return NULL;
#line 2874 "feedbinAPI.c"
					}
				}
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp38_ = entries;
#line 369 "../plugins/backend/feedbin/feedbinAPI.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp38_, &_tmp36_);
#line 366 "../plugins/backend/feedbin/feedbinAPI.vala"
				feedbin_api_entry_destroy (&_tmp36_);
#line 366 "../plugins/backend/feedbin/feedbinAPI.vala"
				_json_object_unref0 (object);
#line 2885 "feedbinAPI.c"
			}
		}
	}
#line 371 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = (GeeList*) entries;
#line 371 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_array_unref0 (array);
#line 371 "../plugins/backend/feedbin/feedbinAPI.vala"
	__vala_JsonNode_free0 (root);
#line 371 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (path);
#line 371 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (starred);
#line 371 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp39_ = result;
#line 371 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_warn_if_fail (!gee_collection_contains ((GeeCollection*) _tmp39_, NULL), "!result.contains(null)");
#line 371 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 2905 "feedbinAPI.c"
}

static guint
__lambda4_ (FeedbinAPI* self,
            gint64* n)
{
	guint result = 0U;
	GHashFunc _tmp0_;
#line 381 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = g_int64_hash;
#line 381 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp0_ (n);
#line 381 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 2920 "feedbinAPI.c"
}

static guint
___lambda4__gee_hash_data_func (gconstpointer v,
                                gpointer self)
{
	guint result;
	result = __lambda4_ ((FeedbinAPI*) self, (gint64*) v);
#line 380 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 2931 "feedbinAPI.c"
}

static gboolean
__lambda5_ (FeedbinAPI* self,
            gint64* a,
            gint64* b)
{
	gboolean result = FALSE;
	GEqualFunc _tmp0_;
#line 382 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = g_int64_equal;
#line 382 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp0_ (a, b);
#line 382 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 2947 "feedbinAPI.c"
}

static gboolean
___lambda5__gee_equal_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gboolean result;
	result = __lambda5_ ((FeedbinAPI*) self, (gint64*) a, (gint64*) b);
#line 380 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 2959 "feedbinAPI.c"
}

static gint64*
_int64_dup (gint64* self)
{
	gint64* dup;
#line 380 "../plugins/backend/feedbin/feedbinAPI.vala"
	dup = g_new0 (gint64, 1);
#line 380 "../plugins/backend/feedbin/feedbinAPI.vala"
	memcpy (dup, self, sizeof (gint64));
#line 380 "../plugins/backend/feedbin/feedbinAPI.vala"
	return dup;
#line 2972 "feedbinAPI.c"
}

static GeeSet*
feedbin_api_get_x_entries (FeedbinAPI* self,
                           const gchar* path,
                           GError** error)
{
	GeeSet* result = NULL;
	JsonNode* root = NULL;
	JsonNode* _tmp0_;
	JsonArray* array = NULL;
	JsonArray* _tmp1_;
	JsonArray* _tmp2_;
	GeeHashSet* ids = NULL;
	GeeHashSet* _tmp3_;
	GError* _inner_error0_ = NULL;
#line 374 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 374 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 376 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = feedbin_api_get_json (self, path, &_inner_error0_);
#line 376 "../plugins/backend/feedbin/feedbinAPI.vala"
	root = _tmp0_;
#line 376 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 376 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 376 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 376 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 3005 "feedbinAPI.c"
		} else {
#line 376 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 376 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 376 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 3013 "feedbinAPI.c"
		}
	}
#line 377 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = json_node_get_array (root);
#line 377 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _json_array_ref0 (_tmp1_);
#line 377 "../plugins/backend/feedbin/feedbinAPI.vala"
	array = _tmp2_;
#line 380 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = gee_hash_set_new (G_TYPE_INT64, (GBoxedCopyFunc) _int64_dup, (GDestroyNotify) g_free, ___lambda4__gee_hash_data_func, g_object_ref (self), g_object_unref, ___lambda5__gee_equal_data_func, g_object_ref (self), g_object_unref);
#line 380 "../plugins/backend/feedbin/feedbinAPI.vala"
	ids = _tmp3_;
#line 3026 "feedbinAPI.c"
	{
		gint i = 0;
#line 383 "../plugins/backend/feedbin/feedbinAPI.vala"
		i = 0;
#line 3031 "feedbinAPI.c"
		{
			gboolean _tmp4_ = FALSE;
#line 383 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp4_ = TRUE;
#line 383 "../plugins/backend/feedbin/feedbinAPI.vala"
			while (TRUE) {
#line 3038 "feedbinAPI.c"
				JsonArray* _tmp5_;
				GeeHashSet* _tmp6_;
				JsonArray* _tmp7_;
				gint64 _tmp8_;
#line 383 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (!_tmp4_) {
#line 383 "../plugins/backend/feedbin/feedbinAPI.vala"
					i = i + 1;
#line 3047 "feedbinAPI.c"
				}
#line 383 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp4_ = FALSE;
#line 383 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp5_ = array;
#line 383 "../plugins/backend/feedbin/feedbinAPI.vala"
				if (!(((guint) i) < json_array_get_length (_tmp5_))) {
#line 383 "../plugins/backend/feedbin/feedbinAPI.vala"
					break;
#line 3057 "feedbinAPI.c"
				}
#line 385 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp6_ = ids;
#line 385 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp7_ = array;
#line 385 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp8_ = json_array_get_int_element (_tmp7_, (guint) i);
#line 385 "../plugins/backend/feedbin/feedbinAPI.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp6_, &_tmp8_);
#line 3067 "feedbinAPI.c"
			}
		}
	}
#line 387 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = (GeeSet*) ids;
#line 387 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_array_unref0 (array);
#line 387 "../plugins/backend/feedbin/feedbinAPI.vala"
	__vala_JsonNode_free0 (root);
#line 387 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 3079 "feedbinAPI.c"
}

GeeSet*
feedbin_api_get_unread_entries (FeedbinAPI* self,
                                GError** error)
{
	GeeSet* result = NULL;
	GeeSet* _tmp0_ = NULL;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 390 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 392 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = feedbin_api_get_x_entries (self, "unread_entries.json", &_inner_error0_);
#line 392 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = _tmp1_;
#line 392 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 392 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 392 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 392 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 3105 "feedbinAPI.c"
		} else {
#line 392 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 392 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 392 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 3113 "feedbinAPI.c"
		}
	}
#line 392 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp0_;
#line 392 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = NULL;
#line 392 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp2_;
#line 392 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp0_);
#line 392 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 3126 "feedbinAPI.c"
}

GeeSet*
feedbin_api_get_starred_entries (FeedbinAPI* self,
                                 GError** error)
{
	GeeSet* result = NULL;
	GeeSet* _tmp0_ = NULL;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 395 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 397 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = feedbin_api_get_x_entries (self, "starred_entries.json", &_inner_error0_);
#line 397 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = _tmp1_;
#line 397 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 397 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 397 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 397 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 3152 "feedbinAPI.c"
		} else {
#line 397 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 397 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 397 "../plugins/backend/feedbin/feedbinAPI.vala"
			return NULL;
#line 3160 "feedbinAPI.c"
		}
	}
#line 397 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp0_;
#line 397 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = NULL;
#line 397 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp2_;
#line 397 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp0_);
#line 397 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 3173 "feedbinAPI.c"
}

static void
feedbin_api_set_entries_status (FeedbinAPI* self,
                                const gchar* type,
                                GeeCollection* entry_ids,
                                gboolean create,
                                GError** error)
{
	JsonArray* array = NULL;
	JsonArray* _tmp0_;
	JsonObject* object = NULL;
	JsonObject* _tmp7_;
	JsonObject* _tmp8_;
	JsonArray* _tmp9_;
	JsonArray* _tmp10_;
	gchar* _tmp11_ = NULL;
	gchar* path = NULL;
	gchar* _tmp16_;
	JsonObject* _tmp17_;
	SoupMessage* _tmp18_;
	SoupMessage* _tmp19_;
	GError* _inner_error0_ = NULL;
#line 400 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 400 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (type != NULL);
#line 400 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (entry_ids != NULL);
#line 400 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_return_if_fail (!gee_collection_contains (entry_ids, NULL), "!entry_ids.contains(null)");
#line 403 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = json_array_new ();
#line 403 "../plugins/backend/feedbin/feedbinAPI.vala"
	array = _tmp0_;
#line 3209 "feedbinAPI.c"
	{
		GeeIterator* _id_it = NULL;
		GeeIterator* _tmp1_;
#line 404 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp1_ = gee_iterable_iterator ((GeeIterable*) entry_ids);
#line 404 "../plugins/backend/feedbin/feedbinAPI.vala"
		_id_it = _tmp1_;
#line 404 "../plugins/backend/feedbin/feedbinAPI.vala"
		while (TRUE) {
#line 3219 "feedbinAPI.c"
			GeeIterator* _tmp2_;
			gint64* id = NULL;
			GeeIterator* _tmp3_;
			gpointer _tmp4_;
			JsonArray* _tmp5_;
			gint64* _tmp6_;
#line 404 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp2_ = _id_it;
#line 404 "../plugins/backend/feedbin/feedbinAPI.vala"
			if (!gee_iterator_next (_tmp2_)) {
#line 404 "../plugins/backend/feedbin/feedbinAPI.vala"
				break;
#line 3232 "feedbinAPI.c"
			}
#line 404 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp3_ = _id_it;
#line 404 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp4_ = gee_iterator_get (_tmp3_);
#line 404 "../plugins/backend/feedbin/feedbinAPI.vala"
			id = (gint64*) _tmp4_;
#line 406 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp5_ = array;
#line 406 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp6_ = id;
#line 406 "../plugins/backend/feedbin/feedbinAPI.vala"
			json_array_add_int_element (_tmp5_, *_tmp6_);
#line 404 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (id);
#line 3248 "feedbinAPI.c"
		}
#line 404 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_object_unref0 (_id_it);
#line 3252 "feedbinAPI.c"
	}
#line 409 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp7_ = json_object_new ();
#line 409 "../plugins/backend/feedbin/feedbinAPI.vala"
	object = _tmp7_;
#line 410 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp8_ = object;
#line 410 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp9_ = array;
#line 410 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp10_ = _json_array_ref0 (_tmp9_);
#line 410 "../plugins/backend/feedbin/feedbinAPI.vala"
	json_object_set_array_member (_tmp8_, type, _tmp10_);
#line 412 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (create) {
#line 3268 "feedbinAPI.c"
		const gchar* _tmp12_;
		gchar* _tmp13_;
#line 412 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp12_ = string_to_string (type);
#line 412 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp13_ = g_strconcat (_tmp12_, ".json", NULL);
#line 412 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp11_);
#line 412 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp11_ = _tmp13_;
#line 3279 "feedbinAPI.c"
	} else {
		const gchar* _tmp14_;
		gchar* _tmp15_;
#line 412 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp14_ = string_to_string (type);
#line 412 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp15_ = g_strconcat (_tmp14_, "/delete.json", NULL);
#line 412 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (_tmp11_);
#line 412 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp11_ = _tmp15_;
#line 3291 "feedbinAPI.c"
	}
#line 412 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp16_ = g_strdup (_tmp11_);
#line 412 "../plugins/backend/feedbin/feedbinAPI.vala"
	path = _tmp16_;
#line 413 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp17_ = object;
#line 413 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp18_ = feedbin_api_post_json_object (self, path, _tmp17_, &_inner_error0_);
#line 413 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp19_ = _tmp18_;
#line 413 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (_tmp19_);
#line 413 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 413 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 413 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 413 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (path);
#line 413 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (_tmp11_);
#line 413 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_object_unref0 (object);
#line 413 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_array_unref0 (array);
#line 413 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 3321 "feedbinAPI.c"
		} else {
#line 413 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (path);
#line 413 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_free0 (_tmp11_);
#line 413 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_object_unref0 (object);
#line 413 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_array_unref0 (array);
#line 413 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 413 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 413 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 3337 "feedbinAPI.c"
		}
	}
#line 400 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (path);
#line 400 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (_tmp11_);
#line 400 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_object_unref0 (object);
#line 400 "../plugins/backend/feedbin/feedbinAPI.vala"
	_json_array_unref0 (array);
#line 3348 "feedbinAPI.c"
}

void
feedbin_api_set_entries_read (FeedbinAPI* self,
                              GeeCollection* entry_ids,
                              gboolean read,
                              GError** error)
{
	GError* _inner_error0_ = NULL;
#line 416 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 416 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (entry_ids != NULL);
#line 416 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_return_if_fail (!gee_collection_contains (entry_ids, NULL), "!entry_ids.contains(null)");
#line 419 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_set_entries_status (self, "unread_entries", entry_ids, !read, &_inner_error0_);
#line 419 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 419 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 419 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 419 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 3374 "feedbinAPI.c"
		} else {
#line 419 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 419 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 419 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 3382 "feedbinAPI.c"
		}
	}
}

void
feedbin_api_set_entries_starred (FeedbinAPI* self,
                                 GeeCollection* entry_ids,
                                 gboolean starred,
                                 GError** error)
{
	GError* _inner_error0_ = NULL;
#line 422 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 422 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (entry_ids != NULL);
#line 422 "../plugins/backend/feedbin/feedbinAPI.vala"
	_vala_return_if_fail (!gee_collection_contains (entry_ids, NULL), "!entry_ids.contains(null)");
#line 425 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_set_entries_status (self, "starred_entries", entry_ids, starred, &_inner_error0_);
#line 425 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 425 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 425 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 425 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 3410 "feedbinAPI.c"
		} else {
#line 425 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 425 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 425 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 3418 "feedbinAPI.c"
		}
	}
}

GeeMap*
feedbin_api_get_favicons (FeedbinAPI* self,
                          GError** error)
{
	GeeMap* result = NULL;
	GError* _inner_error0_ = NULL;
#line 428 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 3431 "feedbinAPI.c"
	{
		JsonNode* root = NULL;
		JsonNode* _tmp0_;
		JsonNode* _tmp1_;
		JsonArray* array = NULL;
		JsonNode* _tmp3_;
		JsonArray* _tmp4_;
		JsonArray* _tmp5_;
		JsonArray* _tmp6_;
		GeeHashMap* favicons = NULL;
		GeeHashMap* _tmp8_;
#line 434 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp0_ = feedbin_api_get_json (self, "favicons.json", &_inner_error0_);
#line 434 "../plugins/backend/feedbin/feedbinAPI.vala"
		root = _tmp0_;
#line 434 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3449 "feedbinAPI.c"
			goto __catch4_g_error;
		}
#line 435 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp1_ = root;
#line 435 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_tmp1_ == NULL) {
#line 3456 "feedbinAPI.c"
			GeeMap* _tmp2_;
#line 437 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp2_ = gee_map_empty (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_BYTES, (GBoxedCopyFunc) g_bytes_ref, (GDestroyNotify) g_bytes_unref);
#line 437 "../plugins/backend/feedbin/feedbinAPI.vala"
			result = _tmp2_;
#line 437 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 437 "../plugins/backend/feedbin/feedbinAPI.vala"
			return result;
#line 3466 "feedbinAPI.c"
		}
#line 440 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp3_ = root;
#line 440 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp4_ = json_node_get_array (_tmp3_);
#line 440 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp5_ = _json_array_ref0 (_tmp4_);
#line 440 "../plugins/backend/feedbin/feedbinAPI.vala"
		array = _tmp5_;
#line 441 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp6_ = array;
#line 441 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_tmp6_ == NULL) {
#line 3480 "feedbinAPI.c"
			GeeMap* _tmp7_;
#line 443 "../plugins/backend/feedbin/feedbinAPI.vala"
			_tmp7_ = gee_map_empty (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_BYTES, (GBoxedCopyFunc) g_bytes_ref, (GDestroyNotify) g_bytes_unref);
#line 443 "../plugins/backend/feedbin/feedbinAPI.vala"
			result = _tmp7_;
#line 443 "../plugins/backend/feedbin/feedbinAPI.vala"
			_json_array_unref0 (array);
#line 443 "../plugins/backend/feedbin/feedbinAPI.vala"
			__vala_JsonNode_free0 (root);
#line 443 "../plugins/backend/feedbin/feedbinAPI.vala"
			return result;
#line 3492 "feedbinAPI.c"
		}
#line 446 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp8_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_BYTES, (GBoxedCopyFunc) g_bytes_ref, (GDestroyNotify) g_bytes_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 446 "../plugins/backend/feedbin/feedbinAPI.vala"
		favicons = _tmp8_;
#line 3498 "feedbinAPI.c"
		{
			gint i = 0;
#line 447 "../plugins/backend/feedbin/feedbinAPI.vala"
			i = 0;
#line 3503 "feedbinAPI.c"
			{
				gboolean _tmp9_ = FALSE;
#line 447 "../plugins/backend/feedbin/feedbinAPI.vala"
				_tmp9_ = TRUE;
#line 447 "../plugins/backend/feedbin/feedbinAPI.vala"
				while (TRUE) {
#line 3510 "feedbinAPI.c"
					JsonArray* _tmp10_;
					JsonObject* obj = NULL;
					JsonArray* _tmp11_;
					JsonObject* _tmp12_;
					JsonObject* _tmp13_;
					gchar* host = NULL;
					JsonObject* _tmp14_;
					const gchar* _tmp15_;
					gchar* _tmp16_;
					const gchar* _tmp17_;
					gchar* favicon_encoded = NULL;
					JsonObject* _tmp18_;
					const gchar* _tmp19_;
					gchar* _tmp20_;
					const gchar* _tmp21_;
					GBytes* favicon = NULL;
					const gchar* _tmp22_;
					size_t _tmp23_ = 0;
					guchar* _tmp24_;
					GBytes* _tmp25_;
					GeeHashMap* _tmp26_;
					const gchar* _tmp27_;
					GBytes* _tmp28_;
#line 447 "../plugins/backend/feedbin/feedbinAPI.vala"
					if (!_tmp9_) {
#line 447 "../plugins/backend/feedbin/feedbinAPI.vala"
						i = i + 1;
#line 3538 "feedbinAPI.c"
					}
#line 447 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp9_ = FALSE;
#line 447 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp10_ = array;
#line 447 "../plugins/backend/feedbin/feedbinAPI.vala"
					if (!(((guint) i) < json_array_get_length (_tmp10_))) {
#line 447 "../plugins/backend/feedbin/feedbinAPI.vala"
						break;
#line 3548 "feedbinAPI.c"
					}
#line 449 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp11_ = array;
#line 449 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp12_ = json_array_get_object_element (_tmp11_, (guint) i);
#line 449 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp13_ = _json_object_ref0 (_tmp12_);
#line 449 "../plugins/backend/feedbin/feedbinAPI.vala"
					obj = _tmp13_;
#line 450 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp14_ = obj;
#line 450 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp15_ = json_object_get_string_member (_tmp14_, "host");
#line 450 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp16_ = g_strdup (_tmp15_);
#line 450 "../plugins/backend/feedbin/feedbinAPI.vala"
					host = _tmp16_;
#line 451 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp17_ = host;
#line 451 "../plugins/backend/feedbin/feedbinAPI.vala"
					if (_tmp17_ == NULL) {
#line 453 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_free0 (host);
#line 453 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_object_unref0 (obj);
#line 453 "../plugins/backend/feedbin/feedbinAPI.vala"
						continue;
#line 3576 "feedbinAPI.c"
					}
#line 455 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp18_ = obj;
#line 455 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp19_ = json_object_get_string_member (_tmp18_, "favicon");
#line 455 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp20_ = g_strdup (_tmp19_);
#line 455 "../plugins/backend/feedbin/feedbinAPI.vala"
					favicon_encoded = _tmp20_;
#line 456 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp21_ = favicon_encoded;
#line 456 "../plugins/backend/feedbin/feedbinAPI.vala"
					if (_tmp21_ == NULL) {
#line 458 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_free0 (favicon_encoded);
#line 458 "../plugins/backend/feedbin/feedbinAPI.vala"
						_g_free0 (host);
#line 458 "../plugins/backend/feedbin/feedbinAPI.vala"
						_json_object_unref0 (obj);
#line 458 "../plugins/backend/feedbin/feedbinAPI.vala"
						continue;
#line 3598 "feedbinAPI.c"
					}
#line 460 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp22_ = favicon_encoded;
#line 460 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp24_ = g_base64_decode (_tmp22_, &_tmp23_);
#line 460 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp25_ = g_bytes_new_take (_tmp24_, _tmp23_);
#line 460 "../plugins/backend/feedbin/feedbinAPI.vala"
					favicon = _tmp25_;
#line 461 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp26_ = favicons;
#line 461 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp27_ = host;
#line 461 "../plugins/backend/feedbin/feedbinAPI.vala"
					_tmp28_ = favicon;
#line 461 "../plugins/backend/feedbin/feedbinAPI.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp26_, _tmp27_, _tmp28_);
#line 447 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_bytes_unref0 (favicon);
#line 447 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_free0 (favicon_encoded);
#line 447 "../plugins/backend/feedbin/feedbinAPI.vala"
					_g_free0 (host);
#line 447 "../plugins/backend/feedbin/feedbinAPI.vala"
					_json_object_unref0 (obj);
#line 3624 "feedbinAPI.c"
				}
			}
		}
#line 463 "../plugins/backend/feedbin/feedbinAPI.vala"
		result = (GeeMap*) favicons;
#line 463 "../plugins/backend/feedbin/feedbinAPI.vala"
		_json_array_unref0 (array);
#line 463 "../plugins/backend/feedbin/feedbinAPI.vala"
		__vala_JsonNode_free0 (root);
#line 463 "../plugins/backend/feedbin/feedbinAPI.vala"
		return result;
#line 3636 "feedbinAPI.c"
	}
	goto __finally4;
	__catch4_g_error:
	{
		GError* e = NULL;
		GeeMap* _tmp29_;
#line 432 "../plugins/backend/feedbin/feedbinAPI.vala"
		e = _inner_error0_;
#line 432 "../plugins/backend/feedbin/feedbinAPI.vala"
		_inner_error0_ = NULL;
#line 467 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp29_ = gee_map_empty (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_BYTES, (GBoxedCopyFunc) g_bytes_ref, (GDestroyNotify) g_bytes_unref);
#line 467 "../plugins/backend/feedbin/feedbinAPI.vala"
		result = _tmp29_;
#line 467 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_error_free0 (e);
#line 467 "../plugins/backend/feedbin/feedbinAPI.vala"
		return result;
#line 3655 "feedbinAPI.c"
	}
	__finally4:
#line 432 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 432 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_propagate_error (error, _inner_error0_);
#line 432 "../plugins/backend/feedbin/feedbinAPI.vala"
		return NULL;
#line 3664 "feedbinAPI.c"
	} else {
#line 432 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 432 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_clear_error (&_inner_error0_);
#line 432 "../plugins/backend/feedbin/feedbinAPI.vala"
		return NULL;
#line 3672 "feedbinAPI.c"
	}
}

const gchar*
feedbin_api_get_username (FeedbinAPI* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = self->priv->_username;
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp0_;
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 3689 "feedbinAPI.c"
}

void
feedbin_api_set_username (FeedbinAPI* self,
                          const gchar* value)
{
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (g_strcmp0 (value, feedbin_api_get_username (self)) != 0) {
#line 3700 "feedbinAPI.c"
		gchar* _tmp0_;
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp0_ = g_strdup (value);
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (self->priv->_username);
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
		self->priv->_username = _tmp0_;
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_object_notify_by_pspec ((GObject *) self, feedbin_api_properties[FEEDBIN_API_USERNAME_PROPERTY]);
#line 3710 "feedbinAPI.c"
	}
}

const gchar*
feedbin_api_get_password (FeedbinAPI* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = self->priv->_password;
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
	result = _tmp0_;
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
	return result;
#line 3727 "feedbinAPI.c"
}

void
feedbin_api_set_password (FeedbinAPI* self,
                          const gchar* value)
{
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (self != NULL);
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (g_strcmp0 (value, feedbin_api_get_password (self)) != 0) {
#line 3738 "feedbinAPI.c"
		gchar* _tmp0_;
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
		_tmp0_ = g_strdup (value);
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
		_g_free0 (self->priv->_password);
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
		self->priv->_password = _tmp0_;
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_object_notify_by_pspec ((GObject *) self, feedbin_api_properties[FEEDBIN_API_PASSWORD_PROPERTY]);
#line 3748 "feedbinAPI.c"
	}
}

void
feedbin_api_subscription_init_from_json (FeedbinAPISubscription *self,
                                         JsonObject* object,
                                         GError** error)
{
	GDateTime* _tmp0_ = NULL;
	GDateTime* _tmp1_;
	GDateTime* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	GError* _inner_error0_ = NULL;
#line 200 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (object != NULL);
#line 200 "../plugins/backend/feedbin/feedbinAPI.vala"
	memset (self, 0, sizeof (FeedbinAPISubscription));
#line 202 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).id = json_object_get_int_member (object, "id");
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = feedbin_api_get_datetime_member (object, "created_at", &_inner_error0_);
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = _tmp1_;
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 3785 "feedbinAPI.c"
		} else {
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 3793 "feedbinAPI.c"
		}
	}
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = _tmp0_;
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = NULL;
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*self).created_at);
#line 203 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).created_at = _tmp2_;
#line 204 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).feed_id = json_object_get_int_member (object, "feed_id");
#line 205 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = json_object_get_string_member (object, "title");
#line 205 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 205 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).title);
#line 205 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).title = _tmp4_;
#line 206 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = json_object_get_string_member (object, "feed_url");
#line 206 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 206 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).feed_url);
#line 206 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).feed_url = _tmp6_;
#line 207 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp7_ = json_object_get_string_member (object, "site_url");
#line 207 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 207 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).site_url);
#line 207 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).site_url = _tmp8_;
#line 200 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 (_tmp0_);
#line 3832 "feedbinAPI.c"
}

static gpointer
_g_date_time_ref0 (gpointer self)
{
#line 192 "../plugins/backend/feedbin/feedbinAPI.vala"
	return self ? g_date_time_ref (self) : NULL;
#line 3840 "feedbinAPI.c"
}

void
feedbin_api_subscription_copy (const FeedbinAPISubscription* self,
                               FeedbinAPISubscription* dest)
{
	GDateTime* _tmp0_;
	GDateTime* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
#line 192 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).id = (*self).id;
#line 192 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = (*self).created_at;
#line 192 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = _g_date_time_ref0 (_tmp0_);
#line 192 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*dest).created_at);
#line 192 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).created_at = _tmp1_;
#line 192 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).feed_id = (*self).feed_id;
#line 192 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = (*self).title;
#line 192 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 192 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).title);
#line 192 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).title = _tmp3_;
#line 192 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = (*self).feed_url;
#line 192 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 192 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).feed_url);
#line 192 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).feed_url = _tmp5_;
#line 192 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp6_ = (*self).site_url;
#line 192 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 192 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).site_url);
#line 192 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).site_url = _tmp7_;
#line 3891 "feedbinAPI.c"
}

void
feedbin_api_subscription_destroy (FeedbinAPISubscription* self)
{
#line 194 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*self).created_at);
#line 196 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).title);
#line 197 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).feed_url);
#line 198 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).site_url);
#line 3905 "feedbinAPI.c"
}

FeedbinAPISubscription*
feedbin_api_subscription_dup (const FeedbinAPISubscription* self)
{
	FeedbinAPISubscription* dup;
#line 192 "../plugins/backend/feedbin/feedbinAPI.vala"
	dup = g_new0 (FeedbinAPISubscription, 1);
#line 192 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_subscription_copy (self, dup);
#line 192 "../plugins/backend/feedbin/feedbinAPI.vala"
	return dup;
#line 3918 "feedbinAPI.c"
}

void
feedbin_api_subscription_free (FeedbinAPISubscription* self)
{
#line 192 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_subscription_destroy (self);
#line 192 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_free (self);
#line 3928 "feedbinAPI.c"
}

GType
feedbin_api_subscription_get_type (void)
{
	static volatile gsize feedbin_api_subscription_type_id__volatile = 0;
	if (g_once_init_enter (&feedbin_api_subscription_type_id__volatile)) {
		GType feedbin_api_subscription_type_id;
		feedbin_api_subscription_type_id = g_boxed_type_register_static ("FeedbinAPISubscription", (GBoxedCopyFunc) feedbin_api_subscription_dup, (GBoxedFreeFunc) feedbin_api_subscription_free);
		g_once_init_leave (&feedbin_api_subscription_type_id__volatile, feedbin_api_subscription_type_id);
	}
	return feedbin_api_subscription_type_id__volatile;
}

void
feedbin_api_tagging_init_from_json (FeedbinAPITagging *self,
                                    JsonObject* object)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 271 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (object != NULL);
#line 271 "../plugins/backend/feedbin/feedbinAPI.vala"
	memset (self, 0, sizeof (FeedbinAPITagging));
#line 273 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).id = json_object_get_int_member (object, "id");
#line 274 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).feed_id = json_object_get_int_member (object, "feed_id");
#line 275 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = json_object_get_string_member (object, "name");
#line 275 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 275 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).name);
#line 275 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).name = _tmp1_;
#line 3965 "feedbinAPI.c"
}

void
feedbin_api_tagging_copy (const FeedbinAPITagging* self,
                          FeedbinAPITagging* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 265 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).id = (*self).id;
#line 265 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).feed_id = (*self).feed_id;
#line 265 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = (*self).name;
#line 265 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 265 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).name);
#line 265 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).name = _tmp1_;
#line 3986 "feedbinAPI.c"
}

void
feedbin_api_tagging_destroy (FeedbinAPITagging* self)
{
#line 269 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).name);
#line 3994 "feedbinAPI.c"
}

FeedbinAPITagging*
feedbin_api_tagging_dup (const FeedbinAPITagging* self)
{
	FeedbinAPITagging* dup;
#line 265 "../plugins/backend/feedbin/feedbinAPI.vala"
	dup = g_new0 (FeedbinAPITagging, 1);
#line 265 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_tagging_copy (self, dup);
#line 265 "../plugins/backend/feedbin/feedbinAPI.vala"
	return dup;
#line 4007 "feedbinAPI.c"
}

void
feedbin_api_tagging_free (FeedbinAPITagging* self)
{
#line 265 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_tagging_destroy (self);
#line 265 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_free (self);
#line 4017 "feedbinAPI.c"
}

GType
feedbin_api_tagging_get_type (void)
{
	static volatile gsize feedbin_api_tagging_type_id__volatile = 0;
	if (g_once_init_enter (&feedbin_api_tagging_type_id__volatile)) {
		GType feedbin_api_tagging_type_id;
		feedbin_api_tagging_type_id = g_boxed_type_register_static ("FeedbinAPITagging", (GBoxedCopyFunc) feedbin_api_tagging_dup, (GBoxedFreeFunc) feedbin_api_tagging_free);
		g_once_init_leave (&feedbin_api_tagging_type_id__volatile, feedbin_api_tagging_type_id);
	}
	return feedbin_api_tagging_type_id__volatile;
}

void
feedbin_api_entry_init_from_json (FeedbinAPIEntry *self,
                                  JsonObject* object,
                                  GError** error)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	GDateTime* _tmp10_ = NULL;
	GDateTime* _tmp11_;
	GDateTime* _tmp12_;
	GDateTime* _tmp13_ = NULL;
	GDateTime* _tmp14_;
	GDateTime* _tmp15_;
	GError* _inner_error0_ = NULL;
#line 320 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_return_if_fail (object != NULL);
#line 320 "../plugins/backend/feedbin/feedbinAPI.vala"
	memset (self, 0, sizeof (FeedbinAPIEntry));
#line 322 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).id = json_object_get_int_member (object, "id");
#line 323 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).feed_id = json_object_get_int_member (object, "feed_id");
#line 324 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = json_object_get_string_member (object, "title");
#line 324 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 324 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).title);
#line 324 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).title = _tmp1_;
#line 325 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = json_object_get_string_member (object, "url");
#line 325 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 325 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).url);
#line 325 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).url = _tmp3_;
#line 326 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = json_object_get_string_member (object, "author");
#line 326 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 326 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).author);
#line 326 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).author = _tmp5_;
#line 327 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp6_ = json_object_get_string_member (object, "content");
#line 327 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 327 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).content);
#line 327 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).content = _tmp7_;
#line 328 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp8_ = json_object_get_string_member (object, "summary");
#line 328 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 328 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).summary);
#line 328 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).summary = _tmp9_;
#line 329 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp11_ = feedbin_api_get_datetime_member (object, "published", &_inner_error0_);
#line 329 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp10_ = _tmp11_;
#line 329 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 329 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 329 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 329 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 4114 "feedbinAPI.c"
		} else {
#line 329 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 329 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 329 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 4122 "feedbinAPI.c"
		}
	}
#line 329 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp12_ = _tmp10_;
#line 329 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp10_ = NULL;
#line 329 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*self).published);
#line 329 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).published = _tmp12_;
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp14_ = feedbin_api_get_datetime_member (object, "created_at", &_inner_error0_);
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp13_ = _tmp14_;
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
		if (_inner_error0_->domain == FEEDBIN_ERROR) {
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_propagate_error (error, _inner_error0_);
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_date_time_unref0 (_tmp10_);
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 4147 "feedbinAPI.c"
		} else {
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
			_g_date_time_unref0 (_tmp10_);
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
			g_clear_error (&_inner_error0_);
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
			return;
#line 4157 "feedbinAPI.c"
		}
	}
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp15_ = _tmp13_;
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp13_ = NULL;
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*self).created_at);
#line 330 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*self).created_at = _tmp15_;
#line 320 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 (_tmp13_);
#line 320 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 (_tmp10_);
#line 4172 "feedbinAPI.c"
}

void
feedbin_api_entry_copy (const FeedbinAPIEntry* self,
                        FeedbinAPIEntry* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	GDateTime* _tmp10_;
	GDateTime* _tmp11_;
	GDateTime* _tmp12_;
	GDateTime* _tmp13_;
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).id = (*self).id;
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).feed_id = (*self).feed_id;
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = (*self).title;
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).title);
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).title = _tmp1_;
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp2_ = (*self).url;
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).url);
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).url = _tmp3_;
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp4_ = (*self).author;
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).author);
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).author = _tmp5_;
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp6_ = (*self).content;
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp7_ = g_strdup (_tmp6_);
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).content);
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).content = _tmp7_;
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp8_ = (*self).summary;
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*dest).summary);
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).summary = _tmp9_;
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp10_ = (*self).published;
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp11_ = _g_date_time_ref0 (_tmp10_);
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*dest).published);
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).published = _tmp11_;
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp12_ = (*self).created_at;
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp13_ = _g_date_time_ref0 (_tmp12_);
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*dest).created_at);
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	(*dest).created_at = _tmp13_;
#line 4253 "feedbinAPI.c"
}

void
feedbin_api_entry_destroy (FeedbinAPIEntry* self)
{
#line 312 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).title);
#line 313 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).url);
#line 314 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).author);
#line 315 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).content);
#line 316 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 ((*self).summary);
#line 317 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*self).published);
#line 318 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_date_time_unref0 ((*self).created_at);
#line 4273 "feedbinAPI.c"
}

FeedbinAPIEntry*
feedbin_api_entry_dup (const FeedbinAPIEntry* self)
{
	FeedbinAPIEntry* dup;
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	dup = g_new0 (FeedbinAPIEntry, 1);
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_entry_copy (self, dup);
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	return dup;
#line 4286 "feedbinAPI.c"
}

void
feedbin_api_entry_free (FeedbinAPIEntry* self)
{
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_entry_destroy (self);
#line 308 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_free (self);
#line 4296 "feedbinAPI.c"
}

GType
feedbin_api_entry_get_type (void)
{
	static volatile gsize feedbin_api_entry_type_id__volatile = 0;
	if (g_once_init_enter (&feedbin_api_entry_type_id__volatile)) {
		GType feedbin_api_entry_type_id;
		feedbin_api_entry_type_id = g_boxed_type_register_static ("FeedbinAPIEntry", (GBoxedCopyFunc) feedbin_api_entry_dup, (GBoxedFreeFunc) feedbin_api_entry_free);
		g_once_init_leave (&feedbin_api_entry_type_id__volatile, feedbin_api_entry_type_id);
	}
	return feedbin_api_entry_type_id__volatile;
}

static void
feedbin_api_class_init (FeedbinAPIClass * klass,
                        gpointer klass_data)
{
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	feedbin_api_parent_class = g_type_class_peek_parent (klass);
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_type_class_adjust_private_offset (klass, &FeedbinAPI_private_offset);
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_feedbin_api_get_property;
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_feedbin_api_set_property;
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	G_OBJECT_CLASS (klass)->finalize = feedbin_api_finalize;
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FEEDBIN_API_USERNAME_PROPERTY, feedbin_api_properties[FEEDBIN_API_USERNAME_PROPERTY] = g_param_spec_string ("username", "username", "username", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FEEDBIN_API_PASSWORD_PROPERTY, feedbin_api_properties[FEEDBIN_API_PASSWORD_PROPERTY] = g_param_spec_string ("password", "password", "password", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 4329 "feedbinAPI.c"
}

static void
feedbin_api_instance_init (FeedbinAPI * self,
                           gpointer klass)
{
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	self->priv = feedbin_api_get_instance_private (self);
#line 4338 "feedbinAPI.c"
}

static void
feedbin_api_finalize (GObject * obj)
{
	FeedbinAPI * self;
	SoupSession* _tmp0_;
	guint _tmp1_;
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FEEDBIN_API, FeedbinAPI);
#line 51 "../plugins/backend/feedbin/feedbinAPI.vala"
	_tmp0_ = self->priv->m_session;
#line 51 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_signal_parse_name ("authenticate", soup_session_get_type (), &_tmp1_, NULL, FALSE);
#line 51 "../plugins/backend/feedbin/feedbinAPI.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _feedbin_api_authenticate_soup_session_authenticate, self);
#line 29 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_object_unref0 (self->priv->m_session);
#line 30 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (self->priv->m_base_uri);
#line 31 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (self->priv->_username);
#line 32 "../plugins/backend/feedbin/feedbinAPI.vala"
	_g_free0 (self->priv->_password);
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	G_OBJECT_CLASS (feedbin_api_parent_class)->finalize (obj);
#line 4365 "feedbinAPI.c"
}

GType
feedbin_api_get_type (void)
{
	static volatile gsize feedbin_api_type_id__volatile = 0;
	if (g_once_init_enter (&feedbin_api_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FeedbinAPIClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) feedbin_api_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FeedbinAPI), 0, (GInstanceInitFunc) feedbin_api_instance_init, NULL };
		GType feedbin_api_type_id;
		feedbin_api_type_id = g_type_register_static (G_TYPE_OBJECT, "FeedbinAPI", &g_define_type_info, 0);
		FeedbinAPI_private_offset = g_type_add_instance_private (feedbin_api_type_id, sizeof (FeedbinAPIPrivate));
		g_once_init_leave (&feedbin_api_type_id__volatile, feedbin_api_type_id);
	}
	return feedbin_api_type_id__volatile;
}

static void
_vala_feedbin_api_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	FeedbinAPI * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FEEDBIN_API, FeedbinAPI);
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	switch (property_id) {
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		case FEEDBIN_API_USERNAME_PROPERTY:
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_value_set_string (value, feedbin_api_get_username (self));
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		break;
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		case FEEDBIN_API_PASSWORD_PROPERTY:
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		g_value_set_string (value, feedbin_api_get_password (self));
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		break;
#line 4404 "feedbinAPI.c"
		default:
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		break;
#line 4410 "feedbinAPI.c"
	}
}

static void
_vala_feedbin_api_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	FeedbinAPI * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FEEDBIN_API, FeedbinAPI);
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
	switch (property_id) {
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		case FEEDBIN_API_USERNAME_PROPERTY:
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		feedbin_api_set_username (self, g_value_get_string (value));
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		break;
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		case FEEDBIN_API_PASSWORD_PROPERTY:
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		feedbin_api_set_password (self, g_value_get_string (value));
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		break;
#line 4436 "feedbinAPI.c"
		default:
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../plugins/backend/feedbin/feedbinAPI.vala"
		break;
#line 4442 "feedbinAPI.c"
	}
}

